# MatrixFactorizations.jl

[![CI](https://github.com/JuliaLinearAlgebra/MatrixFactorizations.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaLinearAlgebra/MatrixFactorizations.jl/actions/workflows/ci.yml)

[![codecov](https://codecov.io/gh/JuliaLinearAlgebra/MatrixFactorizations.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaLinearAlgebra/MatrixFactorizations.jl)

A Julia package to contain non-standard matrix factorizations. At the moment it
implements the QL, RQ, and UL factorizations, a combined Cholesky factorization with inverse,
and polar decompositions.
In the future it may include other factorizations such
as the LQ factorization.

## QL Factorization

The QL Factorization  is analogous to the QR factorization but with a lower-triangular matrix:
```julia
julia> using MatrixFactorizations

julia> A = randn(5,5);

julia> ql(A)
MatrixFactorizations.QL{Float64,Array{Float64,2}}
Q factor:
5×5 MatrixFactorizations.QLPackedQ{Float64,Array{Float64,2}}:
  0.155574  -0.112555   -0.686362   -0.701064   0.0233276
  0.363037  -0.0583277  -0.0329428   0.152682   0.916736
 -0.670742   0.294355   -0.547867    0.347157   0.206843
 -0.61094   -0.566041    0.324432   -0.353128   0.276396
  0.144425  -0.759527   -0.349868    0.489877  -0.199681
L factor:
5×5 Array{Float64,2}:
 -1.75734     0.0         0.0        0.0       0.0   
 -0.58336    -2.08515     0.0        0.0       0.0   
  0.0213518   0.0722477  -2.01325    0.0       0.0   
  0.930364   -0.46796    -0.322493  -2.9091    0.0   
  1.08725     0.746217    0.549688  -1.10194  -2.0581

julia> b = randn(5); ql(A) \ b ≈ A \ b
true
```

## Jordan canonical form

Every square matrix has a Jordan canonical form. Although Jordan blocks are unstable
with respect to perturbations, the Jordan canonical form of a rational matrix with
rational eigenvalues can be found exactly:
```julia

julia> A = [0 0 1 7 -1; -5 -6 -6 -35 5; 1 1 -7 7 -1; 0 0 0 -9 0; 2 1 -5 -42 -3];

julia> λ = [-9, -7, -7, -1, -1//1];

julia> V, J = jordan(A, λ)
Jordan{Rational{Int64}, Matrix{Rational{Int64}}, Matrix{Rational{Int64}}}
Generalized eigenvectors:
5×5 Matrix{Rational{Int64}}:
 0  0   0  1   0
 0  1   0  0  -1
 0  1  -1  0   0
 1  0   0  0   0
 7  1  -1  1  -1
Jordan normal form:
5×5 Matrix{Rational{Int64}}:
 -9   0   0   0   0
  0  -7   1   0   0
  0   0  -7   0   0
  0   0   0  -1   1
  0   0   0   0  -1

julia> A == V*J/V
true
```

# This file was modified from
# a part of Julia. License is MIT: https://julialang.org/license

##########################
# Reverse Cholesky Factorization #
##########################

"""
    ReverseCholesky <: Factorization

Matrix factorization type of the reverse Cholesky factorization of a dense symmetric/Hermitian
positive definite matrix `A`. This is the return type of [`reversecholesky`](@ref),
the corresponding matrix factorization function.

The triangular reverse Cholesky factor can be obtained from the factorization `F::ReverseCholesky`
via `F.L` and `F.U`, where `A ≈ F.U * F.U' ≈ F.L' * F.L`.
```
"""
struct ReverseCholesky{T,S<:AbstractMatrix} <: Factorization{T}
    factors::S
    uplo::Char
    info::BlasInt

    function ReverseCholesky{T,S}(factors, uplo, info) where {T,S<:AbstractMatrix}
        require_one_based_indexing(factors)
        new(factors, uplo, info)
    end
end
ReverseCholesky(A::AbstractMatrix{T}, uplo::Symbol, info::Integer) where {T} =
    ReverseCholesky{T,typeof(A)}(A, char_uplo(uplo), info)
ReverseCholesky(A::AbstractMatrix{T}, uplo::AbstractChar, info::Integer) where {T} =
    ReverseCholesky{T,typeof(A)}(A, uplo, info)
ReverseCholesky(U::UpperTriangular{T}) where {T} = ReverseCholesky{T,typeof(U.data)}(U.data, 'U', 0)
ReverseCholesky(L::LowerTriangular{T}) where {T} = ReverseCholesky{T,typeof(L.data)}(L.data, 'L', 0)

# iteration for destructuring into components
iterate(C::ReverseCholesky) = (C.U, Val(:U))
iterate(C::ReverseCholesky, ::Val{:U}) = (C.L, Val(:done))
iterate(C::ReverseCholesky, ::Val{:done}) = nothing

## Non BLAS/LAPACK element types (generic)
function reversecholesky_layout!(_, A::AbstractMatrix, ::Type{UpperTriangular})
    require_one_based_indexing(A)
    n = checksquare(A)
    realdiag = eltype(A) <: Complex
    @inbounds begin
        for k = n:-1:1
            cs = colsupport(A, k)
            rs = rowsupport(A, k)
            Akk = realdiag ? real(A[k,k]) : A[k,k]
            for j = (k+1:n) ∩ rs
                Akk -= realdiag ? abs2(A[k,j]) : A[k,j]'A[k,j]
            end
            A[k,k] = Akk
            Akk, info = reversecholesky_layout!(MemoryLayout(Akk), Akk, UpperTriangular)
            if info != 0
                return UpperTriangular(A), info
            end
            A[k,k] = Akk
            for j = (k+1:n) ∩ rs
                Akj = A[k,j]'
                @simd for i = (1:k-1) ∩ cs ∩ colsupport(A,j)
                    A[i,k] -= A[i,j]*Akj
                end
            end
            AkkInv = inv(Akk)
            for i = (1:k-1) ∩ cs
                A[i,k] *= AkkInv'
            end
        end
    end
    return UpperTriangular(A), convert(BlasInt, 0)
end

function reversecholesky_layout!(_, A::AbstractMatrix, ::Type{LowerTriangular})
    require_one_based_indexing(A)
    n = checksquare(A)
    realdiag = eltype(A) <: Complex
    @inbounds begin
        for k = n:-1:1
            cs = colsupport(A, k)
            rs = rowsupport(A, k)
            Akk = realdiag ? real(A[k,k]) : A[k,k]
            for i = (k+1:n) ∩ cs
                Akk -= realdiag ? abs2(A[i,k]) : A[i,k]'A[i,k]
            end
            A[k,k] = Akk
            Akk, info = reversecholesky_layout!(MemoryLayout(Akk), Akk, LowerTriangular)
            if info != 0
                return LowerTriangular(A), info
            end
            A[k,k] = Akk
            AkkInv = inv(copy(Akk'))
            for j = (1:k-1) ∩ rs # colsupport == rowsupport
                for i = (k+1:n) ∩ cs ∩ colsupport(A,j)
                    A[k,j] -= A[i,k]'*A[i,j]
                end
                A[k,j] = AkkInv*A[k,j]
            end
        end
    end
    return UpperTriangular(A), convert(BlasInt, 0)
end

## Numbers
reversecholesky_layout!(_, x::Number, uplo) = LinearAlgebra._chol!(x, uplo)

## for StridedMatrices, check that matrix is symmetric/Hermitian

# cholesky!. Destructive methods for computing Cholesky factorization of real symmetric
# or Hermitian matrix
## No pivoting (default)
function reversecholesky!(A::RealHermSymComplexHerm, ::NoPivot = NoPivot(); check::Bool = true)
    C, info = reversecholesky_layout!(MemoryLayout(A.data), A.data, A.uplo == 'U' ? UpperTriangular : LowerTriangular)
    check && checkpositivedefinite(info)
    return ReverseCholesky(C.data, A.uplo, info)
end

### for AbstractMatrix, check that matrix is symmetric/Hermitian
"""
    reversecholesky!(A::AbstractMatrix, NoPivot(); check = true) -> ReverseCholesky

The same as [`reversecholesky`](@ref), but saves space by overwriting the input `A`,
instead of creating a copy. An [`InexactError`](@ref) exception is thrown if
the factorization produces a number not representable by the element type of
`A`, e.g. for integer types.
```
"""
function reversecholesky!(A::AbstractMatrix, ::NoPivot = NoPivot(); check::Bool = true)
    checksquare(A)
    if !ishermitian(A) # return with info = -1 if not Hermitian
        check && checkpositivedefinite(-1)
        return ReverseCholesky(A, 'U', convert(BlasInt, -1))
    else
        return reversecholesky!(Hermitian(A), NoPivot(); check = check)
    end
end

# can't use chol_copy in 1.12 since it makes BigFloat fill with #undef
reversecholcopy(A::Symmetric, S=choltype(A)) = Symmetric(copy_similar(A, S), LinearAlgebra.sym_uplo(A.uplo))
reversecholcopy(A::Hermitian, S=choltype(A)) = Hermitian(copy_similar(A, S), LinearAlgebra.sym_uplo(A.uplo))
reversecholcopy(A::Diagonal, S=choltype(A)) = Diagonal(copy_similar(diag(A), S))
reversecholcopy(A::RealHermSymComplexHerm{<:Any,<:Diagonal}, S=choltype(A)) = Diagonal(copy_similar(diag(A), S))
reversecholcopy(A, S=choltype(A)) = copy_similar(A, S)
function reversecholcopy(A::SymTridiagonal)
    T = LinearAlgebra.choltype(A)
    Symmetric(Bidiagonal(copymutable_oftype(A.dv, T), copymutable_oftype(A.ev, T), :U))
end

function reversecholcopy(A::Symmetric{<:Any,<:Tridiagonal})
    T = LinearAlgebra.choltype(A)
    if A.uplo == 'U'
        Symmetric(Bidiagonal(copymutable_oftype(parent(A).d, T), copymutable_oftype(parent(A).du, T), :U))
    else
        Symmetric(Bidiagonal(copymutable_oftype(parent(A).d, T), copymutable_oftype(parent(A).dl, T), :L), :L)
    end
end

# Needed to work around O(n^2) copyto! in Base
_copymutable_oftype(B::Bidiagonal, ::Type{T}) where T =
    Bidiagonal(copymutable_oftype(B.dv, T), copymutable_oftype(B.ev, T), B.uplo)

function reversecholcopy(A::Symmetric{<:Any,<:Bidiagonal})
    T = LinearAlgebra.choltype(A)
    B = _copymutable_oftype(parent(A), T)
    Symmetric{T,typeof(B)}(B, A.uplo)
end

# reversecholesky. Non-destructive methods for computing ReverseCholesky factorization of real symmetric
# or Hermitian matrix
## No pivoting (default)
"""
    reversecholesky(A, NoPivot(); check = true) -> ReverseCholesky

Compute the ReverseCholesky factorization of a dense symmetric positive definite matrix `A`
and return a [`ReverseCholesky`](@ref) factorization. The matrix `A` can either be a [`Symmetric`](@ref) or [`Hermitian`](@ref)
[`AbstractMatrix`](@ref) or a *perfectly* symmetric or Hermitian `AbstractMatrix`.

The triangular ReverseCholesky factor can be obtained from the factorization `F` via `F.L` and `F.U`,
where `A ≈ F.U * F.U' ≈ F.L' * F.L`.
"""
reversecholesky(A::AbstractMatrix, piv::NoPivot=NoPivot(); check::Bool = true) =
    reversecholesky_layout(MemoryLayout(A), axes(A), A, piv; check)

reversecholesky_layout(lay, ax, A, piv; kwds...) = reversecholesky!(reversecholcopy(A); kwds...)

function reversecholesky(A::AbstractMatrix{Float16}, ::NoPivot=NoPivot(); check::Bool = true)
    X = reversecholesky!(reversecholcopy(A); check = check)
    return ReverseCholesky{Float16}(X)
end


## Number
function reversecholesky(x::Number, uplo::Symbol=:U)
    C, info = reversecholesky_layout!(MemoryLayout(x), x, uplo)
    xf = fill(C, 1, 1)
    ReverseCholesky(xf, uplo, info)
end

_reverse_chol!(A, T) = reversecholesky_layout!(MemoryLayout(A), A, T)

function ReverseCholesky{T}(C::ReverseCholesky) where T
    Cnew = convert(AbstractMatrix{T}, C.factors)
    ReverseCholesky{T, typeof(Cnew)}(Cnew, C.uplo, C.info)
end
Factorization{T}(C::ReverseCholesky{T}) where {T} = C
Factorization{T}(C::ReverseCholesky) where {T} = ReverseCholesky{T}(C)

AbstractMatrix(C::ReverseCholesky) = C.uplo == 'U' ? C.U*C.U' : C.L'*C.L
AbstractArray(C::ReverseCholesky) = AbstractMatrix(C)
Matrix(C::ReverseCholesky) = Array(AbstractArray(C))
Array(C::ReverseCholesky) = Matrix(C)

copy(C::ReverseCholesky) = ReverseCholesky(copy(C.factors), C.uplo, C.info)


size(C::ReverseCholesky) = size(C.factors)
size(C::ReverseCholesky, d::Integer) = size(C.factors, d)

function getproperty(C::ReverseCholesky, d::Symbol)
    Cfactors = getfield(C, :factors)
    Cuplo    = getfield(C, :uplo)
    if d === :U
        return UpperTriangular(Cuplo === char_uplo(d) ? Cfactors : copy(Cfactors'))
    elseif d === :L
        return LowerTriangular(Cuplo === char_uplo(d) ? Cfactors : copy(Cfactors'))
    elseif d === :UL
        return (Cuplo === 'U' ? UpperTriangular(Cfactors) : LowerTriangular(Cfactors))
    else
        return getfield(C, d)
    end
end
propertynames(F::ReverseCholesky, private::Bool=false) =
    (:U, :L, :UL, (private ? fieldnames(typeof(F)) : ())...)



issuccess(C::ReverseCholesky) = C.info == 0

adjoint(C::ReverseCholesky) = C

function show(io::IO, mime::MIME{Symbol("text/plain")}, C::ReverseCholesky)
    if issuccess(C)
        summary(io, C); println(io)
        println(io, "$(C.uplo) factor:")
        show(io, mime, C.UL)
    else
        print(io, "Failed factorization of type $(typeof(C))")
    end
end

function ldiv!(C::ReverseCholesky, B::AbstractVecOrMat)
    if C.uplo == 'L'
        return ldiv!(LowerTriangular(C.factors), ldiv!(adjoint(LowerTriangular(C.factors)), B))
    else
        return ldiv!(adjoint(UpperTriangular(C.factors)), ldiv!(UpperTriangular(C.factors), B))
    end
end

function rdiv!(B::AbstractMatrix, C::ReverseCholesky)
    if C.uplo == 'L'
        return rdiv!(rdiv!(B, LowerTriangular(C.factors)), adjoint(LowerTriangular(C.factors)))
    else
        return rdiv!(rdiv!(B, adjoint(UpperTriangular(C.factors))), UpperTriangular(C.factors))
    end
end

isposdef(C::ReverseCholesky) = C.info == 0

function det(C::ReverseCholesky)
    dd = one(real(eltype(C)))
    @inbounds for i in 1:size(C.factors,1)
        dd *= real(C.factors[i,i])^2
    end
    return dd
end

function logdet(C::ReverseCholesky)
    dd = zero(real(eltype(C)))
    @inbounds for i in 1:size(C.factors,1)
        dd += log(real(C.factors[i,i]))
    end
    dd + dd # instead of 2.0dd which can change the type
end



logabsdet(C::ReverseCholesky) = logdet(C), one(eltype(C)) # since C is p.s.d.


function getproperty(C::ReverseCholesky{<:Any,<:Diagonal}, d::Symbol)
    Cfactors = getfield(C, :factors)
    if d in (:U, :L, :UL)
        return Cfactors
    else
        return getfield(C, d)
    end
end

function getproperty(C::ReverseCholesky{<:Any, <:Bidiagonal}, d::Symbol)
    Cfactors = getfield(C, :factors)
    Cuplo    = getfield(C, :uplo)
    @assert Cfactors.uplo === Cuplo
    if d === :U && Cuplo === 'U'
        return Cfactors
    elseif d === :L && Cuplo === 'U'
        return Cfactors'
    elseif d === :U && Cuplo === 'L'
            return Cfactors'
    elseif d === :L && Cuplo === 'L'
            return Cfactors
    elseif d === :UL
        return Cfactors
    else
        return getfield(C, d)
    end
end

inv(C::ReverseCholesky{<:Any,<:Diagonal}) = Diagonal(map(inv∘abs2, C.factors.diag))

using LinearAlgebra, MatrixFactorizations, Random, Test

@testset "A = LUL⁻¹" begin
    @testset "A::Matrix{Int}" begin
        V = [2 3 16; 1 -1 5; 0 1 1//1]
        λ = [17//1; -2; 3]
        A = det(V)*V*Diagonal(λ)/V
        @test A == Matrix{Int}(A)
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
    end
    @testset "A::Matrix{Rational{Int}}" begin
        Random.seed!(0)
        V = rand(-3:3//1, 5, 5)
        λ = [-2; -1; 0; 1; 2//1]
        A = V*Diagonal(λ)/V
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
    end
    @testset "Full Jordan blocks" begin
        Random.seed!(0)
        V = rand(-3:3//1, 5, 5)
        λ = [-2; -2; 1; 1; 1//1]
        J = diagm(0=> λ)
        J[1, 2] = 1
        J[3, 4] = 1
        J[4, 5] = 1
        A = V*J/V
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U

    end
    @testset "Alg ≠ geo" begin
        Random.seed!(0)
        V = rand(-3:3//1, 5, 5)
        λ = [-2; -2; 1; 1; 1//1]
        J = diagm(0 => λ)
        J[1, 2] = 1
        J[3, 4] = 1
        A = V*J/V
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
        λ = [1; -2; -2; 1; 1//1]
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
        λ = [1; -2; 1; -2; 1//1]
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
    end
    @testset "Index scan is correct" begin
        Random.seed!(0)
        V = rand(-3:3//1, 8, 8)
        J1 = diagm(0 => 1//1*ones(Int, 4), 1 => rand(0:1, 3))
        J2 = diagm(0 => -1//1*ones(Int, 4), 1 => rand(0:1, 3))
        J = [J1 zeros(Rational{Int}, size(J1)); zeros(Rational{Int}, size(J2)) J2]
        λ = diag(J)
        A = V*J/V
        L, U, p = lulinv(A, λ)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
    end
    @testset "A::Matrix{Float64}" begin
        A = [4.0 3; 6 3]
        L, U, p = lulinv(A)
        @test A[p, p] ≈ L*U/L
        @test A[p, p]*L ≈ L*U
    end
    @testset "size, det, logdet, logabsdet" begin
        A = [4.0 3; 6 3]
        F = lulinv(A)
        @test size(A) == size(F)
        @test size(F, 1) == size(F, 2)
        @test F\A ≈ I
        @test A/F ≈ I
        @test det(A) ≈ det(F)
        @test_throws DomainError logdet(F)
        lad, sd = logabsdet(A)
        lad1, sd1 = logabsdet(F)
        @test lad ≈ lad1
        @test sd ≈ sd1
    end
    @testset "REPL printing" begin
            bf = IOBuffer()
            show(bf, "text/plain", lulinv([1 0; 0 1]))
            seekstart(bf)
            @test String(take!(bf)) ==
"""
LULinv{Float64, Matrix{Float64}, Vector{Int64}}
L factor:
2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0
U factor:
2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0"""
    end
    @testset "propertynames" begin
        names = sort!(collect(string.(Base.propertynames(lulinv([2 1; 1 2])))))
        @test names == ["L", "P", "U", "p"]
        allnames = sort!(collect(string.(Base.propertynames(lulinv([2 1; 1 2]), true))))
        @test allnames == ["L", "P", "U", "factors", "ipiv", "p"]
    end
    @testset "A::Matrix{Int64}, λ::Vector{Rational{Int64}}" begin
        A = [-150 334 778; -89 195 464; 5 -10 -27]
        F = lulinv(A, [17, -2, 3//1])
        @test A[F.p, F.p] * F.L == F.L * F.U
        G = LULinv{Float64}(F)
        @test A[G.p, G.p] * G.L ≈ G.L * G.U
    end
    @testset "A is lower triangular" begin
        Random.seed!(0)
        for A in (tril!(rand(-5:5, 8, 8)), tril!(randn(8, 8)), tril!(randn(Float32, 8, 8)))
            F = lulinv(A)
            @test A[F.p, F.p] * F.L ≈ F.L * F.U
            L, U, P = F.L, F.U, F.P
            @test P'A*P*L ≈ L*U
            @test P'A*P ≈ L*U/L
            @test A ≈ P*L*U/(P*L)
            @test A ≈ P*L*U/L*P'
        end
    end
    @testset "Pivoting is necessary" begin
        A = [1 0; 0 2//1]
        λ = [2; 1//1]
        @test_throws SingularException lulinv(A, λ, Val(false))
        L, U, p = lulinv(A, λ)
        @test p == [2, 1]
        @test A[p, p] == L*U/L
        F = lulinv(A, λ)
        @test F\A ≈ I
        @test A/F ≈ I
    end
end

# This file is based on the PolarFact package by weijianzhang
# License is MIT

export polar, PolarDecomposition

"""
    polar(A; algorithm::Symbol, maxiter, tol, verbose)

Compute the polar decomposition of the matrix `A`.

Returns a [`PolarDecomposition`](@ref).

Arguments:

`algorithm` (default: `:newton`) may be one of:
- ``:newton``: scaled Newton's method
- ``:qdwh``: the QR-based Dynamically weighted Halley (QDWH) method
- ``:halley``: Halley's method
- ``:schulz``: the Newton Schulz method
- ``:hybrid``: a hybrid Newton method
- ``:svd``: the SVD method

`maxiter` defaults to 100; `tol` defaults to `∛eps(t)`; `verbose` defaults to `false`.
"""
function polar end


"""
    PolarDecomposition <: Factorization

Matrix factorization type of the polar decomposition of a matrix ``A``.
This is the return type of [`polar(_)`](@ref), the corresponding matrix factorization function.

Every ``m-by-n`` matrix ``A`` has a polar decomposition

```math
A = U H
```

where the ``m-by-n`` matrix ``U`` has orthonormal columns if ``m>n``
or orthonormal rows if ``m<n`` and the ``n-by-n`` matrix ``H`` is
Hermitian positive semidefinite. For a square matrix ``A``, ``H`` is
unique. If in addition, ``A`` is nonsingular, then ``H`` is positive
definite and ``U`` is unique.

Iterating the decomposition produces the components ``U`` and ``H``.

"""
struct PolarDecomposition{T,M<:AbstractArray{T},Mh<:AbstractArray{T}} <: Factorization{T}
    U::M
    H::Mh
    niters::Integer
    converged::Bool

    function PolarDecomposition{T,M,Mh}(U, H,
                    niter::Integer,
                    converged::Bool) where {T,M<:AbstractArray{T},Mh<:AbstractArray{T}}
        require_one_based_indexing(U, H)
        size(U, 2) == size(H, 1) ||
               throw(DimensionMismatch("Inner dimension of U and H mismatch."))
        new{T,M,Mh}(U, H, niter, converged)
    end
end
function PolarDecomposition{T}(U::AbstractArray{T}, H::AbstractArray{T}, niter=1, converged=true) where {T}
    PolarDecomposition{T,typeof(U),typeof(H)}(U,H,niter,converged)
end

iterate(P::PolarDecomposition) = (P.U, Val(:U))
iterate(P::PolarDecomposition, ::Val{:U}) = (P.H, Val(:done))
iterate(P::PolarDecomposition, ::Val{:done}) = nothing

module Polar
using LinearAlgebra

using ..MatrixFactorizations: PolarDecomposition

using Printf
# common types or functions


# the objective type

struct Objective{T}
    absolute::T  # absolute error
    relative::T  # relative error

    function Objective(absolute::T, relative::T) where {T <: Real}
        absolute >= 0 || error("absolute must be non-negative.")
        relative >= 0 || error("relative must be non-negative.")

        new{T}(absolute, relative)
    end
end


function evaluate_objv(preU::Matrix{T}, U::Matrix{T}) where {T}
    rel = opnorm(preU - U, Inf) / opnorm(preU, Inf)
    abs = opnorm(I - U'*U, Inf)
    return Objective(rel, abs)
end


abstract type PolarUpdater end

abstract type PolarAlg end

# common algorithm skeleton for iterative updating methods

function common_iter!(updater::PolarUpdater,
                         X::Matrix{T},
                         U::Matrix{T},
                         H::Matrix{T},
                         maxiter::Int,
                         verbose::Bool,
                         tol) where {T}

    preU = Array{T}(undef, size(X))
    copyto!(U, X)
    converged = false
    t = 0
    if verbose
        @printf("%-5s    %-13s    %-13s\n", "Iter.", "Rel. err.",  "Obj.")
    end

    while !converged && t < maxiter
        t += 1
        copyto!(preU, U)
        update_U!(updater, U)

        # determine convergence
        diff = norm(preU - U)
        if diff < tol
            converged = true
        end

        # display infomation
        if verbose
            objv = evaluate_objv(preU, U)
            @printf("%5d    %13.6e    %13.6e\n",
                    t, objv.absolute, objv.relative)
        end
    end

    # compute H
    mul!(H, U', X)
    H = (1/T(2)) * (H + H')
    return PolarDecomposition{T}(U, H, t, converged)
end

# Scaling iterative algorithm
function common_iter_scal!(updater::PolarUpdater,
                              X::Matrix{T},
                              U::Matrix{T},
                              H::Matrix{T},
                              maxiter::Int,
                              verbose::Bool,
                              tol) where {T}

    preU = Array{T}(undef, size(X))
    copyto!(U, X)
    converged = false
    t = 0
    if verbose
        @printf("%-5s    %-13s    %-13s\n", "Iter.", "Rel. err.",  "Obj.")
    end

    while !converged && t < maxiter
        t += 1
        copyto!(preU, U)
        update_U!(updater, U)

        # determine convergence
        diff = norm(preU - U)
        if diff < tol
            converged = true
        end

        # determine scaling
        reldiff = diff/norm(U) # relative error
        if updater.scale && (reldiff < updater.scale_tol)
            updater.scale = false
        end

        # display infomation
        if verbose
            objv = evaluate_objv(preU, U)
            @printf("%5d    %13.6e    %13.6e\n",
                    t, objv.absolute, objv.relative)
        end
    end

    # compute H
    mul!(H, U', X)
    H = (1/T(2)) * (H + H')
    return PolarDecomposition{T}(U, H, t, converged)
end



# Hybrid iteration algorithm
function common_iter_hybr!(updater1::PolarUpdater,
                              updater2::PolarUpdater,
                              X::Matrix{T},
                              U::Matrix{T},
                              H::Matrix{T},
                              maxiter::Int,
                              verbose::Bool,
                              tol,
                              theta) where {T} # theta is the switch parameter

    preU = Array{T}(undef, size(X))
    copyto!(U, X)
    converged = false
    switched = false
    t = 0
    if verbose
        @printf("%-5s    %-13s    %-13s\n", "Iter.", "Rel. err.",  "Obj.")
    end

    while !converged && t < maxiter
        t += 1
        copyto!(preU, U)

        if switched
            update_U!(updater2, U)
        else
            obj = opnorm(I - U'*U, 1)
            if obj > theta # theta is the switch parameter
                update_U!(updater1, U)
            else
                switched = true
                update_U!(updater2, U)
            end
        end

        # determine convergence
        diff = norm(preU - U)
        if diff < tol
            converged = true
        end

        # display infomation
        if verbose
            objv = evaluate_objv(preU, U)
            @printf("%5d    %13.6e    %13.6e\n",
                    t, objv.absolute, objv.relative)
        end
    end

    # compute H
    mul!(H, U', X)
    H = (1/T(2)) * (H + H')
    return PolarDecomposition{T}(U, H, t, converged)
end

"""
    Polar.NewtonAlg{T} <: Polar.PolarAlg

Newton's method for polar decomposition

Reference:
Nicholas J. Higham, Computing the Polar Decomposition ---with Applications,
SIAM J. Sci. Statist. Comput. Vol. 7, Num 4 (1986) pp. 1160-1174.
"""
mutable struct NewtonAlg{T,RT<:Real} <: PolarAlg
    maxiter::Int        # maximum number of iterations.
    scale::Bool         # whether to scale Newton iteration.
    verbose::Bool       # whether to show procedural information
    tol::RT        # tolerance for convergence
    scale_tol::RT  # tolerance for acceleration scaling

    function NewtonAlg{T}( ;maxiter::Integer=100,
                       verbose::Bool=false,
                       scale::Bool=true,
                       tol::RT=cbrt(eps(real(T))),
                       scale_tol::Real=eps(real(T))^(1/4)) where {T,RT<:Real}
        maxiter > 1 || error("maxiter must be greater than 1.")
        tol > 0 || error("tol must be positive.")
        scale_tol > 0 || error("scale_tol must be positive.")

        new{T,RT}(maxiter,
            scale,
            verbose,
            tol,
            RT(scale_tol))
    end
end


function solve!(alg::NewtonAlg{T},
                   X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}
    common_iter_scal!(NewtonUpdater(alg.scale, alg.scale_tol), X, U, H, alg.maxiter, alg.verbose, alg.tol)
end

mutable struct NewtonUpdater{T} <: PolarUpdater
    scale::Bool
    scale_tol::T
end

function update_U!(upd::NewtonUpdater, U::Matrix{T}) where {T}
    scale = upd.scale
    Uinv = Array{T}(undef, size(U))
    Uinvt = Array{T}(undef, size(U))
    copyto!(Uinv, inv(U))

    # 1, Inf-norm scaling
    if scale
        g = (opnorm(Uinv,1) * opnorm(Uinv, Inf) / (opnorm(U,1) * opnorm(U, Inf)) )^(1/4)
    else
        g = one(T)
    end
    adjoint!(Uinvt, Uinv)
    copyto!(U, (g * U + Uinvt /g) / convert(T, 2))

end



"""
     Polar.NewtonSchulzAlg{T} <: Polar.PolarAlg

 Newton-Schulz algorithm for polar decomposition

 This method can only apply to matrix ``A`` such that ``norm(A) < sqrt(3)``.

Reference:
[3] Günther Schulz, Iterative Berechnung der reziproken Matrix, Z. Angew.
Math. Mech.,13:57-59, (1933) pp. 114, 181.
"""
mutable struct NewtonSchulzAlg{T,RT} <: PolarAlg
    maxiter::Int     # maximum number of iterations.
    verbose::Bool    # whether to show procedural information
    tol::RT     # convergence tolerance.

    function NewtonSchulzAlg{T}(; maxiter::Integer=100,
                             verbose::Bool=false,
                             tol::RT=cbrt(eps(real(T)))) where {T,RT<:Real}
        maxiter > 1 || error("maxiter must be greater than 1.")
        tol > 0 || error("tol must be positive.")

        new{T,RT}(Int(maxiter),
            verbose,
            tol)
    end
end

function solve!(alg::NewtonSchulzAlg,
                   X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}

    # Newton Schulz converge quadratically if norm(X) < sqrt(3)

    # Revisor's note: this test makes the implementation pointless,
    # since opnorm does an SVD.
    # opnorm(X) < convert(real(T), sqrt(3)) || throw(ArgumentError("The norm of the input matrix must be smaller than sqrt(3)."))

    common_iter!(NewtonSchulzUpdater(), X, U, H, alg.maxiter, alg.verbose, alg.tol)
end

struct NewtonSchulzUpdater <: PolarUpdater end

function update_U!(upd::NewtonSchulzUpdater, U::Matrix{T}) where {T}
    UtU = Array{T}(undef, size(U))
    mul!(UtU, adjoint(U), U)
    copyto!(U, 0.5*U*(3*I - UtU))
end

#
# Compute Polar Decomposition via SVD
#

struct SVDAlg <: PolarAlg end

function solve!(alg::SVDAlg,
                X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}

    F = svd(X, full = false)
    PQt = Array{T}(undef, size(U))
    mul!(PQt, F.U, adjoint(F.V))
    copyto!(U, PQt)
    copyto!(H, F.V * Diagonal(F.S) * F.Vt)
    H = (1/T(2)) * (H + H')

    return PolarDecomposition{T}(U, H, 1, true)
end

"""
    Polar.HalleyAlg{T} <: Polar.PolarAlg

Halley's method for the polar decomposition

Reference:
Y. Nakatsukasa, Z. Bai and F. Gygi, Optimizing Halley's iteration
for computing the matrix polar decomposition, SIAM, J. Mat. Anal.
Vol. 31, Num 5 (2010) pp. 2700-2720

"""
mutable struct HalleyAlg{T,RT} <: PolarAlg
    maxiter::Int
    verbose::Bool
    tol::RT

    function HalleyAlg{T}( ;maxiter::Integer=100,
                       verbose::Bool=false,
                       tol::RT = cbrt(eps(T))) where {T,RT<:Real}
        maxiter > 1 || error("maxiter must be greater than 1.")
        tol > 0 || error("tol must be positive.")

        new{T,RT}(maxiter,
            verbose,
            tol)
    end
end

function solve!(alg::HalleyAlg{T},
                X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}
    common_iter!(HalleyUpdater(), X, U, H, alg.maxiter, alg.verbose, alg.tol)
end

struct HalleyUpdater <: PolarUpdater end


function update_U!(upd::HalleyUpdater, U::Matrix{T}) where {T}
    UtU = Array{T}(undef, size(U))
    mul!(UtU, adjoint(U), U)
    copyto!(U, U * (3*I + UtU)* inv(I + 3*UtU))
end

"""
    Polar.QDWHAlg{T} <: Polar.PolarAlg

QR-based Dynamically Weighted Halley (QDWH) algorithm for polar decomposition

Reference: Optimizing Halley's iteration for computing the matrix
           polar decomposition, Yuji Nakatsukasa, Zhaojun Bai and
           Francois Gygi, SIAM, J. Mat. Anal. Vol. 31, Num 5 (2010)
           pp. 2700-2720

Limitations: 1. the QDWH method should support `m > n` matrix itself in the future.
             2. the computing of `alpha` and `L` in `solve!` can be improved by using
                norm and condition number estimate, which were
                not available in Julia when written.
"""
mutable struct QDWHAlg{T,RT} <: PolarAlg
    maxiter::Int
    verbose::Bool
    piv::Bool       # whether to pivot
    tol::RT

    function QDWHAlg{T}( ;maxiter::Integer=100,
                     verbose::Bool=false,
                     piv::Bool=true,
                     tol::RT=cbrt(eps(T))) where {T,RT<:Real}
        maxiter > 1 || error("maxiter must be greater than 1.")
        tol > 0 || error("tol must be positive.")

        new{T,RT}(maxiter,
            verbose,
            piv,
            tol)
    end
end


function solve!(alg::QDWHAlg,
                X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}
    # alpha is an estimate of the largest singular value of the
    # original matrix
    X_temp = Array{T}(undef, size(X))
    copyto!(X_temp, X)

    n = size(X_temp, 1)
    alpha = norm(X_temp)
    for i in length(X_temp)
        X_temp[i] /= alpha # form X0
    end

    # L is a lower bound for the smallest singular value of X0
    smin_est = opnorm(X_temp, 1)/cond(X_temp, 1)
    L  = smin_est/convert(T, sqrt(n))

    common_iter!(QDWHUpdater(alg.piv, L), X, U, H, alg.maxiter, alg.verbose, alg.tol)
end

mutable struct QDWHUpdater{T} <: PolarUpdater
    piv::Bool   # whether to pivot QR factorization
    L::T  # a lower bound for the smallest singluar value of each update matrix U
end

function update_U!(upd::QDWHUpdater, U::Matrix{T}) where {T}
    piv = upd.piv
    L = upd.L
    m, n = size(U)
    B = Array{T}(undef, m+n, n)
    Q1 = Array{T}(undef, n, n)
    Q2 = Array{T}(undef, n, n)
    # Compute paramters L, a, b, c
    L2 = L^2
    dd = try
        (4 * (1 - L2)/L2^2)^(1/3)
        catch
        (complex(4 * (1 -L2)/L2^2, 0))^(1/3)
    end
    sqd = sqrt(1+dd)
    a = sqd + 0.5 * sqrt(8 - 4 * dd + 8 * (2 - L2)/(L2 * sqd))
    a = real(a)
    b = (a - 1)^2 / 4
    c = a + b - 1

    # update L
    upd.L = L * (a + b * L2)/(1 + c * L2)

    copyto!(B, [sqrt(c)*U; Matrix(one(T)*I,n,n)])
    if piv
        F = qr(B, ColumnNorm())
    else
        F = qr(B)
    end
    copyto!(Q1, Matrix(F.Q)[1:m, :])
    copyto!(Q2, Matrix(F.Q)[m+1:end, :])
    copyto!(U, b / c * U + (a - b / c) / sqrt(c) * Q1 * Q2')

end

"""
    Polar.NewtonHybridAlg{T} <: Polar.PolarAlg

Hybrid Newton and Newton-Schulz algorithm for polar decomposition

Reference:
Nicholas J. Higham and Robert S. Schreiber, Fast Polar Decomposition
of an arbitrary matrix, SIAM, J. Sci. Statist. Comput. Vol. 11, No. 4
(1990) pp. 648-655.
"""
mutable struct NewtonHybridAlg{T,RT<:Real} <: PolarAlg
    maxiter::Int    # maximum number of iterations.
    verbose::Bool   # whether to show procedural information.
    tol::RT    # convergence tolerance
    theta::RT  # switch parameter

    function NewtonHybridAlg{T}( ; maxiter::Integer=100,
                             verbose::Bool=false,
                             tol::RT=cbrt(eps(real(T))),
                             theta::RT=convert(real(T), 0.6)) where {T,RT<:Real}
        maxiter > 1 || error("maxiter must  be greater than 1.")
        tol > 0 || error("tol must be positive.")
        theta > 0 || error("theta must be positive.")

        new{T,RT}(maxiter,
            verbose,
            tol,
            theta)
    end
end

function solve!(alg::NewtonHybridAlg,
                X::Matrix{T}, U::Matrix{T}, H::Matrix{T}) where {T}
    common_iter_hybr!(NewtonUpdater(true, eps(real(T))^(1/4)), NewtonSchulzUpdater(), X, U, H,
                      alg.maxiter, alg.verbose, alg.tol, alg.theta)
end

isiterative(alg::PolarAlg) = true
isiterative(alg::SVDAlg) = false

end # submodule Polar


function polar(A::AbstractMatrix{T};
                   alg::Symbol=:newton,
                   maxiter::Integer=100,
                   tol::Real = cbrt(eps(real(T))),
                   verbose::Bool=false) where {T}

    # choose algorithm
    algorithm =
       alg == :newton ? Polar.NewtonAlg{T}(; maxiter=maxiter, tol=tol, verbose=verbose) :
       alg == :qdwh ?  Polar.QDWHAlg{T}(; maxiter=maxiter, tol=tol, verbose=verbose) :
       alg == :halley ? Polar.HalleyAlg{T}(; maxiter=maxiter, tol=tol, verbose=verbose) :
       alg == :svd ? Polar.SVDAlg() :
       alg == :schulz ? Polar.NewtonSchulzAlg{T}(; maxiter=maxiter, tol=tol, verbose=verbose) :
       alg == :hybrid ? Polar.NewtonHybridAlg{T}(; maxiter=maxiter, tol=tol, verbose=verbose) :
       error("Invalid algorithm.")
    polar(A, algorithm)
end

"""
    polar(::AbstractMatrix, ::Polar.PolarAlg)
"""
function polar(A::AbstractMatrix{T}, algorithm::Polar.PolarAlg) where {T}
    # Initialization: if m > n, do QR factorization
    m, n = size(A)
    mm = m
    if m > n
        if Polar.isiterative(algorithm)
            m = n
            F = qr(A)
            A = F.R
        end
    elseif m < n
        throw(ArgumentError("The row dimension of the input matrix must be
              greater or equal to column dimension."))
    end
    U = Array{T}(undef, m, n)
    H = Array{T}(undef, n, n)
    # solve for polar factors
    r = Polar.solve!(algorithm, A, U, H)
    if mm > m
        return PolarDecomposition{T}(F.Q * r.U, r.H, r.niters, r.converged)
    end
    return r
end

module MatrixFactorizations
using Base, LinearAlgebra, ArrayLayouts
import Base: axes, axes1, getproperty, propertynames, iterate, tail, oneto
import LinearAlgebra: BlasInt, BlasReal, BlasFloat, BlasComplex, axpy!,
   copy_oftype, checksquare, adjoint, transpose, AdjOrTrans, HermOrSym,
   det, logdet, logabsdet, isposdef
import LinearAlgebra.LAPACK: chkuplo, chktrans
import LinearAlgebra: cholesky, cholesky!, norm, diag, eigvals!, eigvals, eigen!, eigen,
   qr, axpy!, ldiv!, rdiv!, mul!, lu, lu!, ldlt, ldlt!, AbstractTriangular, inv,
   chkstride1, kron, lmul!, rmul!, factorize, StructuredMatrixStyle, det, logabsdet,
   AbstractQ, _zeros, _cut_B, _ret_size, require_one_based_indexing,
   checknonsingular, ipiv2perm, copytri!, issuccess, RealHermSymComplexHerm,
   cholcopy, checkpositivedefinite, char_uplo, copymutable_oftype, copy_similar, choltype


using LinearAlgebra: TransposeFactorization, AdjointFactorization

import Base: getindex, setindex!, *, +, -, ==, <, <=, >,
   >=, /, ^, \, transpose, showerror, reindex, checkbounds, @propagate_inbounds

import Base: convert, size, view, unsafe_indices,
   first, last, size, length, unsafe_length, step,
   to_indices, to_index, show, fill!, promote_op,
   MultiplicativeInverses, OneTo, ReshapedArray,
   Array, Matrix, Vector, AbstractArray, AbstractMatrix, AbstractVector,
   similar, copy, convert, promote_rule, rand,
   IndexStyle, real, imag, Slice, pointer, unsafe_convert, copyto!

import ArrayLayouts: reflector!, reflectorApply!, materialize!, @_layoutlmul, @_layoutrmul,
   MemoryLayout, adjointlayout, AbstractQLayout, QRPackedQLayout,
   QRCompactWYQLayout, AdjQRCompactWYQLayout, QRPackedLayout, AdjQRPackedQLayout,
   layout_getindex, rowsupport, colsupport


export ul, ul!, ql, ql!, qrunblocked, qrunblocked!, UL, QL,
    reversecholesky, reversecholesky!, ReverseCholesky,
    lulinv, lulinv!, LULinv, jordan, Jordan

const AdjointQtype = isdefined(LinearAlgebra, :AdjointQ) ? LinearAlgebra.AdjointQ : Adjoint
const AbstractQtype = AbstractQ <: AbstractMatrix ? AbstractMatrix : AbstractQ

const AdjointFact = isdefined(LinearAlgebra, :AdjointFactorization) ? LinearAlgebra.AdjointFactorization : Adjoint
const TransposeFact = isdefined(LinearAlgebra, :TransposeFactorization) ? LinearAlgebra.TransposeFactorization : Transpose

# The abstract type LayoutQ implicitly assumes that any subtype admits a field
# named factors. Based on this field, `size`, `axes` and context-dependent
# multiplication work. The same used to be the case before v1.9 with the even
# more generic LinearAlgebra.AbstractQ. Moreover, it is assumed that LayoutQ
# objects are flexible in size when multiplied from the left, or its adjoint
# from the right.
abstract type LayoutQ{T} <: AbstractQ{T} end


@_layoutlmul LayoutQ
@_layoutlmul AdjointQtype{<:Any,<:LayoutQ}
@_layoutrmul LayoutQ
@_layoutrmul AdjointQtype{<:Any,<:LayoutQ}

LinearAlgebra.copymutable(Q::LayoutQ) = copymutable_size(size(Q), Q)
copymutable_size(sz, Q) = lmul!(Q, Matrix{eltype(Q)}(I, sz))

(*)(Q::LayoutQ, b::AbstractVector) = _mul(Q, b)
(*)(Q::LayoutQ, b::LayoutVector) = ArrayLayouts.mul(Q, b) # disambiguation w/ ArrayLayouts.jl
function _mul(Q::LayoutQ, b::AbstractVector)
   T = promote_type(eltype(Q), eltype(b))
   if size(Q.factors, 1) == length(b)
       bnew = copyto!(similar(b, T, size(b)), b)
   elseif size(Q.factors, 2) == length(b)
       bnew = [b; zeros(T, size(Q.factors, 1) - length(b))]
   else
       throw(DimensionMismatch("vector must have length either $(size(Q.factors, 1)) or $(size(Q.factors, 2))"))
   end
   lmul!(convert(AbstractQtype{T}, Q), bnew)
end
(*)(Q::LayoutQ, B::AbstractMatrix) = _mul(Q, B)
(*)(Q::LayoutQ, B::LayoutQ) = ArrayLayouts.mul(Q, B)
(*)(Q::LayoutQ, B::LayoutMatrix) = ArrayLayouts.mul(Q, B) # disambiguation w/ ArrayLayouts.jl
function _mul(Q::LayoutQ, B::AbstractMatrix)
   T = promote_type(eltype(Q), eltype(B))
   if size(Q.factors, 1) == size(B, 1)
       Bnew = copyto!(similar(B, T, size(B)), B)
   elseif size(Q.factors, 2) == size(B, 1)
       Bnew = [B; zeros(T, size(Q.factors, 1) - size(B,1), size(B, 2))]
   else
       throw(DimensionMismatch("first dimension of matrix must have size either $(size(Q.factors, 1)) or $(size(Q.factors, 2))"))
   end
   lmul!(convert(AbstractQtype{T}, Q), Bnew)
end
(*)(A::AbstractMatrix, adjQ::AdjointQtype{<:Any,<:LayoutQ}) = _mul(A, adjQ)
function _mul(A::AbstractMatrix, adjQ::AdjointQtype{<:Any,<:LayoutQ})
    Q = parent(adjQ)
    T = promote_type(eltype(A), eltype(adjQ))
    adjQQ = convert(AbstractQtype{T}, adjQ)
    if size(A,2) == size(Q.factors, 1)
        AA = copyto!(similar(A, T, size(A)), A)
        return rmul!(AA, adjQQ)
    elseif size(A,2) == size(Q.factors,2)
        return rmul!([A zeros(T, size(A, 1), size(Q.factors, 1) - size(Q.factors, 2))], adjQQ)
    else
        throw(DimensionMismatch("matrix A has dimensions $(size(A)) but Q-matrix B has dimensions $(size(adjQ))"))
    end
end
(*)(u::LinearAlgebra.AdjointAbsVec, Q::AdjointQtype{<:Any,<:LayoutQ}) = (Q'u')'

*(A::LayoutQ, B::AbstractTriangular) = mul(A, B)
*(A::AdjointQtype{<:Any,<:LayoutQ}, B::AbstractTriangular) = mul(A, B)
*(A::AbstractTriangular, B::LayoutQ) = mul(A, B)
*(A::AbstractTriangular, B::AdjointQtype{<:Any,<:LayoutQ}) = mul(A, B)

axes(Q::LayoutQ, dim::Integer) = axes(getfield(Q, :factors), dim == 2 ? 1 : dim)
axes(Q::LayoutQ) = axes(Q, 1), axes(Q, 2)
copy(Q::LayoutQ) = Q
Base.@propagate_inbounds getindex(A::LayoutQ, I...) = layout_getindex(A, I...)
# by default, fall back to AbstractQ  methods
layout_getindex(A::LayoutQ, I...) =
    Base.invoke(Base.getindex, Tuple{AbstractQ, typeof.(I)...}, A, I...)

size(Q::LayoutQ, dim::Integer) = size(getfield(Q, :factors), dim == 2 ? 1 : dim)
size(Q::LayoutQ) = size(Q, 1), size(Q, 2)

include("ul.jl")
include("qr.jl")
include("ql.jl")
include("rq.jl")
include("polar.jl")
include("reversecholesky.jl")
include("lulinv.jl")
include("jordan.jl")

end #module

# choleskyinv.jl
# Cholesky factor and its inverse (complex-conjugate) transposed in one pass.
# For small matrices this is faster than computing the Cholesky factor
# using the `cholesky` function in LinearAlgebra and then invert it.


"""
Cholesky factorization and inverse Cholesky factorization, accessible
in fields `.c` ans `.ci`, respectively.
"""
struct CholeskyInv{T, F<:Factorization{T}} <: Factorization{T}
     c::F
     ci::F
end

"""
    choleskyinv(P::AbstractMatrix{T};
		check::Bool=true, tol::Real = √eps(T)) where T<:Union{Real, Complex}

 Compute the Cholesky factorization of a dense positive definite
 matrix P and return a `Choleskyinv` object, holding in field `.c`
 the Cholesky factorization and in field `ci` the inverse of the Cholesky
 factorization.

 The two factorizations are obtained in one pass and this is faster
 then calling Julia's [cholesky](https://docs.julialang.org/en/v1/stdlib/LinearAlgebra/#LinearAlgebra.cholesky)
 function and inverting the lower factor for small matrices.

 Input matrix `P` may be of type `Matrix` or `Hermitian`. Since only the
 lower triangle is used, `P` may also be a `LowerTriangular` view of a
 positive definite matrix.
 If `P` is real, it can also be of the `Symmetric` type.

 The algorithm is a *multiplicative Gaussian elimination*.

 **Notes:**
 The inverse Cholesky factor ``L^{-1}``, obtained as `.ci.L`,
 is an inverse square root (whitening matrix) of `P`, since
 ``L^{-1}PL^{-H}=I``. It therefore yields the inversion of ``P`` as
 ``P^{-1}=L^{-H}L^{-1}``. This is the fastest whitening matrix to be computed,
 however it yields poor numerical precision, especially for large matrices.

 The following relations holds:
 - ``L=PL^{-H}``,
 - ``L^{H}=L^{-1}P``,
 - ``L^{-H}=P^{-1}L``
 - ``L^{-1}=L^{H}P^{-1}``.

 We also have ``L^{H}L=L^{-1}P^{2}L^{-H}=UPU^H``, with ``U`` orthogonal
 (see below) and ``L^{-1}L^{-H}=L^{H}P^{-2}L=UP^{-1}U^H``.
 ``LL^{H}`` and ``L^{H}L`` are unitarily similar, that is,

 ``ULL^{H}U^H=L^{H}L``,

 where ``U=L^{-1}P^{1/2}``, with ``P^{1/2}=H`` the *principal* (unique symmetric)
 square root of ``P``. This is seen writing
 ``PP^{-1}=HHL^{-H}L^{-1}``; multiplying both sides on the left by ``L^{-1}``
 and on the right by ``L`` we obtain
 ``L^{-1}PP^{-1}L=L^{-1}HHL^{-H}=I=(L^{-1}H)(L^{-1}H)^H`` and since
 ``L^{-1}H`` is square it must be unitary.

 From these expressions we have
 - ``H=LU=U^HL^H,
 - ``L=HU^H``,
 - ``H^{-1}=U^HL^{-1}``
 - ``L^{-1}=UH^{-1}``.

 ``U`` is the *polar factor* of ``L^{H}``, *i.e.*, ``L^{H}=UH``,
 since ``LL^{H}=HU^HUH^H=H^2=P``.
 From ``L^{H}L=UCU^H`` we have ``L^{H}LU=UC=ULL^{H}`` and from
 ``U=L^{-1}H`` we have ``L=HU^H``.

 ## Examples
	using PosDefManifold, Test
	n = 40
	etol = 1e-9
	Y=randP(n)
	Yi=inv(Y)
	a=cholesky(Y)

	C=choleskyinv!(copy(Matrix(Y)))
	@test(norm(C.c.L*C.c.U-Y)/√n < etol)
	@test(norm(C.ci.U*C.ci.L-Yi)/√n < etol)

	# repeat the test for complex matrices
	Y=randP(ComplexF64, n)
	Yi=inv(Y)
	C=choleskyinv!(copy(Matrix(Y)))
	@test(norm(C.c.L*C.c.U-Y)/√n < etol)
	@test(norm(C.ci.U*C.ci.L-Yi)/√n < etol)

	# Benchmark
	using BenchmarkTools

	# computing the Cholesky factor and its inverse using LinearAlgebra
	function linearAlgebraWay(P)
		C=cholesky(P)
		Q=inv(C.L)
	end

	Y=randP(n)
	@benchmark(choleskyinv(Y))
	@benchmark(linearAlgebraWay(Y))

"""
choleskyinv(P::Union{Hermitian, Symmetric, Matrix, LowerTriangular};
	   		check::Bool = true,
	   		tol::Real = √eps(real(eltype(P)))) =
    choleskyinv!(copy(Matrix(P)); check=check, tol=tol)

"""
    choleskyinv!(P::AbstractMatrix{T};
		kind::Symbol = :LLt, tol::Real = √eps(T)) where T<:RealOrComplex
 The same thing as [`choleskyinv`](@ref), but destroys the input matrix.
"""
function choleskyinv!(P::Matrix{T};
			check::Bool = true,
			tol::Real = √eps(real(T))) where T<:Union{Real, Complex}
	LinearAlgebra.require_one_based_indexing(P)
	n = LinearAlgebra.checksquare(P)

	@inbounds for j=1:n-1
		check && abs2(P[j, j])<tol && throw(LinearAlgebra.PosDefException(1))
		for i=j+1:n
			θ = conj(P[i, j] / -P[j, j])
			for k=i:n P[k, i] += θ * P[k, j] end # update P and write D
			P[i, j] = conj(-θ) # write Cholesky factor
			for k=1:j-1 P[k, i] += θ * P[k, j] end # write inv Cholesky factor
			P[j, i] = θ # write inv Cholesky factor
		end
	end

	LT, ULT, UUT = LowerTriangular, UnitLowerTriangular, UnitUpperTriangular
	D=sqrt.(Diagonal(P))
	return CholeskyInv(Cholesky(LT(ULT(P)*D), :L, 0), Cholesky(LT(Matrix((UUT(P)*inv(D))')) , :L, 0 ))
end


function show(io::IO, ::MIME{Symbol("text/plain")}, C::CholeskyInv)
    println(io, "Cholesky (.c) and inverse Cholesky (.ci) factorizations")
	#show(io, C.c)
	#show(io, C.ci)
end

# This file is based on LinearAlgebra/test/lu.jl, a part of Julia. License is MIT: https://julialang.org/license

using Test, LinearAlgebra, Random, MatrixFactorizations
using LinearAlgebra: ldiv!, BlasReal, BlasInt, BlasFloat, rdiv!

@testset "UL" begin
    n = 10

    # Split n into 2 parts for tests needing two matrices
    n1 = div(n, 2)
    n2 = 2*n1

    Random.seed!(1234321)

    areal = randn(n,n)/2
    aimg  = randn(n,n)/2
    bimg  = randn(n,2)/2
    breal = randn(n,2)/2
    creal = randn(n)/2
    cimg  = randn(n)/2
    dureal = randn(n-1)/2
    duimg  = randn(n-1)/2
    dlreal = randn(n-1)/2
    dlimg  = randn(n-1)/2
    dreal = randn(n)/2
    dimg  = randn(n)/2

    @testset "UL simple test" begin
        A = randn(n,n)
        U,L = ul(A,Val(false))
        @test U*L ≈ A
        U,L,p = ul(A)
        @test (U*L) ≈ A[p,:]
        P = ul(A).P
        @test P'*U*L ≈ A
        L,U,p = lu(A)
        @test (L*U) ≈ A[p,:] # for context
        P = lu(A).P
        @test P'*L*U ≈ A
    end

    @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64, BigFloat, Int)
        a = eltya == Int ? rand(1:7, n, n) :
            convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
        d = if eltya == Int
            Tridiagonal(rand(1:7, n-1), rand(1:7, n), rand(1:7, n-1))
        elseif eltya <: Complex
            convert(Tridiagonal{eltya}, Tridiagonal(
                complex.(dlreal, dlimg), complex.(dreal, dimg), complex.(dureal, duimg)))
        else
            convert(Tridiagonal{eltya}, Tridiagonal(dlreal, dreal, dureal))
        end
        ε = εa = eps(abs(float(one(eltya))))

        if eltya <: BlasFloat
            @testset "UL factorization for Number" begin
                num = rand(eltya)
                @test (ul(num)...,) == (hcat(one(eltya)), hcat(num), [1])
                @test convert(Array, ul(num)) ≈ eltya[num]
            end
        end
        κ  = cond(a,1)
        κd    = cond(Array(d),1)
        # @testset "Tridiagonal UL" begin
        #     lud   = ul(d)
        #     @test LinearAlgebra.issuccess(lud)
        #     @test ul(lud) == lud
        #     @test_throws ErrorException lud.Z
        #     @test lud.L*lud.U ≈ lud.P*Array(d)
        #     @test lud.L*lud.U ≈ Array(d)[lud.p,:]
        #     @test AbstractArray(lud) ≈ d
        #     @test Array(lud) ≈ d
        #     if eltya != Int
        #         dlu = convert.(eltya, [1, 1])
        #         dia = convert.(eltya, [-2, -2, -2])
        #         tri = Tridiagonal(dlu, dia, dlu)
        #         @test_throws ArgumentError ul!(tri)
        #     end
        # end
        @testset for eltyb in (Float32, Float64, ComplexF32, ComplexF64, Int)
            b  = eltyb == Int ? rand(1:5, n, 2) :
                convert(Matrix{eltyb}, eltyb <: Complex ? complex.(breal, bimg) : breal)
            c  = eltyb == Int ? rand(1:5, n) :
                convert(Vector{eltyb}, eltyb <: Complex ? complex.(creal, cimg) : creal)
            εb = eps(abs(float(one(eltyb))))
            ε  = max(εa,εb)
            @testset "(Automatic) Square UL decomposition" begin
                lua   = factorize(a)
                let Bs = copy(b), Cs = copy(c)
                    for (bb, cc) in ((Bs, Cs), (view(Bs, 1:n, 1), view(Cs, 1:n)))
                        @test norm(a*(lua\bb) - bb, 1) < ε*κ*n*2 # Two because the right hand side has two columns
                        @test norm(a'*(lua'\bb) - bb, 1) < ε*κ*n*2 # Two because the right hand side has two columns
                        @test norm(a'*(lua'\a') - a', 1) < ε*κ*n^2
                        @test norm(a*(lua\cc) - cc, 1) < ε*κ*n # cc is a vector
                        @test norm(a'*(lua'\cc) - cc, 1) < ε*κ*n # cc is a vector
                        @test AbstractArray(lua) ≈ a
                        @test norm(transpose(a)*(transpose(lua)\bb) - bb,1) < ε*κ*n*2 # Two because the right hand side has two columns
                        @test norm(transpose(a)*(transpose(lua)\cc) - cc,1) < ε*κ*n
                    end

                    # Test whether Ax_ldiv_B!(y, UL, x) indeed overwrites y
                    resultT = typeof(oneunit(eltyb) / oneunit(eltya))

                    b_dest = similar(b, resultT)
                    c_dest = similar(c, resultT)

                    ldiv!(b_dest, lua, b)
                    ldiv!(c_dest, lua, c)
                    @test norm(b_dest - lua \ b, 1) < ε*κ*2n
                    @test norm(c_dest - lua \ c, 1) < ε*κ*n

                    ldiv!(b_dest, transpose(lua), b)
                    ldiv!(c_dest, transpose(lua), c)
                    @test norm(b_dest - transpose(lua) \ b, 1) < ε*κ*2n
                    @test norm(c_dest - transpose(lua) \ c, 1) < ε*κ*n

                    ldiv!(b_dest, adjoint(lua), b)
                    ldiv!(c_dest, adjoint(lua), c)
                    @test norm(b_dest - lua' \ b, 1) < ε*κ*2n
                    @test norm(c_dest - lua' \ c, 1) < ε*κ*n

                    if eltyb != Int && !(eltya <: Complex) || eltya <: Complex && eltyb <: Complex
                        p = Matrix(b')
                        q = Matrix(c')
                        p_dest = copy(p)
                        q_dest = copy(q)
                        rdiv!(p_dest, lua)
                        rdiv!(q_dest, lua)
                        @test norm(p_dest - p / lua, 1) < ε*κ*2n
                        @test norm(q_dest - q / lua, 1) < ε*κ*n
                    end
                end
                if eltya <: BlasFloat && eltyb <: BlasFloat
                    e = rand(eltyb,n,n)
                    @test norm(e/lua - e/a,1) < ε*κ*n^2
                end
            end
            # @testset "Tridiagonal UL" begin
            #     lud   = factorize(d)
            #     f = zeros(eltyb, n+1)
            #     @test_throws DimensionMismatch lud\f
            #     @test_throws DimensionMismatch transpose(lud)\f
            #     @test_throws DimensionMismatch lud'\f
            #     @test_throws DimensionMismatch LinearAlgebra.ldiv!(transpose(lud), f)
            #     let Bs = copy(b)
            #         for bb in (Bs, view(Bs, 1:n, 1))
            #             @test norm(d*(lud\bb) - bb, 1) < ε*κd*n*2 # Two because the right hand side has two columns
            #             if eltya <: Real
            #                 @test norm((transpose(lud)\bb) - Array(transpose(d))\bb, 1) < ε*κd*n*2 # Two because the right hand side has two columns
            #                 if eltya != Int && eltyb != Int
            #                     @test norm(LinearAlgebra.ldiv!(transpose(lud), copy(bb)) - Array(transpose(d))\bb, 1) < ε*κd*n*2
            #                 end
            #             end
            #             if eltya <: Complex
            #                 @test norm((lud'\bb) - Array(d')\bb, 1) < ε*κd*n*2 # Two because the right hand side has two columns
            #             end
            #         end
            #     end
            #     if eltya <: BlasFloat && eltyb <: BlasFloat
            #         e = rand(eltyb,n,n)
            #         @test norm(e/lud - e/d,1) < ε*κ*n^2
            #         @test norm((transpose(lud)\e') - Array(transpose(d))\e',1) < ε*κd*n^2
            #         #test singular
            #         du = rand(eltya,n-1)
            #         dl = rand(eltya,n-1)
            #         dd = rand(eltya,n)
            #         dd[1] = zero(eltya)
            #         du[1] = zero(eltya)
            #         dl[1] = zero(eltya)
            #         zT = Tridiagonal(dl,dd,du)
            #         @test !LinearAlgebra.issuccess(ul(zT; check = false))
            #     end
            # end
            # @testset "Thin UL" begin
            #     lua   = @inferred ul(a[:,1:n1])
            #     @test lua.U*lua.L ≈ lua.P'*a[:,1:n1]
            # end
            # @testset "Fat UL" begin
            #     lua   = ul(a[1:n1,:])
            #     @test lua.L*lua.U ≈ lua.P*a[1:n1,:]
            # end
        end

        # @testset "UL of Symmetric/Hermitian" begin
        #     for HS in (Hermitian(a'a), Symmetric(a'a))
        #         luhs = ul(HS)
        #         @test luhs.L*luhs.U ≈ luhs.P*Matrix(HS)
        #     end
        # end
    end

    @testset "Singular matrices" for T in (Float64, ComplexF64)
        A = T[1 2; 0 0]
        @test_throws SingularException ul(A)
        @test_throws SingularException ul!(copy(A))
        @test_throws SingularException ul(A; check = true)
        @test_throws SingularException ul!(copy(A); check = true)
        @test !issuccess(ul(A; check = false))
        @test !issuccess(ul!(copy(A); check = false))
        if VERSION < v"1.11-"
            @test_throws ZeroPivotException ul(A, Val(false))
            @test_throws ZeroPivotException ul!(copy(A), Val(false))
            @test_throws ZeroPivotException ul(A, Val(false); check = true)
            @test_throws ZeroPivotException ul!(copy(A), Val(false); check = true)
        else
            @test_throws SingularException ul(A, Val(false))
            @test_throws SingularException ul!(copy(A), Val(false))
            @test_throws SingularException ul(A, Val(false); check = true)
            @test_throws SingularException ul!(copy(A), Val(false); check = true)
        end
        @test !issuccess(ul(A, Val(false); check = false))
        @test !issuccess(ul!(copy(A), Val(false); check = false))
        F = ul(A; check = false)
        @test sprint((io, x) -> show(io, "text/plain", x), F) ==
            "Failed factorization of type $(typeof(F))"
    end

    # @testset "conversion" begin
    #     Random.seed!(3)
    #     a = Tridiagonal(rand(9),rand(10),rand(9))
    #     fa = Array(a)
    #     falu = ul(fa)
    #     alu = ul(a)
    #     falu = convert(typeof(falu),alu)
    #     @test Array(alu) == fa
    #     @test AbstractArray(alu) == fa
    # end

    @testset "Rational Matrices" begin
        ## Integrate in general tests when more linear algebra is implemented in julia
        a = convert(Matrix{Rational{BigInt}}, rand(1:10//1,n,n))/n
        b = rand(1:10,n,2)
        @inferred ul(a)
        lua   = factorize(a)
        l,u,p = lua.L, lua.U, lua.p
        @test l*u ≈ a[p,:]
        @test l[invperm(p),:]*u ≈ a
        @test a*inv(lua) ≈ Matrix(I, n, n)
        let Bs = b
            for b in (Bs, view(Bs, 1:n, 1))
                @test a*(lua\b) ≈ b
            end
        end
        @test @inferred(det(a)) ≈ det(Array{Float64}(a))
    end

    @testset "Rational{BigInt} and BigFloat Hilbert Matrix" begin
        ## Hilbert Matrix (very ill conditioned)
        ## Testing Rational{BigInt} and BigFloat version
        nHilbert = 50
        H = Rational{BigInt}[1//(i+j-1) for i = 1:nHilbert,j = 1:nHilbert]
        Hinv = Rational{BigInt}[(-1)^(i+j)*(i+j-1)*binomial(nHilbert+i-1,nHilbert-j)*
            binomial(nHilbert+j-1,nHilbert-i)*binomial(i+j-2,i-1)^2
            for i = big(1):nHilbert,j=big(1):nHilbert]
        @test inv(H) == Hinv
        setprecision(2^10) do
            @test norm(Array{Float64}(inv(float(H)) - float(Hinv))) < 1e-100
        end
    end

    @testset "logdet" begin
        @test @inferred(logdet(ComplexF32[1.0f0 0.5f0; 0.5f0 -1.0f0])) === 0.22314355f0 + 3.1415927f0im
        @test_throws DomainError logdet([1 1; 1 -1])
    end

    @testset "REPL printing" begin
            bf = IOBuffer()
            show(bf, "text/plain", ul(Matrix(I, 4, 4)))
            seekstart(bf)
			@test String(take!(bf)) ==
"""
UL{Float64, Matrix{Float64}, Vector{Int64}}
U factor:
4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0
L factor:
4×4 Matrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0"""
    end

    @testset "propertynames" begin
        names = sort!(collect(string.(Base.propertynames(ul(rand(3,3))))))
        @test names == ["L", "P", "U", "p"]
        allnames = sort!(collect(string.(Base.propertynames(ul(rand(3,3)), true))))
        @test allnames == ["L", "P", "U", "factors", "info", "ipiv", "p"]
    end

    @testset "Issue #30917. Determinant of integer matrix" begin
        @test det([1 1 0 0 1 0 0 0
                1 0 1 0 0 1 0 0
                1 0 0 1 0 0 1 0
                0 1 1 1 0 0 0 0
                0 1 0 0 0 0 1 1
                0 0 1 0 1 0 0 1
                0 0 0 1 1 1 0 0
                0 0 0 0 1 1 0 1]) ≈ 6
    end

    @testset "Issue #33177. No ldiv!(UL, Adjoint)" begin
        A = [1 0; 1 1]
        B = [1 2; 2 8]
        F = ul(B)
        @test (A  / F') * B == A
        @test (A' / F') * B == A'

        a = complex.(randn(2), randn(2))
        @test (a' / F') * B ≈ a'
        @test (transpose(a) / F') * B ≈ transpose(a)

        A = complex.(randn(2, 2), randn(2, 2))
        @test (A' / F') * B ≈ A'
        @test (transpose(A) / F') * B ≈ transpose(A)
    end

    @testset "0x0 matrix" begin
        A = ones(0, 0)
        F = ul(A)
        @test F.U == ones(0, 0)
        @test F.L == ones(0, 0)
        @test F.P == ones(0, 0)
        @test F.p == []
    end

    @testset "more ldiv! methods" begin
        for elty in (Float16, Float64, ComplexF64), transform in (transpose, adjoint)
            A = randn(elty, 5, 5)
            B = randn(elty, 5, 5)
            @test ldiv!(transform(ul(A)), copy(B)) ≈ transform(ul(A)) \ B ≈ transform(A) \ B
            @test ldiv!(transform(ul(A)), transform(copy(B))) ≈ transform(ul(A)) \ transform(B) ≈ transform(A) \ transform(B)
        end
    end

    @testset "more rdiv! methods" begin
        A = randn(5,5)
        B = randn(5,5)
        a = randn(5)
        @test rdiv!(copy(A), ul(B)) ≈ A / B

        for elty in (Float16, Float64, ComplexF64), transform in (transpose, adjoint)
            A = randn(elty, 5, 5)
            C = copy(A)
            B = randn(elty, 5, 5)
            @test rdiv!(transform(A), transform(ul(B))) ≈ transform(C) / transform(ul(B)) ≈ transform(C) / transform(B)
        end
    end

    @testset "conversions" begin
        A = randn(5,5)
        F = ul(A)
        @test ul(F) ≡ F ≡ Factorization{Float64}(F)
        @test UL{Float32}(F).factors ≈ UL{Float32,Matrix{Float32}}(F).factors ≈
                Factorization{Float32}(F).factors ≈ ul(Float32.(A)).factors
        @test copy(F).factors == F.factors
    end

    @testset "det" begin
        A = randn(5,5)
        @test det(A) ≈ det(ul(A))
        @test all(logabsdet(A) .≈ logabsdet(ul(A)))
    end

    @testset "inv" begin
        A = randn(5,5)
        @test inv(ul(A)) ≈ inv(A)
    end

    @testset "MyVector/MyMatrix" begin
        A = randn(5,5)
        b = randn(5)
        B = randn(5,3)
        b̃ = MyVector(copy(b))
        B̃ = MyMatrix(copy(B))
        @test ldiv!(ul(A), b̃) === b̃
        @test b̃ ≈ A \ b
        @test ldiv!(ul(A), B̃) === B̃
        @test B̃ ≈ A \ B
    end

    @testset "Tridiagonal" begin
        n = 10
        A = Tridiagonal(randn(n-1), randn(n), randn(n-1))+10I
        U,L = ul(A, Val(false))
        @test U isa Bidiagonal
        @test L isa Bidiagonal
        Ũ,L̃ = ul(Matrix(A), Val(false))
        @test U ≈ Ũ
        @test L ≈ L̃
        @test U*L ≈ A
    end
end

# This file is based on JuliaLang/LinearAlgebra/src/lu.jl, a part of Julia.
# License is MIT: https://julialang.org/license

####################
# UL Factorization #
####################
"""
    UL <: Factorization

Matrix factorization type of the `UL` factorization of a square matrix `A`. This
is the return type of [`ul`](@ref), the corresponding matrix factorization function.

The individual components of the factorization `F::UL` can be accessed via [`getproperty`](@ref):

| Component | Description                              |
|:----------|:-----------------------------------------|
| `F.U`     | `U` (upper triangular) part of `UL`      |
| `F.L`     | `L` (unit lower triangular) part of `UL` |
| `F.p`     | (right) permutation `Vector`             |
| `F.P`     | (right) permutation `Matrix`             |

Iterating the factorization produces the components `F.U`, `F.L`, and `F.p`.

# Examples
```jldoctest
julia> A = [4 3; 6 3]
2×2 Array{Int64,2}:
 4  3
 6  3

julia> F = ul(A)
UL{Float64,Array{Float64,2}}
L factor:
2×2 Array{Float64,2}:
 1.0       0.0
 0.666667  1.0
U factor:
2×2 Array{Float64,2}:
 6.0  3.0
 0.0  1.0

julia> F.L * F.U == A[F.p, :]
true

julia> l, u, p = ul(A); # destructuring via iteration

julia> l == F.L && u == F.U && p == F.p
true
```
"""
struct UL{T,S<:AbstractMatrix{T},IPIV<:AbstractVector{<:Integer}} <: Factorization{T}
    factors::S
    ipiv::IPIV
    info::BlasInt

    function UL{T,S,IPIV}(factors, ipiv, info) where {T,S<:AbstractMatrix{T},IPIV<:AbstractVector{<:Integer}}
        require_one_based_indexing(factors)
        new{T,S,IPIV}(factors, ipiv, info)
    end
end
function UL(factors::AbstractMatrix{T}, ipiv::AbstractVector{<:Integer}, info::Integer) where {T}
    UL{T,typeof(factors),typeof(ipiv)}(factors, ipiv, BlasInt(info))
end
function UL{T}(factors::AbstractMatrix, ipiv::AbstractVector{<:Integer}, info::Integer) where {T}
    UL(convert(AbstractMatrix{T}, factors),
       ipiv,
       info)
end

function UL{T,S}(factors::AbstractMatrix, ipiv::AbstractVector{<:Integer}, info::Integer) where {T,S<:AbstractMatrix{T}}
    UL(convert(S, factors),
       ipiv,
       info)
end


# iteration for destructuring into components
iterate(S::UL) = (S.U, Val(:L))
iterate(S::UL, ::Val{:L}) = (S.L, Val(:p))
iterate(S::UL, ::Val{:p}) = (S.p, Val(:done))
iterate(S::UL, ::Val{:done}) = nothing

if isdefined(LinearAlgebra, :AdjointFactorization) # VERSION >= v"1.10-"
    adjoint(F::UL{<:Real}) = LinearAlgebra.TransposeFactorization(F)
    transpose(F::UL{<:Real}) = LinearAlgebra.TransposeFactorization(F)
else
    adjoint(F::UL) = Adjoint(F)
    adjoint(F::UL{<:Real}) = Transpose(F)
    transpose(F::UL) = Transpose(F)
end

# AbstractMatrix
function ul!(A::AbstractMatrix{T}, pivot::Union{Val{false}, Val{true}} = Val(true);
             check::Bool = true) where T<:BlasFloat
    return generic_ulfact!(A, pivot; check = check)
end
# function ul!(A::HermOrSym, pivot::Union{Val{false}, Val{true}} = Val(true); check::Bool = true)
#     copytri!(A.data, A.uplo, isa(A, Hermitian))
#     ul!(A.data, pivot; check = check)
# end

if VERSION < v"1.11-"
    _checknonsingular(info, ::Val{true}) = checknonsingular(info, RowMaximum())
    _checknonsingular(info, ::Val{false}) = checknonsingular(info, NoPivot())
else
    _checknonsingular(info, _) = checknonsingular(info)
end

"""
    ul!(A, pivot=Val(true); check = true) -> UL

`ul!` is the same as [`ul`](@ref), but saves space by overwriting the
input `A`, instead of creating a copy. An [`InexactError`](@ref)
exception is thrown if the factorization produces a number not representable by the
element type of `A`, e.g. for integer types.

# Examples
```jldoctest
julia> A = [4. 3.; 6. 3.]
2×2 Array{Float64,2}:
 4.0  3.0
 6.0  3.0

julia> F = ul!(A)
UL{Float64,Array{Float64,2},Vector{Int}}
L factor:
2×2 Array{Float64,2}:
 1.0       0.0
 0.666667  1.0
U factor:
2×2 Array{Float64,2}:
 6.0  3.0
 0.0  1.0

julia> iA = [4 3; 6 3]
2×2 Array{Int64,2}:
 4  3
 6  3

julia> ul!(iA)
ERROR: InexactError: Int64(0.6666666666666666)
Stacktrace:
[...]
```
"""
ul!(A::AbstractMatrix, pivot::Union{Val{false}, Val{true}} = Val(true); check::Bool = true) =
    generic_ulfact!(A, pivot; check = check)
function generic_ulfact!(A::AbstractMatrix{T}, ::Val{Pivot} = Val(true);
                         check::Bool = true) where {T,Pivot}
    m, n = size(A)
    minmn = min(m,n)
    info = 0
    ipiv = Vector{BlasInt}(undef, minmn)
    @inbounds begin
        for k = minmn:-1:1
            # find index max
            kp = k
            if Pivot
                amax = abs(zero(T))
                for i = 1:k
                    absi = abs(A[i,k])
                    if absi > amax
                        kp = i
                        amax = absi
                    end
                end
            end
            ipiv[k] = kp
            if !iszero(A[kp,k])
                if k != kp
                    # Interchange
                    for i = 1:n
                        tmp = A[k,i]
                        A[k,i] = A[kp,i]
                        A[kp,i] = tmp
                    end
                end
                # Scale first coulmn
                Akkinv = inv(A[k,k])
                for i = 1:k-1
                    A[i,k] *= Akkinv
                end
            elseif info == 0
                info = k
            end
            # Update the rest
            for j = 1:k-1
                for i = 1:k-1
                    A[i,j] -= A[i,k]*A[k,j]
                end
            end
        end
    end
    check && _checknonsingular(info, Val{Pivot}())
    return UL{T}(A, ipiv, convert(BlasInt, info))
end

function ultype(T::Type)
    # In generic_ulfact!, the elements of the lower part of the matrix are
    # obtained using the division of two matrix elements. Hence their type can
    # be different (e.g. the division of two types with the same unit is a type
    # without unit).
    # The elements of the upper part are obtained by U - U * L
    # where U is an upper part element and L is a lower part element.
    # Therefore, the types LT, UT should be invariant under the map:
    # (LT, UT) -> begin
    #     L = oneunit(UT) / oneunit(UT)
    #     U = oneunit(UT) - oneunit(UT) * L
    #     typeof(L), typeof(U)
    # end
    # The following should handle most cases
    UT = typeof(oneunit(T) - oneunit(T) * (oneunit(T) / (oneunit(T) + zero(T))))
    LT = typeof(oneunit(UT) / oneunit(UT))
    S = promote_type(T, LT, UT)
end

# for all other types we must promote to a type which is stable under division
"""
    ul(A, pivot=Val(true); check = true) -> F::UL

Compute the UL factorization of `A`.

When `check = true`, an error is thrown if the decomposition fails.
When `check = false`, responsibility for checking the decomposition's
validity (via [`issuccess`](@ref)) lies with the user.

In most cases, if `A` is a subtype `S` of `AbstractMatrix{T}` with an element
type `T` supporting `+`, `-`, `*` and `/`, the return type is `UL{T,S{T}}`. If
pivoting is chosen (default) the element type should also support [`abs`](@ref) and
[`<`](@ref).

The individual components of the factorization `F` can be accessed via [`getproperty`](@ref):

| Component | Description                         |
|:----------|:------------------------------------|
| `F.U`     | `U` (upper triangular) part of `UL` |
| `F.L`     | `L` (lower triangular) part of `UL` |
| `F.p`     | (right) permutation `Vector`        |
| `F.P`     | (right) permutation `Matrix`        |

Iterating the factorization produces the components `F.L`, `F.U`, and `F.p`.

The relationship between `F` and `A` is

`F.L*F.U == A[F.p, :]`

`F` further supports the following functions:

| Supported function               | `UL` | `UL{T,Tridiagonal{T}}` |
|:---------------------------------|:-----|:-----------------------|
| [`/`](@ref)                      | ✓    |                        |
| [`\\`](@ref)                     | ✓    | ✓                      |
| [`inv`](@ref)                    | ✓    | ✓                      |
| [`det`](@ref)                    | ✓    | ✓                      |
| [`logdet`](@ref)                 | ✓    | ✓                      |
| [`logabsdet`](@ref)              | ✓    | ✓                      |
| [`size`](@ref)                   | ✓    | ✓                      |

# Examples
```jldoctest
julia> A = [4 3; 6 3]
2×2 Array{Int64,2}:
 4  3
 6  3

julia> F = ul(A)
UL{Float64,Array{Float64,2},Vector{Int}}
L factor:
2×2 Array{Float64,2}:
 1.0       0.0
 0.666667  1.0
U factor:
2×2 Array{Float64,2}:
 6.0  3.0
 0.0  1.0

julia> F.L * F.U == A[F.p, :]
true

julia> l, u, p = ul(A); # destructuring via iteration

julia> l == F.L && u == F.U && p == F.p
true
```
"""
function ul_layout(layout, A::AbstractMatrix{T}, pivot::Union{Val{false}, Val{true}}=Val(true);
            check::Bool = true) where T
    S = ultype(T)
    ul!(copy_oftype(A, S), pivot; check = check)
end

const _ul = ul_layout

ul(A::AbstractMatrix{T}, pivot::Union{Val{false}, Val{true}}=Val(true); check::Bool = true) where T =
    _ul(MemoryLayout(A), A, pivot; check=check)

ul(S::UL) = S
function ul(x::Number; check::Bool=true)
    info = x == 0 ? one(BlasInt) : zero(BlasInt)
    check && checknonsingular(info)
    return UL(fill(x, 1, 1), BlasInt[1], info)
end

function UL{T}(F::UL) where T
    M = convert(AbstractMatrix{T}, F.factors)
    UL{T,typeof(M)}(M, F.ipiv, F.info)
end
UL{T,S}(F::UL) where {T,S} = UL{T,S}(convert(S, F.factors), F.ipiv, F.info)
Factorization{T}(F::UL{T}) where {T} = F
Factorization{T}(F::UL) where {T} = UL{T}(F)

copy(A::UL{T,S}) where {T,S} = UL{T,S}(copy(A.factors), copy(A.ipiv), A.info)

size(A::UL)    = size(getfield(A, :factors))
size(A::UL, i) = size(getfield(A, :factors), i)

getU(F::UL) = getU(F, size(F.factors))
function getU(F::UL{T}, _) where T
    m, n = size(F)
    U = triu!(layout_getindex(getfield(F, :factors),1:m,1:min(m,n)))
    for i = 1:min(m,n); U[i,i] = one(T); end
    return U
end

getL(F::UL) = getL(F, size(F.factors))
function getL(F::UL, _)
    m, n = size(F)
    tril!(layout_getindex(getfield(F, :factors),1:min(m,n),1:n))
end

function getproperty(F::UL{T,<:AbstractMatrix}, d::Symbol) where T
    m, n = size(F)
    if d === :L
        return getL(F)
    elseif d === :U
        return getU(F)
    elseif d === :p
        return invperm(ipiv2perm(getfield(F, :ipiv), m))
    elseif d === :P
        return Matrix{T}(I, m, m)[:,invperm(F.p)]
    else
        getfield(F, d)
    end
end

propertynames(F::UL, private::Bool=false) =
    (:L, :U, :p, :P, (private ? fieldnames(typeof(F)) : ())...)

issuccess(F::UL) = F.info == 0

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::UL)
    if issuccess(F)
        summary(io, F); println(io)
        println(io, "U factor:")
        show(io, mime, F.U)
        println(io, "\nL factor:")
        show(io, mime, F.L)
    else
        print(io, "Failed factorization of type $(typeof(F))")
    end
end

_apply_inverse_ipiv_rows!(A::UL, B::AbstractVecOrMat) = _ipiv_rows!(A, axes(A.ipiv,1), B)
_apply_ipiv_rows!(A::UL, ipiv, B::AbstractVecOrMat) = _ipiv_rows!(A, reverse(axes(ipiv,1)), B)
_apply_ipiv_rows!(A::UL, ::AbstractUnitRange, B::AbstractVecOrMat) = B
_apply_ipiv_rows!(A::UL, B::AbstractVecOrMat) = _apply_ipiv_rows!(A, A.ipiv, B)


function _ipiv_rows!(A::UL, order::OrdinalRange, B::AbstractVecOrMat)
    for i = order
        if i != A.ipiv[i]
            _swap_rows!(B, i, A.ipiv[i])
        end
    end
    B
end

function _swap_rows!(B::AbstractVector, i::Integer, j::Integer)
    B[i], B[j] = B[j], B[i]
    B
end

function _swap_rows!(B::AbstractMatrix, i::Integer, j::Integer)
    for col = 1 : size(B, 2)
        B[i,col], B[j,col] = B[j,col], B[i,col]
    end
    B
end

function ldiv!(A::UL, B::AbstractVecOrMat)
    _apply_ipiv_rows!(A, B)
    ArrayLayouts.ldiv!(LowerTriangular(A.factors), ArrayLayouts.ldiv!(UnitUpperTriangular(A.factors), B))
end

ldiv!(A::UL, B::LayoutVector) = Base.invoke(ldiv!, Tuple{UL,AbstractVecOrMat}, A, B)
ldiv!(A::UL, B::LayoutMatrix) = Base.invoke(ldiv!, Tuple{UL,AbstractVecOrMat}, A, B)

function ldiv!(transA::TransposeFact{<:Any,<:UL}, B::AbstractVecOrMat)
    A = transA.parent
    ArrayLayouts.ldiv!(transpose(UnitUpperTriangular(A.factors)), ArrayLayouts.ldiv!(transpose(LowerTriangular(A.factors)), B))
    _apply_inverse_ipiv_rows!(A, B)
end

function ldiv!(adjA::AdjointFact{<:Any,<:UL}, B::AbstractVecOrMat)
    A = adjA.parent
    ArrayLayouts.ldiv!(adjoint(UnitUpperTriangular(A.factors)), ArrayLayouts.ldiv!(adjoint(LowerTriangular(A.factors)), B))
    _apply_inverse_ipiv_rows!(A, B)
end

(\)(F::AdjointFact{<:Any,<:UL}, B::AbstractVecOrMat) = ldiv!(F, copy_oftype(B, promote_type(eltype(F), eltype(B))))
(\)(F::TransposeFact{<:Any,<:UL}, B::AbstractVecOrMat) = ldiv!(F, copy_oftype(B, promote_type(eltype(F), eltype(B))))

(/)(A::AbstractMatrix, F::AdjointFact{<:Any,<:UL}) = adjoint(adjoint(F) \ adjoint(A))
(/)(A::AbstractMatrix, F::TransposeFact{<:Any,<:UL}) = transpose(transpose(F) \ transpose(A))
(/)(A::Union{Matrix{Complex{T}},AdjOrTrans{Complex{T},Vector{Complex{T}}}}, F::TransposeFactorization{T,<:UL}) where {T<:BlasReal} =
    transpose(transpose(F) \ transpose(A))
(/)(B::Transpose{Complex{T},Vector{Complex{T}}}, F::TransposeFactorization{T,<:UL}) where {T<:BlasReal} =
    transpose(transpose(F) \ transpose(B))


function det(F::UL{T}) where T
    n = checksquare(F)
    issuccess(F) || return zero(T)
    P = one(T)
    c = 0
    @inbounds for i = 1:n
        P *= F.factors[i,i]
        if F.ipiv[i] != i
            c += 1
        end
    end
    s = (isodd(c) ? -one(T) : one(T))
    return P * s
end

function logabsdet(F::UL{T}) where T  # return log(abs(det)) and sign(det)
    n = checksquare(F)
    issuccess(F) || return log(zero(real(T))), log(one(T))
    c = 0
    P = one(T)
    abs_det = zero(real(T))
    @inbounds for i = 1:n
        dg_ii = F.factors[i,i]
        P *= sign(dg_ii)
        if F.ipiv[i] != i
            c += 1
        end
        abs_det += log(abs(dg_ii))
    end
    s = ifelse(isodd(c), -one(real(T)), one(real(T))) * P
    abs_det, s
end

inv!(A::UL{T,<:AbstractMatrix}) where {T} =
    ldiv!(A.factors, copy(A), Matrix{T}(I, size(A, 1), size(A, 1)))
inv(A::UL{<:BlasFloat,<:AbstractMatrix}) = inv!(copy(A))

# Tridiagonal

# # See dgttrf.f
# function ul!(A::Tridiagonal{T,V}, pivot::Union{Val{false}, Val{true}} = Val(true);
#              check::Bool = true) where {T,V}
#     n = size(A, 1)
#     info = 0
#     ipiv = Vector{BlasInt}(undef, n)
#     dl = A.dl
#     d = A.d
#     du = A.du
#     if dl === du
#         throw(ArgumentError("off-diagonals of `A` must not alias"))
#     end
#     dl2 = fill!(similar(d, n-2), 0)::V

#     @inbounds begin
#         for i = 1:n
#             ipiv[i] = i
#         end
#         for i = n:-1:3
#             # pivot or not?
#             if pivot === Val(false) || abs(d[i]) >= abs(dl[i])
#                 # No interchange
#                 if d[i] != 0
#                     fact = du[i-1]/d[i]
#                     du[i-1] = fact
#                     d[i-1] -= fact*dl[i-1]
#                     dl2[i] = 0
#                 end
#             else
#                 # Interchange
#                 fact = d[i]/du[i-1]
#                 d[i] = du[i-1]
#                 du[i-1] = fact
#                 tmp = dl[i-1]
#                 dl[i-1] = d[i-1]
#                 d[i-1] = tmp - fact*d[i-1]
#                 dl2[i] = dl[i-1]
#                 dl[i-1] = -fact*dl[i-1]
#                 ipiv[i] = i-1
#             end
#         end
#         if n > 1
#             i = 2
#             if pivot === Val(false) || abs(d[i]) >= abs(dl[i])
#                 if d[i] != 0
#                     fact = du[i-1]/d[i]
#                     du[i-1] = fact
#                     d[i-1] -= fact*dl[i-1]
#                 end
#             else
#                 fact = d[i]/du[i-1]
#                 d[i] = du[i-1]
#                 du[i-1] = fact
#                 tmp = dl[i-1]
#                 dl[i-1] = d[i-1]
#                 d[i-1] = tmp - fact*d[i-1]
#                 ipiv[i] = i-1
#             end
#         end
#         # check for a zero on the diagonal of U
#         for i = 1:n
#             if d[i] == 0
#                 info = i
#                 break
#             end
#         end
#     end
#     B = Tridiagonal{T,V}(dl, d, du, dl2)
#     check && checknonsingular(info, pivot)
#     return UL{T,Tridiagonal{T,V}}(B, ipiv, convert(BlasInt, info))
# end


function getU(F::UL{T,<:Tridiagonal}, _) where T
    m, n = size(F)
    @assert m == n
    data = getfield(F, :factors)
    Bidiagonal(ones(T,m), copy(data.du), :U)
end
function getL(F::UL{T,<:Tridiagonal}, _) where T
    m, n = size(F)
    @assert m == n
    data = getfield(F, :factors)
    Bidiagonal(copy(data.d), copy(data.dl), :L)
end


# function getproperty(F::UL{T,Tridiagonal{T,V}}, d::Symbol) where {T,V}
#     m, n = size(F)
#     if d === :U
#         du = getfield(getfield(F, :factors), :du)
#         U = Array(Bidiagonal(fill!(similar(du, n), one(T)), du, d))
#         for i = 2:n
#             tmp = U[getfield(F, :ipiv)[i], i+1:end]
#             U[getfield(F, :ipiv)[i], i+1:end] = U[i, i+1:end]
#             U[i, i+1:end] = tmp
#         end
#         return U
#     elseif d === :L
#         L = Array(Bidiagonal(getfield(getfield(F, :factors), :d), getfield(getfield(F, :factors), :dl), d))
#         for i = 1:n - 2
#             L[i,i + 2] = getfield(getfield(F, :factors), :du2)[i]
#         end
#         return L
#     elseif d === :p
#         return ipiv2perm(getfield(F, :ipiv), m)
#     elseif d === :P
#         return Matrix{T}(I, m, m)[:,invperm(F.p)]
#     end
#     return getfield(F, d)
# end

# # See dgtts2.f
# function ldiv!(A::UL{T,Tridiagonal{T,V}}, B::AbstractVecOrMat) where {T,V}
#     require_one_based_indexing(B)
#     n = size(A,1)
#     if n != size(B,1)
#         throw(DimensionMismatch("matrix has dimensions ($n,$n) but right hand side has $(size(B,1)) rows"))
#     end
#     nrhs = size(B,2)
#     dl = A.factors.dl
#     d = A.factors.d
#     du = A.factors.du
#     du2 = A.factors.du2
#     ipiv = A.ipiv
#     @inbounds begin
#         for j = 1:nrhs
#             for i = 1:n-1
#                 ip = ipiv[i]
#                 tmp = B[i+1-ip+i,j] - dl[i]*B[ip,j]
#                 B[i,j] = B[ip,j]
#                 B[i+1,j] = tmp
#             end
#             B[n,j] /= d[n]
#             if n > 1
#                 B[n-1,j] = (B[n-1,j] - du[n-1]*B[n,j])/d[n-1]
#             end
#             for i = n-2:-1:1
#                 B[i,j] = (B[i,j] - du[i]*B[i+1,j] - du2[i]*B[i+2,j])/d[i]
#             end
#         end
#     end
#     return B
# end

# function ldiv!(transA::Transpose{<:Any,<:UL{T,Tridiagonal{T,V}}}, B::AbstractVecOrMat) where {T,V}
#     require_one_based_indexing(B)
#     A = transA.parent
#     n = size(A,1)
#     if n != size(B,1)
#         throw(DimensionMismatch("matrix has dimensions ($n,$n) but right hand side has $(size(B,1)) rows"))
#     end
#     nrhs = size(B,2)
#     dl = A.factors.dl
#     d = A.factors.d
#     du = A.factors.du
#     du2 = A.factors.du2
#     ipiv = A.ipiv
#     @inbounds begin
#         for j = 1:nrhs
#             B[1,j] /= d[1]
#             if n > 1
#                 B[2,j] = (B[2,j] - du[1]*B[1,j])/d[2]
#             end
#             for i = 3:n
#                 B[i,j] = (B[i,j] - du[i-1]*B[i-1,j] - du2[i-2]*B[i-2,j])/d[i]
#             end
#             for i = n-1:-1:1
#                 if ipiv[i] == i
#                     B[i,j] = B[i,j] - dl[i]*B[i+1,j]
#                 else
#                     tmp = B[i+1,j]
#                     B[i+1,j] = B[i,j] - dl[i]*tmp
#                     B[i,j] = tmp
#                 end
#             end
#         end
#     end
#     return B
# end

# # Ac_ldiv_B!(A::UL{T,Tridiagonal{T}}, B::AbstractVecOrMat) where {T<:Real} = At_ldiv_B!(A,B)
# function ldiv!(adjA::Adjoint{<:Any,UL{T,Tridiagonal{T,V}}}, B::AbstractVecOrMat) where {T,V}
#     require_one_based_indexing(B)
#     A = adjA.parent
#     n = size(A,1)
#     if n != size(B,1)
#         throw(DimensionMismatch("matrix has dimensions ($n,$n) but right hand side has $(size(B,1)) rows"))
#     end
#     nrhs = size(B,2)
#     dl = A.factors.dl
#     d = A.factors.d
#     du = A.factors.du
#     du2 = A.factors.du2
#     ipiv = A.ipiv
#     @inbounds begin
#         for j = 1:nrhs
#             B[1,j] /= conj(d[1])
#             if n > 1
#                 B[2,j] = (B[2,j] - conj(du[1])*B[1,j])/conj(d[2])
#             end
#             for i = 3:n
#                 B[i,j] = (B[i,j] - conj(du[i-1])*B[i-1,j] - conj(du2[i-2])*B[i-2,j])/conj(d[i])
#             end
#             for i = n-1:-1:1
#                 if ipiv[i] == i
#                     B[i,j] = B[i,j] - conj(dl[i])*B[i+1,j]
#                 else
#                     tmp = B[i+1,j]
#                     B[i+1,j] = B[i,j] - conj(dl[i])*tmp
#                     B[i,j] = tmp
#                 end
#             end
#         end
#     end
#     return B
# end

rdiv!(B::AbstractMatrix, A::UL) = transpose(ldiv!(transpose(A), transpose(B)))
rdiv!(B::AbstractMatrix, A::TransposeFact{<:Any,<:UL}) = transpose(ldiv!(A.parent, transpose(B)))
rdiv!(B::AbstractMatrix, A::AdjointFact{<:Any,<:UL}) = adjoint(ldiv!(A.parent, adjoint(B)))

# Conversions
AbstractMatrix(F::UL) = (F.L * F.U)[invperm(F.p),:]
AbstractArray(F::UL) = AbstractMatrix(F)
Matrix(F::UL) = Array(AbstractArray(F))
Array(F::UL) = Matrix(F)

# function Tridiagonal(F::UL{T,Tridiagonal{T,V}}) where {T,V}
#     n = size(F, 1)

#     dl  = copy(F.factors.dl)
#     d   = copy(F.factors.d)
#     du  = copy(F.factors.du)
#     du2 = copy(F.factors.du2)

#     for i = n - 1:-1:1
#         li         = dl[i]
#         dl[i]      = li*d[i]
#         d[i + 1]  += li*du[i]
#         if i < n - 1
#             du[i + 1] += li*du2[i]
#         end

#         if F.ipiv[i] != i
#             tmp   = dl[i]
#             dl[i] = d[i]
#             d[i]  = tmp

#             tmp      = d[i + 1]
#             d[i + 1] = du[i]
#             du[i]    = tmp

#             if i < n - 1
#                 tmp       = du[i + 1]
#                 du[i + 1] = du2[i]
#                 du2[i]    = tmp
#             end
#         end
#     end
#     return Tridiagonal(dl, d, du)
# end
# AbstractMatrix(F::UL{T,Tridiagonal{T,V}}) where {T,V} = Tridiagonal(F)
# AbstractArray(F::UL{T,Tridiagonal{T,V}}) where {T,V} = AbstractMatrix(F)
# Matrix(F::UL{T,Tridiagonal{T,V}}) where {T,V} = Array(AbstractArray(F))
# Array(F::UL{T,Tridiagonal{T,V}}) where {T,V} = Matrix(F)

# This file is based on a part of Julia. License is MIT: https://julialang.org/license

# It has modified the definition of QR to support general τ

# QR and Hessenberg Factorizations
"""
    QR <: Factorization

A QR matrix factorization stored in a packed format, typically obtained from
[`qr`](@ref). If ``A`` is an `m`×`n` matrix, then

```math
A = Q R
```

where ``Q`` is an orthogonal/unitary matrix and ``R`` is upper triangular.
The matrix ``Q`` is stored as a sequence of Householder reflectors ``v_i``
and coefficients ``\\tau_i`` where:

```math
Q = \\prod_{i=1}^{\\min(m,n)} (I - \\tau_i v_i v_i^T).
```

Iterating the decomposition produces the components `Q` and `R`.

The object has two fields:

* `factors` is an `m`×`n` matrix.

  - The upper triangular part contains the elements of ``R``, that is `R =
    triu(F.factors)` for a `QR` object `F`.

  - The subdiagonal part contains the reflectors ``v_i`` stored in a packed format where
    ``v_i`` is the ``i``th column of the matrix `V = I + tril(F.factors, -1)`.

* `τ` is a vector  of length `min(m,n)` containing the coefficients ``\tau_i``.

"""
struct QR{T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}} <: Factorization{T}
    factors::S
    τ::Tau

    function QR{T,S,Tau}(factors, τ) where {T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}}
        require_one_based_indexing(factors)
        new{T,S,Tau}(factors, τ)
    end
end
QR(factors::AbstractMatrix{T}, τ::AbstractVector{T}) where {T} = QR{T,typeof(factors), typeof(τ)}(factors, τ)
QR{T}(factors::AbstractMatrix, τ::AbstractVector) where {T} =
    QR(convert(AbstractMatrix{T}, factors), convert(AbstractVector{T}, τ))

QR(F::LinearAlgebra.QR) = QR(F.factors, F.τ)

# iteration for destructuring into components
iterate(S::QR) = (S.Q, Val(:R))
iterate(S::QR, ::Val{:R}) = (S.R, Val(:done))
iterate(S::QR, ::Val{:done}) = nothing


function _qrfactUnblocked!(_, _, A::AbstractMatrix{T}, τ::AbstractVector) where {T}
    require_one_based_indexing(A)
    m, n = size(A)
    for k = 1:min(m - 1 + !(T<:Real), n)
        x = view(A, k:m, k)
        τk = reflector!(x)
        τ[k] = τk
        reflectorApply!(x, τk, view(A, k:m, k + 1:n))
    end
    QR(A, τ)
end

_qrfactUnblocked!(::AbstractColumnMajor, ::AbstractStridedLayout, A::AbstractMatrix{T}, τ::AbstractVector{T}) where T<:BlasFloat = QR(LAPACK.geqrf!(A,τ)...)
qrfactUnblocked!(A::AbstractMatrix, τ::AbstractVector) = _qrfactUnblocked!(MemoryLayout(A), MemoryLayout(τ), A, τ)
qrfactUnblocked!(A::AbstractMatrix{T}) where T = qrfactUnblocked!(A, zeros(T, min(size(A)...)))

qrunblocked!(A::AbstractMatrix, ::Val{false}) = qrfactUnblocked!(A)
qrunblocked!(A::AbstractMatrix) = qrunblocked!(A, Val(false))

_qreltype(::Type{T}) where T = typeof(zero(T)/sqrt(abs2(one(T))))


function qrunblocked(A::AbstractMatrix{T}, arg) where T
    require_one_based_indexing(A)
    AA = similar(A, _qreltype(T), size(A))
    copyto!(AA, A)
    return qrunblocked!(AA, arg)
end
function qrunblocked(A::AbstractMatrix{T}) where T
    require_one_based_indexing(A)
    AA = similar(A, _qreltype(T), size(A))
    copyto!(AA, A)
    return qrunblocked!(AA)
end
qrunblocked(x::Number) = qrunblocked(fill(x,1,1))
function qrunblocked(v::AbstractVector)
    require_one_based_indexing(v)
    qrunblocked(reshape(v, (length(v), 1)))
end

# Conversions
QR{T}(A::QR) where {T} = QR(convert(AbstractMatrix{T}, A.factors), convert(AbstractVector{T}, A.τ))
Factorization{T}(A::QR{T}) where {T} = A
Factorization{T}(A::QR) where {T} = QR{T}(A)
AbstractMatrix(F::QR) = F.Q * F.R
AbstractArray(F::QR) = AbstractMatrix(F)
Matrix(F::QR) = Array(AbstractArray(F))
Array(F::QR) = Matrix(F)


function show(io::IO, mime::MIME{Symbol("text/plain")}, F::QR)
    summary(io, F); println(io)
    println(io, "Q factor:")
    show(io, mime, F.Q)
    println(io, "\nR factor:")
    show(io, mime, F.R)
end

@inline function getR(F::QR, _)
    m, n = size(F)
    triu!(getfield(F, :factors)[1:min(m,n), 1:n])
end
@inline getQ(F::QR, _) = QRPackedQ(getfield(F, :factors), F.τ)

getL(F::QR, ::Tuple{AbstractVector,AbstractVector}) = getL(F, size(F))
getQ(F::QR, ::Tuple{AbstractVector,AbstractVector}) = getQ(F, size(F))


getR(F::QR) = getR(F, size(F.factors))
getQ(F::QR) = getQ(F, size(F.factors))

function getproperty(F::QR, d::Symbol)
    if d == :R
        return getR(F)
    elseif d == :Q
        return getQ(F)
    else
        getfield(F, d)
    end
end

propertynames(F::QR, private::Bool=false) =
    (:R, :Q, (private ? fieldnames(typeof(F)) : ())...)

ldiv!(F::QR, B::AbstractVecOrMat) = ArrayLayouts.ldiv!(F, B)
ldiv!(F::QR, B::LayoutVector) = ArrayLayouts.ldiv!(F, B)
ldiv!(F::QR, B::LayoutMatrix) = ArrayLayouts.ldiv!(F, B)


"""
    QRPackedQ <: LinearAlgebra.AbstractQ

The orthogonal/unitary ``Q`` matrix of a QR factorization stored in [`QR`](@ref).
"""
struct QRPackedQ{T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}} <: LayoutQ{T}
    factors::S
    τ::Tau

    function QRPackedQ{T,S,Tau}(factors, τ) where {T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}}
        require_one_based_indexing(factors)
        new{T,S,Tau}(factors, τ)
    end
end



QRPackedQ(factors::AbstractMatrix{T}, τ::AbstractVector{T}) where {T} = QRPackedQ{T,typeof(factors),typeof(τ)}(factors, τ)
function QRPackedQ{T}(factors::AbstractMatrix, τ::AbstractVector) where {T}
    QRPackedQ(convert(AbstractMatrix{T}, factors), convert(AbstractVector{T}, τ))
end

QRPackedQ{T}(Q::QRPackedQ) where {T} = QRPackedQ(convert(AbstractMatrix{T}, Q.factors), convert(AbstractVector{T}, Q.τ))
QRPackedQ(Q::LinearAlgebra.QRPackedQ) = QRPackedQ(Q.factors, Q.τ)

AbstractQ{T}(Q::QRPackedQ{T}) where {T} = Q
AbstractQ{T}(Q::QRPackedQ) where {T} = QRPackedQ{T}(Q)
convert(::Type{AbstractQ{T}}, Q::QRPackedQ) where {T} = QRPackedQ{T}(Q)

Matrix{T}(Q::QRPackedQ{S}) where {T,S} =
    convert(Matrix{T}, lmul!(Q, Matrix{S}(I, size(Q, 1), min(size(Q.factors)...))))
Matrix(Q::QRPackedQ{S}) where {S} = Matrix{S}(Q)

AbstractMatrix{T}(Q::QRPackedQ) where {T} = Matrix{T}(Q)

size(F::QR, dim::Integer) = size(getfield(F, :factors), dim)
size(F::QR) = size(getfield(F, :factors))

MemoryLayout(::Type{<:QRPackedQ{<:Any,S,T}}) where {S,T} =
    QRPackedQLayout{typeof(MemoryLayout(S)),typeof(MemoryLayout(T))}()

MemoryLayout(::Type{<:QR{<:Any,S,T}}) where {S,T} =
    QRPackedLayout{typeof(MemoryLayout(S)),typeof(MemoryLayout(T))}()

function (\)(A::QR{TA}, B::AbstractVecOrMat{TB}) where {TA,TB}
    require_one_based_indexing(B)
    S = promote_type(TA,TB)
    m, n = size(A)
    m == size(B,1) || throw(DimensionMismatch("Both inputs should have the same number of rows"))

    AA = Factorization{S}(A)

    X = _zeros(S, B, n)
    X[1:size(B, 1), :] = B
    ldiv!(AA, X)
    return _cut_B(X, 1:n)
end

function (\)(A::QR{T}, BIn::VecOrMat{Complex{T}}) where T<:BlasReal
    require_one_based_indexing(BIn)
    m, n = size(A)
    m == size(BIn, 1) || throw(DimensionMismatch("left hand side has $m rows, but right hand side has $(size(BIn,1)) rows"))

# |z1|z3|  reinterpret  |x1|x2|x3|x4|  transpose  |x1|y1|  reshape  |x1|y1|x3|y3|
# |z2|z4|      ->       |y1|y2|y3|y4|     ->      |x2|y2|     ->    |x2|y2|x4|y4|
#                                                 |x3|y3|
#                                                 |x4|y4|
    B = reshape(copy(transpose(reinterpret(T, reshape(BIn, (1, length(BIn)))))), size(BIn, 1), 2*size(BIn, 2))

    X = _zeros(T, B, n)
    X[1:size(B, 1), :] = B

    ldiv!(A, X)

# |z1|z3|  reinterpret  |x1|x2|x3|x4|  transpose  |x1|y1|  reshape  |x1|y1|x3|y3|
# |z2|z4|      <-       |y1|y2|y3|y4|     <-      |x2|y2|     <-    |x2|y2|x4|y4|
#                                                 |x3|y3|
#                                                 |x4|y4|
    XX = reshape(collect(reinterpret(Complex{T}, copy(transpose(reshape(X, div(length(X), 2), 2))))), _ret_size(A, BIn))
    return _cut_B(XX, 1:n)
end

# This file is a modified from Julia's LinearAlgebra/qr.jl. License is MIT: https://julialang.org/license

# QL and Hessenberg Factorizations
"""
    QL <: Factorization

A QL matrix factorization stored in a packed format, typically obtained from
[`ql`](@ref). If ``A`` is an `m`×`n` matrix, then

```math
A = Q L
```

where ``Q`` is an orthogonal/unitary matrix and ``L`` is lower triangular.
The matrix ``Q`` is stored as a sequence of Householder reflectors ``v_i``
and coefficients ``\\tau_i`` where:

```math
Q = \\prod_{i=1}^{\\min(m,n)} (I - \\tau_i v_i v_i^T).
```

Iterating the decomposition produces the components `Q` and `L`.

The object has two fields:

* `factors` is an `m`×`n` matrix.

  - The lower triangular part contains the elements of ``L``, that is `L =
    tril(F.factors)` for a `QL` object `F`.

  - The superdiagonal part contains the reflectors ``v_i`` stored in a packed format where
    ``v_i`` is the ``i``th column of the matrix `V = I + triu(F.factors, 1)`.

* `τ` is a vector  of length `min(m,n)` containing the coefficients ``\tau_i``.

"""
struct QL{T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}} <: Factorization{T}
    factors::S
    τ::Tau

    function QL{T,S,Tau}(factors, τ) where {T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}}
        require_one_based_indexing(factors)
        new{T,S,Tau}(factors, τ)
    end
end
QL(factors::AbstractMatrix{T}, τ::AbstractVector{T}) where {T} = QL{T,typeof(factors),typeof(τ)}(factors, τ)
function QL{T}(factors::AbstractMatrix, τ::AbstractVector) where {T}
    QL(convert(AbstractMatrix{T}, factors), convert(AbstractVector{T}, τ))
end

# iteration for destructuring into components
iterate(S::QL) = (S.Q, Val(:L))
iterate(S::QL, ::Val{:L}) = (S.L, Val(:done))
iterate(S::QL, ::Val{:done}) = nothing

function generic_qlfactUnblocked!(A::AbstractMatrix{T}) where {T}
    require_one_based_indexing(A)
    m, n = size(A)
    τ = zeros(T, min(m,n))
    for k = n:-1:max((n - m + 1 + (T<:Real)),1)
        μ = m+k-n
        x = view(A, μ:-1:1, k)
        τk = reflector!(x)
        τ[k-n+min(m,n)] = τk
        reflectorApply!(x, τk, view(A, μ:-1:1, 1:k-1))
    end
    QL(A, τ)
end


@inline qlfactUnblocked!(A::AbstractMatrix) = generic_qlfactUnblocked!(A)
@inline qlfactUnblocked!(A::StridedMatrix{T}) where T<:BlasFloat = QL(LAPACK.geqlf!(A)...)


# Generic fallbacks

"""
    ql!(A, pivot=Val(false))

`ql!` is the same as [`ql`](@ref) when `A` is a subtype of
`StridedMatrix`, but saves space by overwriting the input `A`, instead of creating a copy.
An [`InexactError`](@ref) exception is thrown if the factorization produces a number not
representable by the element type of `A`, e.g. for integer types.

# Examples
```jldoctest
julia> a = [1. 2.; 3. 4.]
2×2 Array{Float64,2}:
 1.0  2.0
 3.0  4.0

julia> ql!(a)
LinearAlgebra.QLCompactWY{Float64,Array{Float64,2}}
Q factor:
2×2 LinearAlgebra.QLCompactWYQ{Float64,Array{Float64,2}}:
 -0.316228  -0.948683
 -0.948683   0.316228
 L factor:
2×2 Array{Float64,2}:
 -3.16228  -4.42719
  0.0      -0.632456

julia> a = [1 2; 3 4]
2×2 Array{Int64,2}:
 1  2
 3  4

julia> ql!(a)
ERROR: InexactError: Int64(-3.1622776601683795)
Stacktrace:
[...]
```
"""
@inline ql_layout!(layout, axes, A, ::Val{false}) = qlfactUnblocked!(A)
@inline ql_layout!(layout, axes, A) = ql!(A, Val(false))
@inline ql!(A::AbstractMatrix; kwds...) = ql_layout!(MemoryLayout(typeof(A)), axes(A), A; kwds...)
@inline ql!(A::AbstractMatrix, val; kwds...) = ql_layout!(MemoryLayout(typeof(A)), axes(A), A, val; kwds...)

@inline _qleltype(::Type{T}) where T = typeof(zero(T)/sqrt(abs2(one(T))))

"""
    ql(A, pivot=Val(false)) -> F

Compute the QL factorization of the matrix `A`: an orthogonal (or unitary if `A` is
complex-valued) matrix `Q`, and a lower triangular matrix `L` such that

```math
A = Q L
```

The returned object `F` stores the factorization in a packed format:

 - `F` is a [`QL`](@ref) object.

The individual components of the decomposition `F` can be retrieved via property accessors:

 - `F.Q`: the orthogonal/unitary matrix `Q`
 - `F.L`: the lower triangular matrix `L`

Iterating the decomposition produces the components `Q`, `L`, and if extant `p`.

The following functions are available for the `QL` objects: [`inv`](@ref), [`size`](@ref),
and [`\\`](@ref). When `A` is rectangular, `\\` will return a least squares
solution and if the solution is not unique, the one with smallest norm is returned. When
`A` is not full rank, factorization with (column) pivoting is required to obtain a minimum
norm solution.

Multiplication with respect to either full/square or non-full/square `Q` is allowed, i.e. both `F.Q*F.L`
and `F.Q*A` are supported. A `Q` matrix can be converted into a regular matrix with
[`Matrix`](@ref).  This operation returns the "thin" Q factor, i.e., if `A` is `m`×`n` with `m>=n`, then
`Matrix(F.Q)` yields an `m`×`n` matrix with orthonormal columns.  To retrieve the "full" Q factor, an
`m`×`m` orthogonal matrix, use `F.Q*Matrix(I,m,m)`.  If `m<=n`, then `Matrix(F.Q)` yields an `m`×`m`
orthogonal matrix.

# Examples
```jldoctest
julia> A = [3.0 -6.0; 4.0 -8.0; 0.0 1.0]
3×2 Array{Float64,2}:
 3.0  -6.0
 4.0  -8.0
 0.0   1.0

julia> F = ql(A)
LinearAlgebra.QLCompactWY{Float64,Array{Float64,2}}
Q factor:
3×3 LinearAlgebra.QLCompactWYQ{Float64,Array{Float64,2}}:
 -0.6   0.0   0.8
 -0.8   0.0  -0.6
  0.0  -1.0   0.0
L factor:
2×2 Array{Float64,2}:
 -5.0  10.0
  0.0  -1.0

julia> F.Q * F.L == A
true
```
"""
@inline ql(A::AbstractMatrix, args...; kwds...) = ql_layout(MemoryLayout(typeof(A)), axes(A), A, args...; kwds...)

function ql_layout(layout, axes, A, args...; kwds...)
    require_one_based_indexing(A)
    AA = similar(A, _qleltype(eltype(A)), size(A))
    copyto!(AA, A)
    return ql!(AA, args...; kwds...)
end
@inline ql(x::Number, args...; kwds...) = ql(fill(x,1,1), args...; kwds...)
@inline function ql(v::AbstractVector, args...; kwds...)
    require_one_based_indexing(v)
    ql(reshape(v, (length(v), 1)), args...; kwds...)
end

# for backward compatability
const _ql! = ql_layout!
const _ql = ql_layout

# Conversions
QL{T}(A::QL) where {T} = QL(convert(AbstractMatrix{T}, A.factors), convert(AbstractVector{T}, A.τ))
Factorization{T}(A::QL{T}) where {T} = A
Factorization{T}(A::QL) where {T} = QL{T}(A)
AbstractMatrix(F::QL) = F.Q * F.L
AbstractArray(F::QL) = AbstractMatrix(F)
Matrix(F::QL) = Array(AbstractArray(F))
Array(F::QL) = Matrix(F)

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::QL)
    summary(io, F); println(io)
    println(io, "Q factor:")
    show(io, mime, F.Q)
    println(io, "\nL factor:")
    show(io, mime, F.L)
end

@inline function getL(F::QL, _)
    m, n = size(F)
    tril!(getfield(F, :factors)[end-min(m,n)+1:end, 1:n], max(n-m,0))
end
@inline getQ(F::QL, _) = QLPackedQ(getfield(F, :factors), F.τ)

getL(F::QL, ::Tuple{AbstractVector,AbstractVector}) = getL(F, size(F))
getQ(F::QL, ::Tuple{AbstractVector,AbstractVector}) = getQ(F, size(F))

getL(F::QL) = getL(F, axes(F.factors))
getQ(F::QL) = getQ(F, axes(F.factors))

function getproperty(F::QL, d::Symbol)
    if d == :L
        return getL(F)
    elseif d == :Q
        return getQ(F)
    else
        getfield(F, d)
    end
end

propertynames(F::QL, private::Bool=false) =
    (:L, :Q, (private ? fieldnames(typeof(F)) : ())...)


"""
    QLPackedQ <: LinearAlgebra.AbstractQ

The orthogonal/unitary ``Q`` matrix of a QL factorization stored in [`QL`](@ref).
"""
struct QLPackedQ{T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}} <: LayoutQ{T}
    factors::S
    τ::Tau

    function QLPackedQ{T,S,Tau}(factors, τ) where {T,S<:AbstractMatrix{T},Tau<:AbstractVector{T}}
        require_one_based_indexing(factors)
        new{T,S,Tau}(factors, τ)
    end
end
QLPackedQ(factors::AbstractMatrix{T}, τ::AbstractVector{T}) where {T} = QLPackedQ{T,typeof(factors),typeof(τ)}(factors, τ)
function QLPackedQ{T}(factors::AbstractMatrix, τ::AbstractVector) where {T}
    QLPackedQ(convert(AbstractMatrix{T}, factors), convert(AbstractVector{T}, τ))
end

QLPackedQ{T}(Q::QLPackedQ) where {T} = QLPackedQ(convert(AbstractMatrix{T}, Q.factors), convert(AbstractVector{T}, Q.τ))
AbstractQ{T}(Q::QLPackedQ{T}) where {T} = Q
AbstractQ{T}(Q::QLPackedQ) where {T} = QLPackedQ{T}(Q)
convert(::Type{AbstractQ{T}}, Q::QLPackedQ) where {T} = QLPackedQ{T}(Q)

Matrix{T}(Q::QLPackedQ{S}) where {T,S} =
    convert(Matrix{T}, lmul!(Q, Matrix{S}(I, size(Q, 1), min(size(Q.factors)...))))
Matrix(Q::QLPackedQ{S}) where {S} = Matrix{S}(Q)

AbstractMatrix{T}(Q::QLPackedQ) where {T} = Matrix{T}(Q)

size(Q::QLPackedQ, dim::Integer) = size(getfield(Q, :factors), dim == 2 ? 1 : dim)

size(F::QL, dim::Integer) = size(getfield(F, :factors), dim)
size(F::QL) = size(getfield(F, :factors))


## Multiplication by Q
function _mul(A::QLPackedQ, B::AbstractMatrix)
    TAB = promote_type(eltype(A), eltype(B))
    Anew = convert(AbstractQtype{TAB}, A)
    if size(A.factors, 1) == size(B, 1)
        Bnew = copy_oftype(B, TAB)
    elseif size(A.factors, 2) == size(B, 1)
        Bnew = [zeros(TAB, size(A.factors, 1) - size(B,1), size(B, 2)); B]
    else
        throw(DimensionMismatch("first dimension of matrix must have size either $(size(A.factors, 1)) or $(size(A.factors, 2))"))
    end
    lmul!(Anew, Bnew)
end

(*)(A::QLPackedQ, B::StridedMatrix) = _mul(A, B)

### QB
abstract type AbstractQLLayout <: MemoryLayout end

"""
    QLPackedLayout{SLAY,TLAY}()

represents a Packed QL factorization whose
factors are stored with layout SLAY and τ stored with layout TLAY
"""
struct QLPackedLayout{SLAY,TLAY} <: AbstractQLLayout end
struct QLPackedQLayout{SLAY,TLAY} <: AbstractQLayout end
struct AdjQLPackedQLayout{SLAY,TLAY} <: AbstractQLayout end

MemoryLayout(::Type{<:QL{<:Any,Mat,Tau}}) where {Mat,Tau} =
    QLPackedLayout{typeof(MemoryLayout(Mat)),typeof(MemoryLayout(Tau))}()


adjointlayout(::Type, ::QLPackedQLayout{SLAY,TLAY}) where {SLAY,TLAY} = AdjQLPackedQLayout{SLAY,TLAY}()

MemoryLayout(::Type{<:QLPackedQ{<:Any,Mat,Tau}}) where {Mat,Tau} =
    QLPackedQLayout{typeof(MemoryLayout(Mat)),typeof(MemoryLayout(Tau))}()

colsupport(::QLPackedQLayout, Q, j) = minimum(colsupport(Q.factors, j)):size(Q,1)
rowsupport(::QLPackedQLayout, Q, k) = oneto(maximum(rowsupport(Q.factors, k)))
colsupport(::AdjQLPackedQLayout, Q, j) = oneto(maximum(colsupport(Q'.factors, j)))
rowsupport(::AdjQLPackedQLayout, Q, k) = minimum(rowsupport(Q'.factors, k)):size(Q,2)



function materialize!(M::Lmul{<:QLPackedQLayout})
    A,B = M.A, M.B
    require_one_based_indexing(B)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    @inbounds begin
        for k = max(nA - mA + 1,1):nA
            μ = mA+k-nA
            for j = 1:nB
                vBj = B[μ,j]
                for i = 1:μ-1
                    vBj += conj(Afactors[i,k])*B[i,j]
                end
                vBj = A.τ[k-nA+min(mA,nA)]*vBj
                B[μ,j] -= vBj
                for i = 1:μ-1
                    B[i,j] -= Afactors[i,k]*vBj
                end
            end
        end
    end
    B
end


function materialize!(M::Lmul{<:AdjQLPackedQLayout})
    adjA,B = M.A, M.B
    require_one_based_indexing(B)
    A = parent(adjA)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    @inbounds begin
        for k = nA:-1:max(nA - mA + 1,1)
            μ = mA+k-nA
            for j = 1:nB
                vBj = B[μ,j]
                for i = 1:μ-1
                    vBj += conj(Afactors[i,k])*B[i,j]
                end
                vBj = conj(A.τ[k-nA+min(mA,nA)])*vBj
                B[μ,j] -= vBj
                for i = 1:μ-1
                    B[i,j] -= Afactors[i,k]*vBj
                end
            end
        end
    end
    B
end


### QBc/QcBc
function materialize!(M::Rmul{<:Any,<:QLPackedQLayout})
    A,Q = M.A, M.B
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    begin
        for k = nQ:-1:max(nQ - mQ + 1,1)
            μ = mQ+k-nQ
            for i = 1:mA
                vAi = A[i,μ]
                for j = 1:μ-1
                    vAi += A[i,j]*Qfactors[j,k]
                end
                vAi = vAi*Q.τ[k-nQ+min(mQ,nQ)]
                A[i,μ] -= vAi
                for j = 1:μ-1
                    A[i,j] -= vAi*conj(Qfactors[j,k])
                end
            end
        end
    end
    A
end

### AQc
function materialize!(M::Rmul{<:Any,<:AdjQLPackedQLayout})
    A,adjQ = M.A, M.B
    Q = parent(adjQ)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    @inbounds begin
        for k = max(nQ - mQ + 1,1):nQ
            μ = mQ+k-nQ
            for i = 1:mA
                vAi = A[i,μ]
                for j = 1:μ-1
                    vAi += A[i,j]*Qfactors[j,k]
                end
                vAi = vAi*conj(Q.τ[k-nQ+min(mQ,nQ)])
                A[i,μ] -= vAi
                for j = 1:μ-1
                    A[i,j] -= vAi*conj(Qfactors[j,k])
                end
            end
        end
    end
    A
end

# Julia implementation similar to xgelsy
ldiv!(F::QL, B::AbstractVecOrMat) = ArrayLayouts.ldiv!(F, B)

function materialize!(Ldv::Ldiv{<:QLPackedLayout,<:Any,<:Any,<:AbstractMatrix{T}}) where T
    A,B = Ldv.A,Ldv.B
    m, n = size(A)
    minmn = min(m,n)
    mB, nB = size(B)
    ArrayLayouts.lmul!(adjoint(A.Q), view(B, 1:m, :))
    L = A.L
    @inbounds begin
        if n > m # minimum norm solution
            τ = zeros(T,m)
            for k = m:-1:1 # Trapezoid to triangular by elementary operation
                x = view(L, k, [k; m + 1:n])
                τk = reflector!(x)
                τ[k] = conj(τk)
                for i = 1:k - 1
                    vLi = L[i,k]
                    for j = m + 1:n
                        vLi += L[i,j]*x[j - m + 1]'
                    end
                    vLi *= τk
                    L[i,k] -= vLi
                    for j = m + 1:n
                        L[i,j] -= vLi*x[j - m + 1]
                    end
                end
            end
        end
        ArrayLayouts.ldiv!(LowerTriangular(view(L, 1:minmn, :)), view(B, 1:minmn, :))
        if n > m # Apply elementary transformation to solution
            B[m + 1:mB,1:nB] .= zero(T)
            for j = 1:nB
                for k = 1:m
                    vBj = B[k,j]
                    for i = m + 1:n
                        vBj += B[i,j]*L[k,i]'
                    end
                    vBj *= τ[k]
                    B[k,j] -= vBj
                    for i = m + 1:n
                        B[i,j] -= L[k,i]*vBj
                    end
                end
            end
        end
    end
    return B
end
materialize!(Ldv::Ldiv{<:QLPackedLayout,<:Any,<:Any,<:AbstractVector{T}}) where T =
    ldiv!(Ldv.A, reshape(Ldv.B, length(Ldv.B), 1))[:]

function (\)(A::QL{TA}, B::AbstractVecOrMat{TB}) where {TA,TB}
    require_one_based_indexing(B)
    S = promote_type(TA,TB)
    m, n = size(A)
    m == size(B,1) || throw(DimensionMismatch("left hand side has $m rows, but right hand side has $(size(B,1)) rows"))

    AA = Factorization{S}(A)

    X = _zeros(S, B, n)
    X[1:size(B, 1), :] = B
    ldiv!(AA, X)
    return _cut_B(X, 1:n)
end


function (\)(A::QL{T}, BIn::VecOrMat{Complex{T}}) where T<:BlasReal
    require_one_based_indexing(BIn)
    m, n = size(A)
    m == size(BIn, 1) || throw(DimensionMismatch("left hand side has $m rows, but right hand side has $(size(BIn,1)) rows"))

# |z1|z3|  reinterpret  |x1|x2|x3|x4|  transpose  |x1|y1|  reshape  |x1|y1|x3|y3|
# |z2|z4|      ->       |y1|y2|y3|y4|     ->      |x2|y2|     ->    |x2|y2|x4|y4|
#                                                 |x3|y3|
#                                                 |x4|y4|
    B = reshape(copy(transpose(reinterpret(T, reshape(BIn, (1, length(BIn)))))), size(BIn, 1), 2*size(BIn, 2))

    X = _zeros(T, B, n)
    X[1:size(B, 1), :] = B

    ldiv!(A, X)

# |z1|z3|  reinterpret  |x1|x2|x3|x4|  transpose  |x1|y1|  reshape  |x1|y1|x3|y3|
# |z2|z4|      <-       |y1|y2|y3|y4|     <-      |x2|y2|     <-    |x2|y2|x4|y4|
#                                                 |x3|y3|
#                                                 |x4|y4|
    XX = reshape(collect(reinterpret(Complex{T}, copy(transpose(reshape(X, div(length(X), 2), 2))))), _ret_size(A, BIn))
    return _cut_B(XX, 1:n)
end

"""
    Jordan <: Factorization

Jordan canonical form of a square matrix `A = VJV⁻¹`. This
is the return type of [`jordan`](@ref), the corresponding Jordan factorization function.

The individual components of the factorization `F::Jordan` can be accessed via [`getfield`](@ref):

| Component | Description                  |
|:----------|:-----------------------------|
| `F.V`     | `V` generalized eigenvectors |
| `F.J`     | `J` Jordan normal form       |

Iterating the factorization produces the components `F.V` and `F.J`.

# Examples
```jldoctest
julia> A = [5 4 2 1; 0 1 -1 -1; -1 -1 3 0; 1 1 -1 2//1]

julia> λ = [1, 2, 4, 4//1] # you will almost certainly need extremely accurate eigenvalues to proceed

julia> F = jordan(A, λ)
Jordan{Rational{Int64}, Matrix{Rational{Int64}}, Matrix{Rational{Int64}}}
Generalized eigenvectors:
4×4 Matrix{Rational{Int64}}:
  1   1  -1  -1
 -1  -1   0   0
  0   0   1   0
  0   1  -1   0
Jordan normal form:
4×4 Matrix{Rational{Int64}}:
 1  0  0  0
 0  2  0  0
 0  0  4  1
 0  0  0  4

julia> A*F.V == F.V*F.J
true

julia> V, J = jordan(A, λ); # destructuring via iteration

julia> V == F.V && J == F.J
true
```
"""
struct Jordan{T, R <: AbstractMatrix{T}, S <: AbstractMatrix{T}} <: Factorization{T}
    V::R
    J::S
end

Jordan{T}(V::AbstractMatrix, J::AbstractMatrix) where T = Jordan(convert(AbstractMatrix{T}, V), convert(AbstractMatrix{T}, J))
Jordan{T}(F::Jordan) where T = Jordan{T}(F.V, F.J)

iterate(F::Jordan) = (F.V, Val(:J))
iterate(F::Jordan, ::Val{:J}) = (F.J, Val(:done))
iterate(F::Jordan, ::Val{:done}) = nothing

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::Jordan)
    summary(io, F); println(io)
    println(io, "Generalized eigenvectors:")
    show(io, mime, F.V)
    println(io, "\nJordan normal form:")
    show(io, mime, F.J)
end

# dangerous because Jordan blocks are unstable with respect to small perturbations
jordan(A::AbstractMatrix) = jordan(A, eigvals(A))

function jordan(A::AbstractMatrix{S}, λ::AbstractVector{T}) where {S, T}
    V = promote_type(S, T)
    jordan(convert(AbstractMatrix{V}, A), convert(AbstractVector{V}, λ))
end

function jordan(A::AbstractMatrix{T}, λ::AbstractVector{T}) where T
    PLEP, B = block_diagonalize(A, λ)
    F, J = block_diagonal_to_jordan(B)
    V = PLEP*F
    return Jordan(V, J)
end

function triangular_to_psychologically_block_diagonal(U::UpperTriangular{T, <: AbstractMatrix{T}}) where T
    n = checksquare(U)
    R = deepcopy(U)
    EACC = UpperTriangular(Matrix{T}(I, n, n))
    # note that this is sensitive to the order of conjugation.
    for j in 2:n
        for i in j-1:-1:1
            if R[i, i] != R[j, j]
                E = UpperTriangular(Matrix{T}(I, n, n))
                E[i, j] = R[i, j]/(R[j, j] - R[i, i])
                R = E\R*E
                EACC = EACC*E
            end
        end
    end
    return EACC, R
end

function psychologically_block_diagonal_to_block_diagonal(R::UpperTriangular{T, <: AbstractMatrix{T}}) where T
    p = sortperm(diag(R))
    n = length(p)
    P = Matrix{Int}(I, n, n)[:, p]
    B = R[p, p]
    P, B
end

function triangular_to_block_diagonal(U::UpperTriangular{T, <: AbstractMatrix{T}}) where T
    E, R = triangular_to_psychologically_block_diagonal(U)
    p = sortperm(diag(R))
    E[:, p], R[p, p]
end

function block_diagonalize(A::AbstractMatrix{T}, λ::AbstractVector{T}) where T
    F = lulinv(A, λ)
    PLEP, B = triangular_to_block_diagonal(UpperTriangular(F.factors))
    lmul!(UnitLowerTriangular(F.factors), PLEP)
    F.P*PLEP, B
end

function determine_block_sizes(B::AbstractMatrix{T}) where T
    n = checksquare(B)
    if n == 1
        m = [1]
        return m
    else
        m = Int[]
        i = 1
        while i < n
            t = 1
            while (i < n-1) && (B[i, i] == B[i+1, i+1])
                i += 1
                t += 1
            end
            if i == n-1
                if B[i, i] == B[i+1, i+1]
                    t += 1
                    push!(m, t)
                else
                    push!(m, t)
                    push!(m, 1)
                end
            else
                push!(m, t)
            end
            i += 1
        end
        return m
    end
end

function block_diagonal_to_jordan(B::Matrix{T}) where T
    n = checksquare(B)
    m = determine_block_sizes(B)
    cm = cumsum(m)
    pushfirst!(cm, 0)
    F = zeros(T, n, n)
    J = zeros(T, n, n)
    for i in 1:length(m)
        ir = cm[i]+1:cm[i+1]
        FB, JB = upper_triangular_block_to_jordan_blocks(B[ir, ir])
        F[ir, ir] .= FB
        J[ir, ir] .= JB
    end
    return F, J
end

# Contract: B_{i, j} = 0 for i > j. B_{i, i} = B_{j, j} for all i ≠ j.
function upper_triangular_block_to_jordan_blocks(B::Matrix{T}) where T
    n = checksquare(B)
    J = deepcopy(B)
    FACC = Matrix{T}(I, n, n)
    for j in 2:n
        # In column j, we shall introduce zeros in any row with a 1 in the {i, i+1} position.
        F = Matrix{T}(I, n, n)
        for i in 1:j-2
            if !iszero(J[i, i+1])
                F[i+1, j] = -J[i, j]
            end
        end
        J = F\J*F
        FACC = FACC*F
        while count(!iszero, J[1:j-1, j]) > 1
            # Next, we identify the first and next nonzeros in the last column. By the first step, they are across from the last row of a Jordan block.
            i1 = 1
            while i1 < j
                if !iszero(J[i1, j])
                    break
                else
                    i1 += 1
                end
            end
            i2 = i1+1
            while i2 < j
                if !iszero(J[i2, j])
                    break
                else
                    i2 += 1
                end
            end
            # With i1 and i2, we find the sizes of the corresponding Jordan blocks, s and t.
            i1s = i1
            while i1s > 1
                if iszero(J[i1s-1, i1s])
                    break
                else
                    i1s -= 1
                end
            end
            i2s = i2
            while i2s > 1
                if iszero(J[i2s-1, i2s])
                    break
                else
                    i2s -= 1
                end
            end
            i1r = i1s:i1
            i2r = i2s:i2
            s = length(i1r)
            t = length(i2r)
            # Eliminate one of the nonzeros or the other.
            if s ≤ t
                # eliminate α
                F = Matrix{T}(I, n, n)
                α = J[i1, j]
                β = J[i2, j]
                γ = α/β
                F[i1r, i2-s+1:i2] .= Matrix{T}(γ*I, s, s)
                J = F\J*F
                FACC = FACC*F
            else
                # eliminate β
                F = Matrix{T}(I, n, n)
                α = J[i1, j]
                β = J[i2, j]
                γ = β/α
                F[i2r, i1-t+1:i1] .= Matrix{T}(γ*I, t, t)
                J = F\J*F
                FACC = FACC*F
            end
        end
        # Next, we must permute to get the final nonzero to the bottom, if there is one at all.
        i1 = 1
        while i1 < j
            if !iszero(J[i1, j])
                break
            else
                i1 += 1
            end
        end
        if i1 < j-1
            # With i1, we find the size of the corresponding Jordan block, s.
            i1s = i1
            while i1s > 1
                if iszero(J[i1s-1, i1s])
                    break
                else
                    i1s -= 1
                end
            end
            i1r = i1s:i1
            s = length(i1r)
            p = [1:i1s-1; i1+1:j-1; i1r; j:n]
            #P = Matrix{T}(I, n, n)[:, p]
            #J = P'J*P
            #FACC = FACC*P
            J = J[p, p]
            FACC = FACC[:, p]
        end
        # Finally, we must scale off the nonzero entry to 1 to get it to conform to a Jordan block.
        if !iszero(J[j-1, j])
            F = Matrix{T}(I, n, n)
            F[j, j] = inv(J[j-1, j])
            J = F\J*F
            FACC = FACC*F
        end
    end
    return FACC, J
end

export RQ, rq, rq!

"""
    RQ <: Factorization

An RQ matrix factorization stored in a packed format, typically obtained from
[`rq`](@ref). If ``A`` is an `m`×`n` matrix, then

```math
A = [0 R] Q
```

where ``Q`` is an orthogonal/unitary matrix and ``R`` is upper triangular (trapezoidal
if `m < n`).
The matrix ``Q`` is stored as a sequence of Householder reflectors ``v_i``
and coefficients ``\\tau_i`` where:

```math
Q = \\prod_{i=1}^{\\min(m,n)} (I - \\tau_i v_i v_i^T).
```

Iterating the decomposition produces the components `R` and `Q`.

The object has two fields:

* `factors` is an `m`×`n` matrix.

  - The upper triangular part contains the elements of ``R``, that is `R =
    triu(F.factors)` for a `QR` object `F`.

  - The subdiagonal part contains the reflectors ``v_i`` stored in a packed format where
    ``v_i`` is the ``i``th column of the matrix `V = I + tril(F.factors, -1)`.

* `τ` is a vector  of length `min(m,n)` containing the coefficients ``\tau_i``.

"""
struct RQ{T,S<:AbstractMatrix{T}} <: Factorization{T}
    factors::S
    τ::Vector{T}

    function RQ{T,S}(factors, τ) where {T,S<:AbstractMatrix{T}}
        require_one_based_indexing(factors)
        new{T,S}(factors, τ)
    end
end
RQ(factors::AbstractMatrix{T}, τ::Vector{T}) where {T} = RQ{T,typeof(factors)}(factors, τ)
function RQ{T}(factors::AbstractMatrix, τ::AbstractVector) where {T}
    RQ(convert(AbstractMatrix{T}, factors), convert(Vector{T}, τ))
end

# iteration for destructuring into components
iterate(S::RQ) = (S.R, Val(:Q))
iterate(S::RQ, ::Val{:Q}) = (S.Q, Val(:done))
iterate(S::RQ, ::Val{:done}) = nothing

size(F::RQ, dim::Integer) = size(getfield(F, :factors), dim)
size(F::RQ) = size(getfield(F, :factors))

function getproperty(F::RQ, d::Symbol)
    m, n = size(F)
    if d === :R
        if m <= n
            return triu!(getfield(F, :factors)[1:m, n-m+1:n])
        else
            return triu(getfield(F, :factors),min(0,n-m))
        end
    elseif d === :Q
        return RQPackedQ(getfield(F, :factors), F.τ)
    else
        getfield(F, d)
    end
end

"""
    RQPackedQ <: AbstractMatrix

The orthogonal/unitary ``Q`` matrix of an RQ factorization stored in [`RQ`](@ref) format.
"""
struct RQPackedQ{T,S<:AbstractMatrix{T}} <: AbstractQ{T}
    factors::S
    τ::Vector{T}

    function RQPackedQ{T,S}(factors, τ) where {T,S<:AbstractMatrix{T}}
        require_one_based_indexing(factors)
        new{T,S}(factors, τ)
    end
end

# Conversions
RQ{T}(A::RQ) where {T} = RQ(convert(AbstractMatrix{T}, A.factors), convert(AbstractVector{T}, A.τ))
Factorization{T}(A::RQ{T}) where {T} = A
Factorization{T}(A::RQ) where {T} = RQ{T}(A)
AbstractMatrix(F::RQ) = F.R * F.Q
AbstractArray(F::RQ) = AbstractMatrix(F)
Matrix(F::RQ) = Array(AbstractArray(F))
Array(F::RQ) = Matrix(F)

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::RQ)
    summary(io, F); println(io)
    println(io, "R factor:")
    show(io, mime, F.R)
    println(io, "\nQ factor:")
    show(io, mime, F.Q)
end

RQPackedQ(factors::AbstractMatrix{T}, τ::Vector{T}) where {T} = RQPackedQ{T,typeof(factors)}(factors, τ)
function RQPackedQ{T}(factors::AbstractMatrix, τ::AbstractVector) where {T}
    RQPackedQ(convert(AbstractMatrix{T}, factors), convert(Vector{T}, τ))
end
RQPackedQ{T}(Q::RQPackedQ) where {T} = RQPackedQ(convert(AbstractMatrix{T}, Q.factors), convert(Vector{T}, Q.τ))
# this makes the rectangular version, alas.
# function Matrix{T}(Q::RQPackedQ{T}) where {T<:BlasFloat}
#     m,n = size(Q.factors)
#     i0= m > n ? (m-n+1) : 1
#     LAPACK.orgrq!(Q.factors[i0:m,1:n], Q.τ)
# end

Matrix{T}(Q::RQPackedQ{S}) where {T,S} =
    convert(Matrix{T}, lmul!(Q, Matrix{S}(I, size(Q,2), size(Q,2))))
Matrix(Q::RQPackedQ{S}) where {S} = Matrix{S}(Q)

AbstractQ{T}(Q::RQPackedQ{T}) where {T} = Q
AbstractQ{T}(Q::RQPackedQ) where {T} = RQPackedQ{T}(Q)
convert(::Type{AbstractQ{T}}, Q::RQPackedQ) where {T} = RQPackedQ{T}(Q)
AbstractMatrix{T}(Q::RQPackedQ) where {T} = Matrix{T}(Q)

size(Q::RQPackedQ, dim::Integer) = size(getfield(Q, :factors), dim == 1 ? 2 : dim)
size(Q::RQPackedQ) = size(Q, 1), size(Q, 2)

function lmul!(A::RQPackedQ{T,<:StridedMatrix}, B::StridedVecOrMat{T}) where {T<:BlasFloat}
    m,n = size(A.factors)
    if m > n
        return LAPACK.ormrq!('L','N',view(A.factors, m-n+1:m, 1:n),A.τ,B)
    else
        return LAPACK.ormrq!('L','N',A.factors,A.τ,B)
    end
end
function lmul!(A::RQPackedQ, B::AbstractVecOrMat)
    require_one_based_indexing(B)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if nA != mB
        throw(DimensionMismatch("matrix A has dimensions ($nA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    mm = min(mA,nA)
    @inbounds begin
        for k = mm:-1:1
            krow = mA-mm+k
            kcol = nA-mm+k
            for j = 1:nB
                vBj = B[kcol,j]
                for i = 1:kcol-1
                    # vBj += conj(Afactors[i,k])*B[i,j]
                    vBj += (Afactors[krow,i])*B[i,j]
                end
                vBj = conj(A.τ[k])*vBj
                B[kcol,j] -= vBj
                for i = 1:kcol-1
                    # B[i,j] -= Afactors[i,k]*vBj
                    B[i,j] -= conj(Afactors[krow,i])*vBj
                end
            end
        end
    end
    B
end

function (*)(B::StridedMatrix, Q::RQPackedQ)
    TBQ = promote_type(eltype(Q), eltype(B))
    Qnew = convert(AbstractQtype{TBQ}, Q)
    if size(Q.factors, 2) == size(B, 2)
        Bnew = copy_oftype(B, TBQ)
    elseif size(Q.factors, 1) == size(B, 2)
        # People will expect this, misguided though it seems.
        Bnew = hcat(zeros(TBQ, size(B,1), size(Q.factors, 2) - size(B,2)),B)
    else
        throw(DimensionMismatch("first dimension of matrix must have size either $(size(Q.factors, 1)) or $(size(Q.factors, 2))"))
    end
    rmul!(Bnew, Qnew)
end

function lmul!(adjA::AdjointQtype{<:Any,<:RQPackedQ{T,<:StridedMatrix}}, B::StridedVecOrMat{T}
               ) where {T<:BlasReal}
    A = parent(adjA)
    m,n = size(A.factors)
    if m > n
        return LAPACK.ormrq!('L','T',view(A.factors, m-n+1:m, 1:n),A.τ,B)
    else
        return LAPACK.ormrq!('L','T',A.factors,A.τ,B)
    end
end
function lmul!(adjA::AdjointQtype{<:Any,<:RQPackedQ{T,S}}, B::StridedVecOrMat{T}
               ) where {T<:BlasComplex,S<:StridedMatrix}
    A = parent(adjA)
    m,n = size(A.factors)
    if m > n
        return LAPACK.ormrq!('L','C',view(A.factors, m-n+1:m, 1:n),A.τ,B)
    else
        return LAPACK.ormrq!('L','C',A.factors,A.τ,B)
    end
end
function lmul!(adjA::AdjointQtype{<:Any,<:RQPackedQ}, B::AbstractVecOrMat)
    require_one_based_indexing(B)
    A = parent(adjA)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if nA != mB
        throw(DimensionMismatch("matrix A has dimensions ($nA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    mm = min(mA,nA)
    @inbounds begin
        for k = 1:mm
            krow = mA-mm+k
            kcol = nA-mm+k
            for j = 1:nB
                vBj = B[kcol,j]
                for i = 1:kcol-1
                    # vBj += conj(Afactors[i,k])*B[i,j]
                    vBj += (Afactors[krow,i])*B[i,j]
                end
                vBj = A.τ[k]*vBj
                B[kcol,j] -= vBj
                for i = 1:kcol-1
                    # B[i,j] -= Afactors[i,k]*vBj
                    B[i,j] -= conj(Afactors)[krow,i]*vBj
                end
            end
        end
    end
    B
end
function rmul!(A::StridedVecOrMat{T}, B::RQPackedQ{T,S}
               ) where {T<:BlasFloat,S<:StridedMatrix}
    m,n = size(B.factors)
    if m > n
        return LAPACK.ormrq!('R','N',view(B.factors, m-n+1:m, 1:n),B.τ,A)
    else
        return LAPACK.ormrq!('R','N',B.factors,B.τ,A)
    end
end
function rmul!(A::StridedMatrix,Q::RQPackedQ)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != nQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($nQ, $nQ)"))
    end
    Qfactors = Q.factors
    mm = min(mQ, nQ)
    @inbounds begin
        for k = 1:min(mQ,nQ)
            krow = mQ-mm+k
            kcol = nQ-mm+k
            for i = 1:mA
                vAi = A[i,kcol]
                for j = 1:kcol-1
                    # vAi += A[i,j]*Qfactors[j,k]
                    vAi += A[i,j]*conj(Qfactors[krow,j])
                end
                vAi = vAi*conj(Q.τ[k])
                A[i,kcol] -= vAi
                for j = 1:kcol-1
                    # A[i,j] -= vAi*conj(Qfactors[j,k])
                    A[i,j] -= vAi*(Qfactors[krow,j])
                end
            end
        end
    end
    A
end
function rmul!(A::StridedVecOrMat{T}, adjB::AdjointQtype{<:Any,<:RQPackedQ{T}}
               ) where {T<:BlasReal}
    B = parent(adjB)
    m,n = size(B.factors)
    if m > n
        return LAPACK.ormrq!('R','T',view(B.factors, m-n+1:m, 1:n),B.τ,A)
    else
        return LAPACK.ormrq!('R','T',B.factors,B.τ,A)
    end
end
function rmul!(A::StridedVecOrMat{T}, adjB::AdjointQtype{<:Any,<:RQPackedQ{T}}
               ) where {T<:BlasComplex}
    B = parent(adjB)
    m,n = size(B.factors)
    if m > n
        return LAPACK.ormrq!('R','C',view(B.factors, m-n+1:m, 1:n),B.τ,A)
    else
        return LAPACK.ormrq!('R','C',B.factors,B.τ,A)
    end
end
function rmul!(A::StridedMatrix, adjQ::AdjointQtype{<:Any,<:RQPackedQ})
    Q = parent(adjQ)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != nQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($nQ, $nQ)"))
    end
    Qfactors = Q.factors
    mm = min(mQ, nQ)
    @inbounds begin
        for k = min(mQ,nQ):-1:1
            krow = mQ-mm+k
            kcol = nQ-mm+k
            for i = 1:mA
                vAi = A[i,kcol]
                for j = 1:kcol-1
                    # vAi += A[i,j]*Qfactors[j,k]
                    vAi += A[i,j]*conj(Qfactors[krow,j])
                end
                vAi = vAi*Q.τ[k]
                A[i,kcol] -= vAi
                for j = 1:kcol-1
                    # A[i,j] -= vAi*conj(Qfactors[j,k])
                    A[i,j] -= vAi*(Qfactors[krow,j])
                end
            end
        end
    end
    A
end

ldiv!(A::RQ{T}, B::StridedMatrix{S}) where {T,S} = lmul!(adjoint(A.Q), ldiv!(UpperTriangular(A.R), B))
ldiv!(A::RQ{T}, B::StridedVector{S}) where {T,S} = lmul!(adjoint(A.Q), ldiv!(UpperTriangular(A.R), B))

# apply shifted reflector from right
@inline function reflectorYlppa!(x::AbstractVector, τ::Number, A::StridedMatrix)
    require_one_based_indexing(x)
    m, n = size(A)
    if length(x) != n
        throw(DimensionMismatch("reflector has length $(length(x)), which must match the second dimension of matrix A, $n"))
    end
    @inbounds begin
        for j = 1:m
            # dot
            Ajv = A[j, n]
            for i = 1:n-1
                Ajv += A[j, i] * x[i+1]
            end

            Ajv = τ * Ajv

            # ger
            A[j, n] -= Ajv
            for i = 1:n-1
                A[j, i] -= Ajv * x[i+1]'
            end
        end
    end
    return A
end

function _rqfactUnblocked!(A::AbstractMatrix{T}) where {T}
    require_one_based_indexing(A)
    m, n = size(A)
    τ = zeros(T, min(m,n))
    v = zeros(T, max(m,n))
    mm = min(m,n)
    for k = mm:-1:1
        krow = m-mm+k
        kcol = n-mm+k
        v[1] = A[krow,kcol]'
        for i = 2:kcol
            v[i] = A[krow,i-1]'
        end
        x = view(v, 1:kcol)
        if kcol==1 && T<:Real
            τk = zero(T)
        else
            τk = reflector!(x)
        end
        τ[k] = τk
        reflectorYlppa!(x, τk, view(A, 1:krow-1, 1:kcol))
        A[krow,kcol] = v[1]'
        for i = 2:kcol
            A[krow,i-1] = v[i]'
        end
    end
    RQ(A, τ)
end

"""
    rq(A) -> F

Compute the RQ factorization of the matrix `A`: an orthogonal/unitary matrix `Q` and
and upper triangular or trapezoidal matrix `R` such that
```math
A = [0 R] Q
```
The returned object `F` stores the factorization in a packed format [`RQ`](@ref).
Unlike the `QR` factorization this does not handle least squares problems.
If `A` is `m`×`n` then `Q` is `n`×`n` and `R` is `m`×`min(m,n)`.
"""
function rq end

"""
    rq!(A) -> F

The same as [`rq`](@ref), but saves space by overwriting the input `A`.
"""
rq!(A::StridedMatrix{<:BlasFloat}) = RQ(LAPACK.gerqf!(A)...)
rq!(A::StridedMatrix) = _rqfactUnblocked!(A)

rq(x::Number) = rq(fill(x,1,1))
function rq(v::AbstractVector)
    require_one_based_indexing(v)
    rq(reshape(v, (length(v), 1)))
end

# There is a local version of this:
# using LinearAlgebra: _qreltype

function rq(A::AbstractMatrix{T}) where {T}
    require_one_based_indexing(A)
    AA = similar(A, LinearAlgebra._qreltype(T), size(A))
    copyto!(AA, A)
    return rq!(AA)
end

using MatrixFactorizations, LinearAlgebra, Random, ArrayLayouts, Test
using LinearAlgebra: BlasComplex, BlasFloat, BlasReal, rmul!, lmul!, require_one_based_indexing, checksquare

n = 10

# Split n into 2 parts for tests needing two matrices
n1 = div(n, 2)
n2 = 2*n1

Random.seed!(1234321)

areal = randn(n,n)/2
aimg  = randn(n,n)/2
a2real = randn(n,n)/2
a2img  = randn(n,n)/2
breal = randn(n,2)/2
bimg  = randn(n,2)/2

using MatrixFactorizations: RQPackedQ

using MatrixFactorizations: rq, rq!
const Our=MatrixFactorizations

if !isdefined(Base, :FieldError)
    const FieldError = ErrorException
end

@testset "RQ" begin
    @testset "LAPACK $elty" for elty in (Float32,Float64,ComplexF32,ComplexF64)
        @testset "Compare with LAPACK (square $elty)" begin
            n = 10
            A = randn(n,n)
            R, Q = @inferred rq(A)
            Ṟ, Q̄ = Our._rqfactUnblocked!(copy(A))
            fla,τla = LinearAlgebra.LAPACK.gerqf!(copy(A))
            @test Q.factors ≈ fla
            @test Q.τ ≈ τla
            @test Q.factors ≈ Q̄.factors
            @test Q.τ ≈ Q̄.τ
            @test R ≈ Ṟ
            @test Matrix(Q) ≈ Matrix(Q̄)
        end
        @testset "Compare with LAPACK (rectangular $elty)" begin
            n = 10
            A = randn(n,n+2)
            R, Q = rq(A)
            Ṟ, Q̄ = Our._rqfactUnblocked!(copy(A))
            fla,τla = LinearAlgebra.LAPACK.gerqf!(copy(A))
            @test Q.factors ≈ fla
            @test Q.τ ≈ τla
            @test Q.factors ≈ Q̄.factors
            @test Q.τ ≈ Q̄.τ
            @test R ≈ Ṟ
            @test Matrix(Q) ≈ Matrix(Q̄)

            A = randn(n+2,n)
            R, Q = rq(A)
            Ṟ, Q̄ = Our._rqfactUnblocked!(copy(A))
            fla,τla = LinearAlgebra.LAPACK.gerqf!(copy(A))
            @test Q.factors ≈ fla
            @test Q.τ ≈ τla
            @test Q.factors ≈ Q̄.factors
            @test Q.τ ≈ Q̄.τ
            @test R ≈ Ṟ
            @test Matrix(Q) ≈ Matrix(Q̄)
        end
    end
    @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64, BigFloat, Complex{BigFloat}, Int)
    # @testset for eltya in (Float32,ComplexF32)
        raw_a = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
        raw_a2 = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(a2real, a2img) : a2real)
        asym = raw_a' + raw_a                  # symmetric indefinite
        apd  = raw_a' * raw_a                 # symmetric positive-definite
        ε = εa = eps(abs(float(one(eltya))))

        @testset for eltyb in (Float32, Float64, ComplexF32, ComplexF64, Int)
        # @info "stubbed eltyb loop"
        # @testset for eltyb in (eltya, )
            raw_b = eltyb == Int ? rand(1:5, n, 2) : convert(Matrix{eltyb}, eltyb <: Complex ? complex.(breal, bimg) : breal)
            εb = eps(abs(float(one(eltyb))))
            ε = max(εa, εb)
            tab = promote_type(eltya, eltyb)

            @testset "RQ decomposition of a Number" begin
                α = rand(eltyb)
                aα = fill(α, 1, 1)
                @test rq(α).R * rq(α).Q ≈ rq(aα).R * rq(aα).Q
                @test abs(rq(α).Q[1,1]) ≈ one(eltyb)
            end

            for (a, b) in ((raw_a, raw_b),
                (view(raw_a, 1:n-1, 1:n-1), view(raw_b, 1:n-1, 1)))
                a_1 = size(a, 1)
                @testset "RQ decomposition" begin
                    rqa   = @inferred rq(a)
                    @inferred rq(a)
                    q, r  = rqa.Q, rqa.R
                    @test_throws FieldError rqa.Z
                    @test q[1,1] ≈ Matrix(q)[1,1]
                    @test q[1:2,1:2] ≈ Matrix(q)[1:2,1:2]
                    @test q'*q ≈ Matrix(I, a_1, a_1)
                    @test q*q' ≈ Matrix(I, a_1, a_1)
                    @test q'*Matrix(1.0I, a_1, a_1)' ≈ Matrix(q')
                    @test q'q ≈ Matrix(I, a_1, a_1)
                    @test Matrix(1.0I, a_1, a_1)'q' ≈ Matrix(q')
                    @test r*q ≈ a
                    @test a*(rqa\b) ≈ b atol=5000ε
                    @test Array(rqa) ≈ a
                    sq = size(q.factors, 2)
                    @test *(Matrix{eltyb}(I, sq, sq), adjoint(q)) * q ≈ Matrix(I, sq, sq) atol=5000ε
                    if eltya != Int
                        @test Matrix{eltyb}(I, a_1, a_1)*q ≈ squareQ(convert(LinearAlgebra.AbstractQ{tab}, q))
                        ac = copy(a)
                        # would need rectangular ldiv! method
                        @test_throws DimensionMismatch rq!(a[:, 1:5])\b == rq!(view(ac, :, 1:5))\b
                    end
                    rqstring = sprint((t, s) -> show(t, "text/plain", s), rqa)
                    rstring  = sprint((t, s) -> show(t, "text/plain", s), r)
                    qstring  = sprint((t, s) -> show(t, "text/plain", s), q)
                    @test rqstring == "$(summary(rqa))\nR factor:\n$rstring\nQ factor:\n$qstring"
                end
            end
            if eltya != Int
                @testset "Matmul with RQ factorizations" begin
                    a = raw_a

                    rqa = rq(a[:,1:n1])
                    q, r = rqa.Q, rqa.R
                    @test rmul!(copy(q'), q) ≈ Matrix(I, n1, n1)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n1+1, n1+1),q)
                    @test rmul!(copy(q), adjoint(q)) ≈ Matrix(I, n1, n1)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n1+1, n1+1),adjoint(q))
                    @test_throws ErrorException size(q,-1)
                    @test_throws DimensionMismatch q * Matrix{Int8}(I, n+4, n+4)
                end
            end
        end
        @testset "Wide RQ" begin
            m = n-2
            A = raw_a[1:m,1:n]
            R,Q = rq(A)
            @test Q'*Q ≈ Matrix(I, n, n)
            @test istriu(R)
            @test hcat(zeros(m,n-m),R)*Q ≈ A
            # test the perverse padded product
            @test R*Q ≈ A
            Qm = Matrix(Q)
            @test Qm' * Qm ≈ Matrix(I, n, n)
            @test hcat(zeros(m,n-m),R)*Qm ≈ A
        end
        @testset "Tall RQ" begin
            p = n-2
            A = raw_a[1:n,1:p]
            R,Q = rq(A)
            @test Q'*Q ≈ Matrix(I, p, p)
            @test istriu(R,p-n)
            @test R*Q ≈ A
            Qm = Matrix(Q)
            @test Qm' * Qm ≈ Matrix(I, p, p)
            @test R*Qm ≈ A
        end
    end

    @testset "Issue 7304" begin
        A = [-√.5 -√.5; -√.5 √.5]
        Q = rq(A).Q
        @test norm(A+Matrix(Q)) < eps()
    end

    @testset "rq on AbstractVector" begin
        vl = [3.0, 4.0]
        for Tl in (Float32, Float64)
            for T in (Tl, Complex{Tl})
                v = convert(Vector{T}, vl)
                nv, nm = rq(v)
                @test nv*nm ≈ v
            end
        end
    end

    @testset "Issue 24589. Promotion of rational matrices" begin
        A = rand(1//1:5//5, 4,3)
        @test first(rq(A)) == first(rq(float(A)))
    end

    # omit "Issue Test Factorization fallbacks for rectangular problems"

    @testset "lmul!/rmul! $elty" for elty in (:real, :cplx)
        s = elty == :real ? 0.0 : 0.25im
        A = randn(100,100) .+ s
        R,Q = rq(A)
        x = randn(100) .+ s
        b = randn(100,2) .+ s
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100) .+ s
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')

        A = randn(103,100) .+ s
        R,Q = rq(A)
        x = randn(100) .+ s
        b = randn(100,2) .+ s
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100) .+ s
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')
    end

    @testset "AbstractMatrix conversion" begin
        Q = rq(randn(5,5)).Q
        @test AbstractMatrix{Float64}(Q) isa Matrix{Float64}
    end
end

"""
    LULinv <: Factorization

Matrix factorization type of the `LUL⁻¹` factorization of a square matrix `A`. This
is the return type of [`lulinv`](@ref), the corresponding matrix factorization function.

The individual components of the factorization `F::LULinv` can be accessed via [`getproperty`](@ref):

| Component | Description                                 |
|:----------|:--------------------------------------------|
| `F.L`     | `L` (unit lower triangular) part of `LUL⁻¹` |
| `F.U`     | `U` (upper triangular) part of `LUL⁻¹`      |
| `F.p`     | (right) permutation `Vector`                |
| `F.P`     | (right) permutation `Matrix`                |

Iterating the factorization produces the components `F.L` and `F.U`.

# Examples
```jldoctest
julia> A = [4 3; 6 3]
2×2 Array{Int64,2}:
 4  3
 6  3

julia> F = lulinv(A)
LULinv{Float64, Matrix{Float64}}
L factor:
2×2 Matrix{Float64}:
  1.0      0.0
 -1.59067  1.0
U factor:
2×2 Matrix{Float64}:
 -0.772002  3.0
  0.0       7.772

julia> F.L * F.U / F.L ≈ A[F.p, F.p]
true

julia> l, u, p = lulinv(A); # destructuring via iteration

julia> l == F.L && u == F.U && p == F.p
true

julia> A = [-150 334 778; -89 195 464; 5 -10 -27]
3×3 Matrix{Int64}:
 -150  334  778
  -89  195  464
    5  -10  -27

julia> F = lulinv(A, [17, -2, 3//1]) # can input rational eigenvalues directly
LULinv{Rational{Int64}, Matrix{Rational{Int64}}}
L factor:
3×3 Matrix{Rational{Int64}}:
  1      0    0
 1//2    1    0
  0    -2//5  1
U factor:
3×3 Matrix{Rational{Int64}}:
 17  114//5  778
  0    -2     75
  0     0      3

julia> F.L * F.U / F.L == A[F.p, F.p]
true
```
"""
struct LULinv{T, S <: AbstractMatrix{T}, IPIV <: AbstractVector{<:Integer}} <: Factorization{T}
    factors::S
    ipiv::IPIV
    function LULinv{T, S, IPIV}(factors, ipiv) where {T, S <: AbstractMatrix{T}, IPIV <: AbstractVector{<:Integer}}
        require_one_based_indexing(factors)
        new{T, S, IPIV}(factors, ipiv)
    end
end


LULinv(factors::AbstractMatrix{T}, ipiv::AbstractVector{<:Integer}) where T = LULinv{T, typeof(factors), typeof(ipiv)}(factors, ipiv)
LULinv{T}(factors::AbstractMatrix, ipiv::AbstractVector{<:Integer}) where T = LULinv(convert(AbstractMatrix{T}, factors), ipiv)
LULinv{T}(F::LULinv) where T = LULinv{T}(F.factors, F.ipiv)

iterate(F::LULinv) = (F.L, Val(:U))
iterate(F::LULinv, ::Val{:U}) = (F.U, Val(:p))
iterate(F::LULinv, ::Val{:p}) = (F.p, Val(:done))
iterate(F::LULinv, ::Val{:done}) = nothing


function lulinvtype(T::Type)
    # In generic_ulfact!, the elements of the lower part of the matrix are
    # obtained using the division of two matrix elements. Hence their type can
    # be different (e.g. the division of two types with the same unit is a type
    # without unit).
    # The elements of the upper part are obtained by U - L * U / L
    # where U is an upper part element and L is a lower part element.
    # Therefore, the types LT, UT should be invariant under the map:
    # (LT, UT) -> begin
    #     L = oneunit(UT) / oneunit(UT)
    #     U = oneunit(UT) - L * oneunit(UT) / L
    #     typeof(L), typeof(U)
    # end
    # The following should handle most cases
    UT = typeof(oneunit(T) - (oneunit(T) / (oneunit(T) + zero(T)) * oneunit(T) * (oneunit(T) + zero(T)) / oneunit(T)))
    LT = typeof(oneunit(UT) / oneunit(UT))
    S = promote_type(T, LT, UT)
end


size(A::LULinv)    = size(getfield(A, :factors))
size(A::LULinv, i) = size(getfield(A, :factors), i)

function getL(F::LULinv{T}) where T
    n = size(F.factors, 1)
    L = tril!(getindex(getfield(F, :factors), 1:n, 1:n))
    for i in 1:n L[i, i] = one(T) end
    return L
end

function getU(F::LULinv)
    n = size(F.factors, 1)
    triu!(getindex(getfield(F, :factors), 1:n, 1:n))
end

function getproperty(F::LULinv{T, <: AbstractMatrix}, d::Symbol) where T
    n = size(F, 1)
    if d === :L
        return getL(F)
    elseif d === :U
        return getU(F)
    elseif d === :p
        return getfield(F, :ipiv)
    elseif d === :P
        return Matrix{T}(I, n, n)[:, F.p]
    else
        getfield(F, d)
    end
end

propertynames(F::LULinv, private::Bool=false) =
    (:L, :U, :p, :P, (private ? fieldnames(typeof(F)) : ())...)

function show(io::IO, mime::MIME{Symbol("text/plain")}, F::LULinv)
    summary(io, F); println(io)
    println(io, "L factor:")
    show(io, mime, F.L)
    println(io, "\nU factor:")
    show(io, mime, F.U)
end


lulinv(A::AbstractMatrix, pivot::Union{Val{false}, Val{true}}=Val(true); kwds...) = lulinv(A, eigvals(A), pivot; kwds...)
function lulinv(A::AbstractMatrix{T}, λ::AbstractVector{T}, pivot::Union{Val{false}, Val{true}}=Val(true); kwds...) where T
    S = lulinvtype(T)
    lulinv!(copy_oftype(A, S), copy_oftype(λ, S), pivot; kwds...)
end
function lulinv(A::AbstractMatrix{T1}, λ::AbstractVector{T2}, pivot::Union{Val{false}, Val{true}}=Val(true); kwds...) where {T1, T2}
    T = promote_type(T1, T2)
    S = lulinvtype(T)
    lulinv!(copy_oftype(A, S), copy_oftype(λ, S), pivot; kwds...)
end

function lulinv!(A::Matrix{T}, λ::Vector{T}, ::Val{Pivot} = Val(true); rtol::Real = size(A, 1)*eps(real(float(oneunit(T))))) where {T, Pivot}
    n = checksquare(A)
    n == length(λ) || throw(ArgumentError("Eigenvalue count does not match matrix dimensions."))
    v = zeros(T, n)
    ipiv = collect(1:n)
    for i in 1:n
        F = ul!(view(A, i:n, i:n) - λ[i]*I; check = false)
        nrm = norm(F.L)
        if Pivot
            ip = n+1-i
            while (ip > 1) && (norm(F.L[ip, ip]) > rtol*nrm)
                ip -= 1
            end
            fill!(v, zero(T))
            v[i] = one(T)
            idx = ip+1:n+1-i
            if !isempty(idx)
                v[idx.+(i-1)] .= -F.L[idx, ip]
                ldiv!(LowerTriangular(view(F.L, idx, idx)), view(v, idx.+(i-1)))
            end
            ip = ip+i-1
            if ip ≠ i
                tmp = ipiv[i]
                ipiv[i] = ipiv[ip]
                ipiv[ip] = tmp
                for j in 1:n
                    tmp = A[i, j]
                    A[i, j] = A[ip, j]
                    A[ip, j] = tmp
                end
                for j in 1:n
                    tmp = A[j, i]
                    A[j, i] = A[j, ip]
                    A[j, ip] = tmp
                end
            end
        else
            fill!(v, zero(T))
            v[i] = one(T)
            idx = 2:n+1-i
            if !isempty(idx)
                v[idx.+(i-1)] .= -F.L[idx, 1]
                ldiv!(LowerTriangular(view(F.L, idx, idx)), view(v, idx.+(i-1)))
            end
        end
        for k in 1:n
            for j in i+1:n
                A[k, i] += A[k, j]*v[j]
            end
        end
        for j in i:n
            for k in i+1:n
                A[k, j] -= A[i, j]*v[k]
            end
        end
        for k in i+1:n
            A[k, i] = v[k]
        end
    end
    return LULinv(A, ipiv)
end

function ldiv!(A::LULinv, B::AbstractVecOrMat)
    B .= B[invperm(A.p), :] # Todo: fix me
    L = UnitLowerTriangular(A.factors)
    lmul!(L, ldiv!(UpperTriangular(A.factors), ldiv!(L, B)))
    B .= B[A.p, :] # Todo: fix me
    return B
end

function rdiv!(A::AbstractVecOrMat, B::LULinv)
    A .= A[:, B.p] # Todo: fix me
    L = UnitLowerTriangular(B.factors)
    rdiv!(rdiv!(rmul!(A, L), UpperTriangular(B.factors)), L)
    A .= A[:, invperm(B.p)] # Todo: fix me
    return A
end

det(F::LULinv) = det(UpperTriangular(F.factors))
logabsdet(F::LULinv) = logabsdet(UpperTriangular(F.factors))

module MatrixFactorizationsBandedMatricesExt
using BandedMatrices, MatrixFactorizations, LinearAlgebra
using MatrixFactorizations.ArrayLayouts
import MatrixFactorizations: ql, ql!, QLPackedQLayout, AdjQLPackedQLayout, QL
import ArrayLayouts: materialize!, reflector!, reflectorApply!
import LinearAlgebra: ldiv!
using BandedMatrices: bandeddata
using Base: require_one_based_indexing
###
# QL
###


ql(A::BandedMatrix{T}) where T = ql!(BandedMatrix{float(T)}(A, (max(bandwidth(A,1),bandwidth(A,1)+bandwidth(A,2)+size(A,1)-size(A,2)),bandwidth(A,2))))

ql!(A::BandedMatrix) = banded_ql!(A)

function banded_ql!(L::BandedMatrix{T}) where T
    D = bandeddata(L)
    l,u = bandwidths(L)
    ν = l+u+1
    m,n=size(L)
    τ = zeros(T, min(m,n))

    for k = n:-1:max((n - m + 1 + (T<:Real)),1)
        μ = m+k-n
        x = view(D,u+1+μ-k:-1:max(1,u-k+2), k)
        τk = reflector!(x)
        τ[k-n+min(m,n)] = τk
        N = length(x)
        for j = max(1,μ-l):k-1
            reflectorApply!(x, τk, view(D, u+1+μ-j:-1:u+2+μ-j-N,j))
        end
    end
    QL(L, τ)
end

function materialize!(M::Lmul{<:QLPackedQLayout{<:AbstractBandedLayout}})
    A,B = M.A,M.B
    require_one_based_indexing(B)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    l,u = bandwidths(Afactors)
    D = bandeddata(Afactors)
    for k = max(nA - mA + 1,1):nA
        μ = mA+k-nA
        for j = 1:nB
            vBj = B[μ,j]
            for i = max(1,k-u):μ-1
                vBj += conj(D[i-k+u+1,k])*B[i,j]
            end
            vBj = A.τ[k-nA+min(mA,nA)]*vBj
            B[μ,j] -= vBj
            for i = max(1,k-u):μ-1
                B[i,j] -= D[i-k+u+1,k]*vBj
            end
        end
    end
    B
end

function materialize!(M::Lmul{<:AdjQLPackedQLayout{<:AbstractBandedLayout}})
    adjA,B = M.A,M.B
    require_one_based_indexing(B)
    A = parent(adjA)
    mA, nA = size(A.factors)
    mB, nB = size(B,1), size(B,2)
    if mA != mB
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but B has dimensions ($mB, $nB)"))
    end
    Afactors = A.factors
    l,u = bandwidths(Afactors)
    D = bandeddata(Afactors)
    @inbounds begin
        for k = nA:-1:max(nA - mA + 1,1)
            μ = mA+k-nA
            for j = 1:nB
                vBj = B[μ,j]
                for i = max(1,k-u):μ-1
                    vBj += conj(D[i-k+u+1,k])*B[i,j]
                end
                vBj = conj(A.τ[k-nA+min(mA,nA)])*vBj
                B[μ,j] -= vBj
                for i = max(1,k-u):μ-1
                    B[i,j] -= D[i-k+u+1,k]*vBj
                end
            end
        end
    end
    B
end

### QBc/QcBc
function materialize!(M::Rmul{<:Any,<:QLPackedQLayout{<:AbstractBandedLayout}})
    A,Q = M.A,M.B
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    l,u = bandwidths(Qfactors)
    D = Qfactors.data
    @inbounds begin
        for k = nQ:-1:max(nQ - mQ + 1,1)
            μ = mQ+k-nQ
            for i = 1:mA
                vAi = A[i,μ]
                for j = max(1,k-u):μ-1
                    vAi += A[i,j]*D[j-k+u+1,k]
                end
                vAi = vAi*Q.τ[k-nQ+min(mQ,nQ)]
                A[i,μ] -= vAi
                for j = max(1,k-u):μ-1
                    A[i,j] -= vAi*conj(D[j-k+u+1,k])
                end
            end
        end
    end
    A
end

### AQc
function materialize!(M::Rmul{<:Any,<:AdjQLPackedQLayout{<:AbstractBandedLayout}})
    A,adjQ = M.A,M.B
    Q = parent(adjQ)
    mQ, nQ = size(Q.factors)
    mA, nA = size(A,1), size(A,2)
    if nA != mQ
        throw(DimensionMismatch("matrix A has dimensions ($mA,$nA) but matrix Q has dimensions ($mQ, $nQ)"))
    end
    Qfactors = Q.factors
    l,u = bandwidths(Qfactors)
    D = Qfactors.data
    @inbounds begin
        for k = max(nQ - mQ + 1,1):nQ
            μ = mQ+k-nQ
            for i = 1:mA
                vAi = A[i,μ]
                for j = max(1,k-u):μ-1
                    vAi += A[i,j]*D[j-k+u+1,k]
                end
                vAi = vAi*conj(Q.τ[k-nQ+min(mQ,nQ)])
                A[i,μ] -= vAi
                for j = max(1,k-u):μ-1
                    A[i,j] -= vAi*conj(D[j-k+u+1,k])
                end
            end
        end
    end
    A
end




function _banded_widerect_ldiv!(A::QL, B)
    error("Not implemented")
end
function _banded_longrect_ldiv!(A::QL, B)
    error("Not implemented")
end
function _banded_square_ldiv!(A::QL, B)
    L = A.factors
    lmul!(adjoint(A.Q), B)
    B .= Ldiv(LowerTriangular(L), B)
    B
end

for Typ in (:StridedVector, :StridedMatrix, :AbstractVecOrMat)
    @eval function ldiv!(A::QL{T,<:BandedMatrix}, B::$Typ{T}) where T
        m, n = size(A)
        if m == n
            _banded_square_ldiv!(A, B)
        elseif n > m
            _banded_widerect_ldiv!(A, B)
        else
            _banded_longrect_ldiv!(A, B)
        end
    end
end

end # module

using MatrixFactorizations, ArrayLayouts, Test

@testset "QL" begin
    @testset "Compare with QR" begin
        n = 10
        A = randn(n,n)
        Q̃, R = @inferred qr(A[end:-1:1,end:-1:1])
        Q, L = @inferred ql(A)
        Q̄, L̄ = MatrixFactorizations.generic_qlfactUnblocked!(copy(A))
        @test Q.factors ≈ Q̄.factors
        @test Q.τ ≈ Q̄.τ
        @test R[end:-1:1,end:-1:1] ≈ L ≈ L̄
        @test Q̃[end:-1:1,end:-1:1] ≈ Matrix(Q) ≈ Matrix(Q̄)
        @test copy(Q) ≡ Q

        A = randn(n,n+2)
        Q̃, R = qr(A[end:-1:1,end:-1:1])
        Q, L = ql(A)
        Q̄, L̄ = MatrixFactorizations.generic_qlfactUnblocked!(copy(A))
        @test Q.factors ≈ Q̄.factors
        @test Q.τ ≈ Q̄.τ
        @test R[end:-1:1,end:-1:1] ≈ L ≈ L̄
        @test Q̃[end:-1:1,end:-1:1] ≈ Matrix(Q) ≈ Matrix(Q̄)

        A = randn(n+2,n)
        Q̃, R = qr(A[end:-1:1,end:-1:1])
        Q, L = ql(A)
        Q̄, L̄ = MatrixFactorizations.generic_qlfactUnblocked!(copy(A))
        @test Q.factors ≈ Q̄.factors
        @test Q.τ ≈ Q̄.τ
        @test R[end:-1:1,end:-1:1] ≈ L ≈ L̄
        @test Q̃[end:-1:1,end:-1:1] ≈ squareQ(Q) ≈ squareQ(Q̄)
    end

    @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64, BigFloat, Int)
        raw_a = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
        raw_a2 = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(a2real, a2img) : a2real)
        asym = raw_a' + raw_a                  # symmetric indefinite
        apd  = raw_a' * raw_a                 # symmetric positive-definite
        ε = εa = eps(abs(float(one(eltya))))

        @testset for eltyb in (Float32, Float64, ComplexF32, ComplexF64, Int)
            raw_b = eltyb == Int ? rand(1:5, n, 2) : convert(Matrix{eltyb}, eltyb <: Complex ? complex.(breal, bimg) : breal)
            εb = eps(abs(float(one(eltyb))))
            ε = max(εa, εb)
            tab = promote_type(eltya, eltyb)

            @testset "QL decomposition of a Number" begin
                α = rand(eltyb)
                aα = fill(α, 1, 1)
                @test ql(α).Q * ql(α).L ≈ ql(aα).Q * ql(aα).L
                @test abs(ql(α).Q[1,1]) ≈ one(eltyb)
            end

            for (a, b) in ((raw_a, raw_b),
                (view(raw_a, 1:n-1, 1:n-1), view(raw_b, 1:n-1, 1)))
                a_1 = size(a, 1)
                @testset "QL decomposition (without pivoting)" begin
                    qla   = @inferred ql(a)
                    @inferred ql(a)
                    q, l  = qla.Q, qla.L
                    @test_throws FieldError qla.Z
                    @test q'*squareQ(q) ≈ Matrix(I, a_1, a_1)
                    @test q*squareQ(q)' ≈ Matrix(I, a_1, a_1)
                    @test q'*Matrix(1.0I, a_1, a_1)' ≈ squareQ(q)'
                    @test squareQ(q)'q ≈ Matrix(I, a_1, a_1)
                    @test Matrix(1.0I, a_1, a_1)'q' ≈ squareQ(q)'
                    @test q*l ≈ a
                    @test a*(qla\b) ≈ b atol=5000ε
                    @test Array(qla) ≈ a
                    sq = size(q.factors, 2)
                    @test *(Matrix{eltyb}(I, sq, sq), adjoint(q)) * squareQ(q) ≈ Matrix(I, sq, sq) atol=5000ε
                    if eltya != Int
                        @test Matrix{eltyb}(I, a_1, a_1)*q ≈ squareQ(convert(AbstractQtype{tab}, q))
                        ac = copy(a)
                        @test ql!(a[:, 1:5])\b == ql!(view(ac, :, 1:5))\b
                    end
                    qlstring = sprint((t, s) -> show(t, "text/plain", s), qla)
                    rstring  = sprint((t, s) -> show(t, "text/plain", s), l)
                    qstring  = sprint((t, s) -> show(t, "text/plain", s), q)
                    @test qlstring == "$(summary(qla))\nQ factor:\n$qstring\nL factor:\n$rstring"
                end
                @testset "Thin QL decomposition (without pivoting)" begin
                    qla   = @inferred ql(a[:, 1:n1], Val(false))
                    @inferred ql(a[:, 1:n1], Val(false))
                    q,l   = qla.Q, qla.L
                    @test_throws FieldError qla.Z
                    @test q'*squareQ(q) ≈ Matrix(I, a_1, a_1)
                    @test q'*rectangularQ(q) ≈ Matrix(I, a_1, n1)
                    @test q*l ≈ a[:, 1:n1]
                    @test q*b[1:n1] ≈ rectangularQ(q)*b[1:n1] atol=100ε
                    @test q*b ≈ squareQ(q)*b atol=100ε
                    @test_throws DimensionMismatch q*b[1:n1 + 1]
                    @test_throws DimensionMismatch b[1:n1 + 1]*q'
                    sq = size(q.factors, 1)
                    @test *(LowerTriangular(Matrix{eltyb}(I, sq, sq)), adjoint(q))*squareQ(q) ≈ Matrix(I, a_1, a_1) atol=5000ε
                    if eltya != Int
                        @test Matrix{eltyb}(I, a_1, a_1)*q ≈ squareQ(convert(LinearAlgebra.AbstractQ{tab}, q))
                    end
                end
            end
            if eltya != Int
                @testset "Matmul with QL factorizations" begin
                    a = raw_a

                    qla = ql(a[:,1:n1], Val(false))
                    q, l = qla.Q, qla.L
                    @test rmul!(copy(squareQ(q)'), q) ≈ Matrix(I, n, n)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n+1, n+1),q)
                    @test rmul!(squareQ(q), adjoint(q)) ≈ Matrix(I, n, n)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n+1, n+1),adjoint(q))
                    @test_throws ErrorException size(q,-1)
                    @test_throws DimensionMismatch q * Matrix{Int8}(I, n+4, n+4)
                end
            end
        end
    end


    @testset "Issue 7304" begin
        A = [-√.5 -√.5; -√.5 √.5]
        Q = rectangularQ(ql(A).Q)
        @test norm(A+Q) < eps()
    end

    @testset "ql on AbstractVector" begin
        vl = [3.0, 4.0]
        for Tl in (Float32, Float64)
            for T in (Tl, Complex{Tl})
                v = convert(Vector{T}, vl)
                nv, nm = ql(v)
                @test nv*nm ≈ v
            end
        end
    end

    @testset "Issue 24589. Promotion of rational matrices" begin
        A = rand(1//1:5//5, 4,3)
        @test Matrix(first(ql(A))) == Matrix(first(ql(float(A))))
    end

    @testset "Issue Test Factorization fallbacks for rectangular problems" begin
        A  = randn(3,2)
        Ac = copy(A')
        b  = randn(3)
        b0 = copy(b)
        c  = randn(2)
        @test_broken A \b ≈ ldiv!(c, ql(A ), b)
    end

    @testset "Wide QL" begin
        A = randn(3,5)
        Q,L = ql(A)
        @test Q*L ≈ A
    end

    @testset "lmul!/rmul!" begin
        A = randn(100,100)
        Q,L = ql(A)
        x = randn(100)
        b = randn(100,2)
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100)
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')

        A = randn(100,103)
        Q,L = ql(A)
        x = randn(100)
        b = randn(100,2)
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100)
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')
    end

    @testset "Q * Tri" begin
        A = randn(5,5)
        Q,L = ql(A)
        @test Q * LowerTriangular(L) ≈ A
        @test LowerTriangular(L) * Q ≈ L * Q
        @test Q' * LowerTriangular(L) ≈ Q' * L
        @test LowerTriangular(L)' * Q' ≈ A'
    end

    @testset "row/col slices via copymutable" begin
        n = 5
        A = randn(n,n)
        Q, L = ql(A)
        @test Q[2,3:4] == [Q[2,k] for k=3:4]
        @test Q[3:4,2] == [Q[k,2] for k=3:4]
    end

    @testset "Q * Q" begin
        Q = ql(randn(5,5)).Q
        @test Q*Q ≈ Matrix(Q)^2
    end

    @testset "row/colsupport" begin
        n = 10
        B = Bidiagonal(randn(n), randn(n-1), :U)
        Q = ql(B).Q
        Q = MatrixFactorizations.QLPackedQ(Tridiagonal(Q.factors), Q.τ)
        @test rowsupport(Q, 4) ≡ colsupport(Q', 4) ≡ Base.OneTo(5)
        @test colsupport(Q, 4) ≡ rowsupport(Q', 4) ≡ 3:10
    end

    @testset "AbstractMatrix conversion" begin
        Q = ql(randn(5,5)).Q
        @test AbstractMatrix{Float64}(Q) isa Matrix{Float64}
    end
end

using MatrixFactorizations, ArrayLayouts, Test

n = 10

# Split n into 2 parts for tests needing two matrices
n1 = div(n, 2)
n2 = 2*n1

Random.seed!(1234321)

areal = randn(n,n)/2
aimg  = randn(n,n)/2
a2real = randn(n,n)/2
a2img  = randn(n,n)/2
breal = randn(n,2)/2
bimg  = randn(n,2)/2

# helper functions to unambiguously recover explicit forms of an implicit QL Q
squareQ(Q::LinearAlgebra.AbstractQ) = (sq = size(Q.factors, 1); lmul!(Q, Matrix{eltype(Q)}(I, sq, sq)))
rectangularQ(Q::LinearAlgebra.AbstractQ) = Matrix(Q) # convert(Array, Q)

@testset "QR" begin
    @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64, BigFloat, Int)
        raw_a = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
        raw_a2 = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(a2real, a2img) : a2real)
        asym = raw_a' + raw_a                  # symmetric indefinite
        apd  = raw_a' * raw_a                 # symmetric positive-definite
        ε = εa = eps(abs(float(one(eltya))))

        @testset for eltyb in (Float32, Float64, ComplexF32, ComplexF64, Int)
            raw_b = eltyb == Int ? rand(1:5, n, 2) : convert(Matrix{eltyb}, eltyb <: Complex ? complex.(breal, bimg) : breal)
            εb = eps(abs(float(one(eltyb))))
            ε = max(εa, εb)
            tab = promote_type(eltya, eltyb)

            @testset "QR decomposition of a Number" begin
                α = rand(eltyb)
                aα = fill(α, 1, 1)
                @test qrunblocked(α).Q * qrunblocked(α).R ≈ qrunblocked(aα).Q * qrunblocked(aα).R
                @test abs(qrunblocked(α).Q[1,1]) ≈ one(eltyb)
            end

            for (a, b) in ((raw_a, raw_b),
                (view(raw_a, 1:n-1, 1:n-1), view(raw_b, 1:n-1, 1)))
                a_1 = size(a, 1)
                @testset "QR decomposition (without pivoting)" begin
                    qra   = @inferred qrunblocked(a)
                    @inferred qrunblocked(a)
                    q, r = qra.Q, qra.R
                    @test_throws FieldError qra.Z
                    @test q[1,1] ≈ Matrix(q)[1,1]
                    @test q[1:2,1:2] ≈ Matrix(q)[1:2,1:2]
                    @test q'*squareQ(q) ≈ Matrix(I, a_1, a_1)
                    @test q*squareQ(q)' ≈ Matrix(I, a_1, a_1)
                    @test q'*Matrix(1.0I, a_1, a_1)' ≈ squareQ(q)'
                    @test squareQ(q)'q ≈ Matrix(I, a_1, a_1)
                    @test Matrix(1.0I, a_1, a_1)'q' ≈ squareQ(q)'
                    @test q*r ≈ a
                    @test a*(qra\b) ≈ b atol=5000ε
                    @test Array(qra) ≈ a
                    sq = size(q.factors, 2)
                    @test *(Matrix{eltyb}(I, sq, sq), adjoint(q)) * squareQ(q) ≈ Matrix(I, sq, sq) atol=5000ε
                    if eltya != Int
                        @test Matrix{eltyb}(I, a_1, a_1)*q ≈ squareQ(convert(LinearAlgebra.AbstractQ{tab}, q))
                        ac = copy(a)
                        @test qrunblocked!(a[:, 1:5])\b == qrunblocked!(view(ac, :, 1:5))\b
                    end
                    qrstring = sprint((t, s) -> show(t, "text/plain", s), qra)
                    rstring  = sprint((t, s) -> show(t, "text/plain", s), r)
                    qstring  = sprint((t, s) -> show(t, "text/plain", s), q)
                    @test qrstring == "$(summary(qra))\nQ factor:\n$qstring\nR factor:\n$rstring"
                end
                @testset "Thin QR decomposition (without pivoting)" begin
                    qra   = @inferred qrunblocked(a[:, 1:n1], Val(false))
                    @inferred qrunblocked(a[:, 1:n1], Val(false))
                    q,r   = qra.Q, qra.R
                    @test_throws FieldError qra.Z
                    @test q[1,1] ≈ Matrix(q)[1,1]
                    @test q[1:2,1:2] ≈ Matrix(q)[1:2,1:2]
                    @test q'*squareQ(q) ≈ Matrix(I, a_1, a_1)
                    @test q'*rectangularQ(q) ≈ Matrix(I, a_1, n1)
                    @test q*r ≈ a[:, 1:n1]
                    @test q*b[1:n1] ≈ rectangularQ(q)*b[1:n1] atol=100ε
                    @test q*b ≈ squareQ(q)*b atol=100ε
                    @test_throws DimensionMismatch q*b[1:n1 + 1]
                    @test_throws DimensionMismatch b[1:n1 + 1]*q'
                    sq = size(q.factors, 1)
                    @test *(LowerTriangular(Matrix{eltyb}(I, sq, sq)), adjoint(q))*squareQ(q) ≈ Matrix(I, a_1, a_1) atol=5000ε
                    if eltya != Int
                        @test Matrix{eltyb}(I, a_1, a_1)*q ≈ squareQ(convert(LinearAlgebra.AbstractQ{tab}, q))
                    end
                end
            end
            if eltya != Int
                @testset "Matmul with QR factorizations" begin
                    a = raw_a

                    qra = qrunblocked(a[:,1:n1], Val(false))
                    q, r = qra.Q, qra.R
                    @test q[1,1] ≈ Matrix(q)[1,1]
                    @test q[1:2,1:2] ≈ Matrix(q)[1:2,1:2]
                    @test rmul!(copy(squareQ(q)'), q) ≈ Matrix(I, n, n)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n+1, n+1),q)
                    @test rmul!(squareQ(q), adjoint(q)) ≈ Matrix(I, n, n)
                    @test_throws DimensionMismatch rmul!(Matrix{eltya}(I, n+1, n+1),adjoint(q))
                    @test_throws ErrorException size(q,-1)
                    @test_throws DimensionMismatch q * Matrix{Int8}(I, n+4, n+4)
                end
            end
        end
    end 

    @testset "Issue 7304" begin
        A = [-√.5 -√.5; -√.5 √.5]
        Q = rectangularQ(qrunblocked(A).Q)
        @test norm(A-Q) < eps()
    end

    @testset "qrunblocked on AbstractVector" begin
        vl = [3.0, 4.0]
        for Tl in (Float32, Float64)
            for T in (Tl, Complex{Tl})
                v = convert(Vector{T}, vl)
                nv, nm = qrunblocked(v)
                @test nv*nm ≈ v
            end
        end
    end

    @testset "Issue 24589. Promotion of rational matrices" begin
        A = rand(1//1:5//5, 4,3)
        @test Matrix(first(qrunblocked(A))) == Matrix(first(qrunblocked(float(A))))
    end

    @testset "Issue Test Factorization fallbacks for rectangular problems" begin
        A  = randn(3,2)
        Ac = copy(A')
        b  = randn(3)
        b0 = copy(b)
        c  = randn(2)
        @test A \b ≈ ldiv!(c, qrunblocked(A ), b)
    end

    @testset "Wide QR" begin
        A = randn(3,5)
        Q,R = qrunblocked(A)
        @test Q*R ≈ A
    end

    @testset "lmul!/rmul!" begin
        A = randn(100,100)
        Q,R = qrunblocked(A)
        x = randn(100)
        b = randn(100,2)
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100)
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')

        A = randn(100,103)
        Q,R = qrunblocked(A)
        x = randn(100)
        b = randn(100,2)
        @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
        @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
        @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
        @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
        c = randn(2,100)
        @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
        @test rmul!(copy(c), Q') ≈ c*Matrix(Q')
    end

    @testset "LinearAlgebra.QR -> MatrixFactorizations.QR" begin
        A = randn(10,10)
        F̃ = LinearAlgebra.qrfactUnblocked!(copy(A))
        F = MatrixFactorizations.QR(F̃)
        Q,R = F
        @test Q*R ≈ A
        Q̃,_ = F̃
        @test MatrixFactorizations.QRPackedQ(Q̃)*R ≈ A
    end

    @testset "Ambiguity" begin
        A = randn(10,10)
        b = rand(10)
        B = randn(10,3)
        F = qrunblocked(A)
        @test ldiv!(F, MyVector(copy(b))) ≈ A \ b
        @test ldiv!(F, MyMatrix(copy(B))) ≈ A \ B
    end

    @testset "row/colsupport" begin
        n = 10
        B = Bidiagonal(randn(n), randn(n-1), :L)
        Q = qrunblocked(B)
        Q = MatrixFactorizations.QRPackedQ(Tridiagonal(Q.factors), Q.τ)
        @test rowsupport(Q, 4) ≡ colsupport(Q', 4) ≡ 3:10
        @test colsupport(Q, 4) ≡ rowsupport(Q', 4) ≡ Base.OneTo(5)
    end

    @testset "AbstractMatrix conversion" begin
        Q = qrunblocked(randn(5,5)).Q
        @test AbstractMatrix{Float64}(Q) isa Matrix{Float64}
    end
end

module BandedMatrixFactorizationTests
using MatrixFactorizations, LinearAlgebra, BandedMatrices, Test

@testset "QL tests" begin
    for T in (Float64,ComplexF64,Float32,ComplexF32)
        A=brand(T,10,10,3,2)
        Q,L=ql(A)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        @test Matrix(Q)*Matrix(L) ≈ A
        b=rand(T,10)
        @test mul!(similar(b),Q,mul!(similar(b),Q',b)) ≈ b
        for j=1:size(A,2)
            @test Q' * A[:,j] ≈ L[:,j]
        end

        A=brand(T,14,10,3,2)
        Q,L=ql(A)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        @test_broken Matrix(Q)*Matrix(L) ≈ A

        for k=1:size(A,1),j=1:size(A,2)
            @test Q[k,j] ≈ Matrix(Q)[k,j]
        end

        A=brand(T,10,14,3,2)
        Q,L=ql(A)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        @test Matrix(Q)*Matrix(L) ≈ A

        for k=1:size(Q,1),j=1:size(Q,2)
            @test Q[k,j] ≈ Matrix(Q)[k,j]
        end

        A=brand(T,10,14,3,6)
        Q,L=ql(A)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        @test Matrix(Q)*Matrix(L) ≈ A

        for k=1:size(Q,1),j=1:size(Q,2)
            @test Q[k,j] ≈ Matrix(Q)[k,j]
        end

        A=brand(T,100,100,3,4)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        b=rand(T,100)
        @test ql(A)\b ≈ Matrix(A)\b
        b=rand(T,100,2)
        @test ql(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch ql(A) \ randn(3)
        @test_throws DimensionMismatch ql(A).Q'randn(3)

        A=brand(T,102,100,3,4)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        b=rand(T,102)
        @test_broken ql(A)\b ≈ Matrix(A)\b
        b=rand(T,102,2)
        @test_broken ql(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch ql(A) \ randn(3)
        @test_throws DimensionMismatch ql(A).Q'randn(3)

        A=brand(T,100,102,3,4)
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        b=rand(T,100)
        @test_broken ql(A)\b ≈ Matrix(A)\b

        A = LinearAlgebra.Tridiagonal(randn(T,99), randn(T,100), randn(T,99))
        @test ql(A).factors ≈ ql!(Matrix(A)).factors
        @test ql(A).τ ≈ ql!(Matrix(A)).τ
        b=rand(T,100)
        @test ql(A)\b ≈ Matrix(A)\b
        b=rand(T,100,2)
        @test ql(A)\b ≈ Matrix(A)\b
        @test_throws DimensionMismatch ql(A) \ randn(3)
        @test_throws DimensionMismatch ql(A).Q'randn(3)
    end

    @testset "lmul!/rmul!" begin
        for T in (Float32, Float64, ComplexF32, ComplexF64)
            A = brand(T,100,100,3,4)
            Q,R = qr(A)
            x = randn(T,100)
            b = randn(T,100,2)
            @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
            @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
            @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
            @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
            c = randn(T,2,100)
            @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
            @test rmul!(copy(c), Q') ≈ c*Matrix(Q')

            A = brand(T,100,100,3,4)
            Q,L = ql(A)
            x = randn(T,100)
            b = randn(T,100,2)
            @test lmul!(Q, copy(x)) ≈ Matrix(Q)*x
            @test lmul!(Q, copy(b)) ≈ Matrix(Q)*b
            @test lmul!(Q', copy(x)) ≈ Matrix(Q)'*x
            @test lmul!(Q', copy(b)) ≈ Matrix(Q)'*b
            c = randn(T,2,100)
            @test rmul!(copy(c), Q) ≈ c*Matrix(Q)
            @test rmul!(copy(c), Q') ≈ c*Matrix(Q')
        end
    end

    @testset "Mixed types" begin
        A=brand(10,10,3,2)
        b=rand(ComplexF64,10)
        Q,L=ql(A)
        @test L\(Q'*b) ≈ ql(A)\b ≈ Matrix(A)\b
        @test Q*L ≈ A

        A=brand(ComplexF64,10,10,3,2)
        b=rand(10)
        Q,L=ql(A)
        @test Q*L ≈ A
        @test L\(Q'*b) ≈ ql(A)\b ≈ Matrix(A)\b

        A = BandedMatrix{Int}(undef, (2,1), (4,4))
        A.data .= 1:length(A.data)
        Q, L = ql(A)
        @test_broken Q*L ≈ A
    end

    @testset "bounds" begin
        A = brand(100,100,3,4)
        @test_throws DimensionMismatch ql(A) \ randn(50)
        @test_throws DimensionMismatch ldiv!(ql(A), randn(50))
        Q = ql(A).Q
        @test_throws DimensionMismatch lmul!(Q, randn(50))
        @test_throws DimensionMismatch lmul!(Q', randn(50))
        @test_throws DimensionMismatch rmul!(randn(50)', Q)
        @test_throws DimensionMismatch rmul!(randn(50)', Q')
    end
end
end

# This file is modifed from a part of Julia. License is MIT: https://julialang.org/license

using Test, LinearAlgebra, Random, MatrixFactorizations
using LinearAlgebra: BlasComplex, BlasFloat, BlasReal, QRPivoted,
    PosDefException, RankDeficientException, chkfullrank
using ArrayLayouts: Fill

function unary_ops_tests(a, ca, tol; n=size(a, 1))
    @test inv(ca)*a ≈ Matrix(I, n, n)
    @test a*inv(ca) ≈ Matrix(I, n, n)
    @test abs((det(ca) - det(a))/det(ca)) <= tol # Ad hoc, but statistically verified, revisit
    @test logdet(ca) ≈ logdet(a)
    @test logdet(ca) ≈ log(det(ca))  # logdet is less likely to overflow
    logabsdet_ca = logabsdet(ca)
    logabsdet_a = logabsdet(a)
    @test logabsdet_ca[1] ≈ logabsdet_a[1]
    @test logabsdet_ca[2] ≈ logabsdet_a[2]
    @test isposdef(ca)
    @test_throws FieldError ca.Z
    @test size(ca) == size(a)
    @test Array(copy(ca)) ≈ a
end

function factor_recreation_tests(a_U, a_L)
    c_U = reversecholesky(a_U)
    c_L = reversecholesky(a_L)
    cl  = c_L.U
    ls = c_L.L
    @test Array(c_U) ≈ Array(c_L) ≈ a_U
    @test ls'*ls ≈ a_U
    @test triu(c_U.factors) ≈ c_U.U
    @test tril(c_L.factors) ≈ c_L.L
    @test istriu(cl)
    @test cl*cl' ≈ a_U
    @test cl*cl' ≈ a_L
end

@testset "ReverseCholesky" begin
    @testset "core functionality" begin
        n = 10

        # Split n into 2 parts for tests needing two matrices
        n1 = div(n, 2)
        n2 = 2*n1

        Random.seed!(12344)

        areal = randn(n,n)/2
        aimg  = randn(n,n)/2
        a2real = randn(n,n)/2
        a2img  = randn(n,n)/2
        breal = randn(n,2)/2
        bimg  = randn(n,2)/2

        @testset "basic sanity check" begin
            A = [4 2; 2 4]
            U = reversecholesky(A).U
            @test U*U' ≈ A
            @test cholesky(A).L[end:-1:1,end:-1:1] ≈ U

            A = Symmetric(areal) + 10I
            U = reversecholesky(A).U
            @test U*U' ≈ A

            A = Hermitian(areal + im*aimg) + 10I
            U = reversecholesky(A).U
            @test U*U' ≈ A

            A = Symmetric(areal, :L) + 10I
            U = reversecholesky(A).U
            @test U*U' ≈ A

            A = Hermitian(areal + im*aimg, :L) + 10I
            U = reversecholesky(A).U
            @test U*U' ≈ A
        end

        for eltya in (Float32, Float64, ComplexF32, ComplexF64, BigFloat, Int)
            a = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
            a2 = eltya == Int ? rand(1:7, n, n) : convert(Matrix{eltya}, eltya <: Complex ? complex.(a2real, a2img) : a2real)

            ε = εa = eps(abs(float(one(eltya))))

            # Test of symmetric pos. def. strided matrix
            apd  = a'*a
            @inferred reversecholesky(apd)
            capd  = reversecholesky(apd)
            r     = capd.U
            κ     = cond(apd, 1) #condition number

            unary_ops_tests(apd, capd, ε*κ*n)
            if eltya != Int
                @test Factorization{eltya}(capd) === capd
                if eltya <: Real
                    @test Array(Factorization{complex(eltya)}(capd)) ≈ apd
                    @test eltype(Factorization{complex(eltya)}(capd)) == complex(eltya)
                end
            end
            @testset "throw for non-square input" begin
                A = rand(eltya, 2, 3)
                @test_throws DimensionMismatch reversecholesky(A)
                @test_throws DimensionMismatch reversecholesky!(A)
            end

            #Test error bound on reconstruction of matrix: LAWNS 14, Lemma 2.1

            #these tests were failing on 64-bit linux when inside the inner loop
            #for eltya = ComplexF32 and eltyb = Int. The E[i,j] had NaN32 elements
            #but only with Random.seed!(1234321) set before the loops.
            E = abs.(apd - r*r')
            for i=1:n, j=1:n
                @test E[i,j] <= (n+1)ε/(1-(n+1)ε)*real(sqrt(apd[i,i]*apd[j,j]))
            end
            E = abs.(apd - Matrix(capd))
            for i=1:n, j=1:n
                @test E[i,j] <= (n+1)ε/(1-(n+1)ε)*real(sqrt(apd[i,i]*apd[j,j]))
            end
            @test LinearAlgebra.issuccess(capd)
            @inferred(logdet(capd))

            apos = apd[1,1]
            @test all(x -> x ≈ √apos, cholesky(apos).factors)

            # Test cholesky with Symmetric/Hermitian upper/lower
            apds  = Symmetric(apd)
            apdsL = Symmetric(apd, :L)
            apdh  = Hermitian(apd)
            apdhL = Hermitian(apd, :L)
            if eltya <: Real
                capds = reversecholesky(apds)
                unary_ops_tests(apds, capds, ε*κ*n)
                if eltya <: BlasReal
                    capds = cholesky!(copy(apds))
                    unary_ops_tests(apds, capds, ε*κ*n)
                end
                ulstring = sprint((t, s) -> show(t, "text/plain", s), capds.UL)
                @test sprint((t, s) -> show(t, "text/plain", s), capds) == "$(typeof(capds))\nU factor:\n$ulstring"
            else
                capdh = reversecholesky(apdh)
                unary_ops_tests(apdh, capdh, ε*κ*n)
                capdh = reversecholesky!(copy(apdh))
                unary_ops_tests(apdh, capdh, ε*κ*n)
                capdh = reversecholesky!(copy(apd))
                unary_ops_tests(apd, capdh, ε*κ*n)
                ulstring = sprint((t, s) -> show(t, "text/plain", s), capdh.UL)
                @test sprint((t, s) -> show(t, "text/plain", s), capdh) == "$(typeof(capdh))\nU factor:\n$ulstring"
            end

            # test reversecholesky of 2x2 Strang matrix
            S = SymTridiagonal{eltya}([2, 2], [-1])
            for uplo in (:U, :L)
                @test Matrix(@inferred reversecholesky(Hermitian(S, uplo))) ≈ S
                if eltya <: Real
                    @test Matrix(@inferred reversecholesky(Symmetric(S, uplo))) ≈ S
                end
            end
            @test Matrix(reversecholesky(S).U) ≈ [sqrt(eltya(3)) -1; 0 2] / sqrt(eltya(2))
            @test Matrix(reversecholesky(S)) ≈ S

            # test extraction of factor and re-creating original matrix
            if eltya <: Real
                factor_recreation_tests(apds, apdsL)
            else
                factor_recreation_tests(apdh, apdhL)
            end



            for eltyb in (Float32, Float64, ComplexF32, ComplexF64, Int)
                b = eltyb == Int ? rand(1:5, n, 2) : convert(Matrix{eltyb}, eltyb <: Complex ? complex.(breal, bimg) : breal)
                εb = eps(abs(float(one(eltyb))))
                ε = max(εa,εb)

                for b in (b, view(b, 1:n, 1)) # Array and SubArray

                    # Test error bound on linear solver: LAWNS 14, Theorem 2.1
                    # This is a surprisingly loose bound
                    x = capd\b
                    @test norm(x-apd\b,1)/norm(x,1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                    @test norm(apd*x-b,1)/norm(b,1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ

                    @test norm(a*(capd\(a'*b)) - b,1)/norm(b,1) <= ε*κ*n # Ad hoc, revisit

                    if eltya != BigFloat && eltyb != BigFloat
                        lapd = reversecholesky(apdhL)
                        @test norm(apd * (lapd\b) - b)/norm(b) <= ε*κ*n
                        @test norm(apd * (lapd\b[1:n]) - b[1:n])/norm(b[1:n]) <= ε*κ*n
                    end
                end
            end

            for eltyb in (Float64, ComplexF64)
                Breal = convert(Matrix{BigFloat}, randn(n,n)/2)
                Bimg  = convert(Matrix{BigFloat}, randn(n,n)/2)
                B = (eltya <: Complex || eltyb <: Complex) ? complex.(Breal, Bimg) : Breal
                εb = eps(abs(float(one(eltyb))))
                ε = max(εa,εb)

                for B in (B, view(B, 1:n, 1:n)) # Array and SubArray

                    # Test error bound on linear solver: LAWNS 14, Theorem 2.1
                    # This is a surprisingly loose bound
                    BB = copy(B)
                    ldiv!(capd, BB)
                    @test norm(apd \ B - BB, 1) / norm(BB, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                    @test norm(apd * BB - B, 1) / norm(B, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                end
            end

            @testset "solve with generic Cholesky" begin
                Breal = convert(Matrix{BigFloat}, randn(n,n)/2)
                Bimg  = convert(Matrix{BigFloat}, randn(n,n)/2)
                B = eltya <: Complex ? complex.(Breal, Bimg) : Breal
                εb = eps(abs(float(one(eltype(B)))))
                ε = max(εa,εb)

                for B in (B, view(B, 1:n, 1:n)) # Array and SubArray

                    # Test error bound on linear solver: LAWNS 14, Theorem 2.1
                    # This is a surprisingly loose bound
                    cpapd = reversecholesky(eltya <: Complex ? apdh : apds)
                    BB = copy(B)
                    rdiv!(BB, cpapd)
                    @test norm(B / apd - BB, 1) / norm(BB, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                    @test norm(BB * apd - B, 1) / norm(B, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                    cpapd = reversecholesky(eltya <: Complex ? apdhL : apdsL)
                    BB = copy(B)
                    rdiv!(BB, cpapd)
                    @test norm(B / apd - BB, 1) / norm(BB, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                    @test norm(BB * apd - B, 1) / norm(B, 1) <= (3n^2 + n + n^3*ε)*ε/(1-(n+1)*ε)*κ
                end
            end
        end
    end

    @testset "behavior for non-positive definite matrices" for T in (Float64, ComplexF64)
        A = T[1 2; 2 1]
        B = T[1 2; 0 1]
        # check = (true|false)
        for M in (A, Hermitian(A), B)
            @test_throws PosDefException reversecholesky(M)
            @test_throws PosDefException reversecholesky!(copy(M))
            @test_throws PosDefException reversecholesky(M; check = true)
            @test_throws PosDefException reversecholesky!(copy(M); check = true)
            @test !LinearAlgebra.issuccess(reversecholesky(M; check = false))
            @test !LinearAlgebra.issuccess(reversecholesky!(copy(M); check = false))
        end
        str = sprint((io, x) -> show(io, "text/plain", x), reversecholesky(A; check = false))
    end

    @testset "Cholesky factor of Matrix with non-commutative elements, here 2x2-matrices" begin
        X = Matrix{Float64}[0.1*rand(2,2) for i in 1:3, j = 1:3]
        L = Matrix(MatrixFactorizations._reverse_chol!(X*X', LowerTriangular)[1])
        U = Matrix(MatrixFactorizations._reverse_chol!(X*X', UpperTriangular)[1])
        XX = Matrix(X*X')

        @test_broken sum(sum(norm, L'*L - XX)) < eps()
        @test_broken sum(sum(norm, U*U' - XX)) < eps()
    end

    @testset "Non-strided Cholesky solves" begin
        B = randn(5, 5)
        v = rand(5)
        @test reversecholesky(Diagonal(v)) \ B ≈ Diagonal(v) \ B
        @test B / reversecholesky(Diagonal(v)) ≈ B / Diagonal(v)
        @test inv(reversecholesky(Diagonal(v)))::Diagonal ≈ Diagonal(1 ./ v)
    end


    @testset "cholesky Diagonal" begin
        # real
        d = abs.(randn(3)) .+ 0.1
        D = Diagonal(d)
        CD = reversecholesky(D)
        CM = reversecholesky(Matrix(D))
        @test CD isa ReverseCholesky{Float64}
        @test CD.U ≈ Diagonal(.√d) ≈ CM.U
        @test D ≈ CD.L * CD.U
        @test CD.info == 0

        F = reversecholesky(Hermitian(I(3)))
        @test F isa ReverseCholesky{Float64,<:Diagonal}
        @test Matrix(F) ≈ I(3)

        # real, failing
        @test_throws PosDefException reversecholesky(Diagonal([1.0, -2.0]))
        Dnpd = reversecholesky(Diagonal([1.0, -2.0]); check = false)
        @test Dnpd.info == 1

        # complex
        D = complex(D)
        CD = reversecholesky(Hermitian(D))
        CM = reversecholesky(Matrix(Hermitian(D)))
        @test CD isa ReverseCholesky{ComplexF64,<:Diagonal}
        @test CD.U ≈ Diagonal(.√d) ≈ CM.U
        @test D ≈ CD.L * CD.U
        @test CD.info == 0

        # complex, failing
        D[2, 2] = 0.0 + 0im
        @test_throws PosDefException reversecholesky(D)        

        # InexactError for Int
        @test_throws InexactError reversecholesky!(Diagonal([2, 1]))
    end

    @testset "Cholesky for AbstractMatrix" begin
        S = SymTridiagonal(fill(2.0, 4), ones(3))
        C = reversecholesky(S)
        @test C.U * C.L ≈ S
    end

    @testset "constructor with non-BlasInt arguments" begin
        x = rand(5,5)
        chol = reversecholesky(x'x)

        factors, uplo, info = chol.factors, chol.uplo, chol.info

        @test ReverseCholesky(factors, uplo, Int32(info)) == chol
        @test ReverseCholesky(factors, uplo, Int64(info)) == chol
    end

    @testset "issue #37356, diagonal elements of hermitian generic matrix" begin
        B = Hermitian(hcat([one(BigFloat) + im]))
        @test Matrix(reversecholesky(B)) ≈ B
        C = Hermitian(hcat([one(BigFloat) + im]), :L)
        @test Matrix(reversecholesky(C)) ≈ C
    end

    @testset "constructing a ReverseCholesky factor from a triangular matrix" begin
        A = [1.0 2.0; 3.0 4.0]
        let
            U = UpperTriangular(A)
            C = ReverseCholesky(U)
            @test C isa ReverseCholesky{Float64}
            @test C.U == U
            @test C.L == U'
        end
        let
            L = LowerTriangular(A)
            C = ReverseCholesky(L)
            @test C isa ReverseCholesky{Float64}
            @test C.L == L
            @test C.U == L'
        end
    end

    @testset "adjoint of ReverseCholesky" begin
        A = randn(5, 5)
        A = A'A
        F = reversecholesky(A)
        b = ones(size(A, 1))
        @test F\b == F'\b
    end

    @testset "Float16" begin
        A = Float16[4. 12. -16.; 12. 37. -43.; -16. -43. 98.]
        B = reversecholesky(A)
        B32 = reversecholesky(Float32.(A))
        @test B isa ReverseCholesky{Float16, Matrix{Float16}}
        @test B.U isa UpperTriangular{Float16, Matrix{Float16}}
        @test B.L isa LowerTriangular{Float16, Matrix{Float16}}
        @test B.UL isa UpperTriangular{Float16, Matrix{Float16}}
        @test B.U ≈ B32.U
        @test B.L ≈ B32.L
        @test B.UL ≈ B32.UL
        @test Matrix(B) ≈ A
    end

    @testset "large Sparse" begin
        n = 1_000_000
        A = SymTridiagonal(fill(4,n), fill(1,n-1))
        R = reversecholesky(A)
        @test R isa ReverseCholesky{Float64, <:Bidiagonal}
        @test R.U isa Bidiagonal
        @test R.L isa Bidiagonal
        @test R.UL isa Bidiagonal
        # Bidiagonal multiplication not supported
        @test R.U*(R.U' * [1; zeros(n-1)]) ≈ A[:,1]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[:,1]

        A = Tridiagonal(fill(1.0,n-1), fill(4.0,n), fill(1/2,n-1))
        R = reversecholesky(Symmetric(A))
        @test R.U*(R.U' * [1; zeros(n-1)]) ≈ A[1,:]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[1,:]
        R = reversecholesky(Symmetric(A,:L))
        @test R.U*(R.U' * [1; zeros(n-1)]) ≈ A[:,1]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[:,1]

        A = Bidiagonal(fill(4.0,n), fill(1.0,n-1), :U)
        R = reversecholesky(Symmetric(A))
        @test R.U*(R.U' * [1; zeros(n-1)]) ≈ A[1,:]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[1,:]

        A = Bidiagonal(fill(4.0,n), fill(1.0,n-1), :L)
        R = reversecholesky(Symmetric(A,:L))
        @test R.U * (R.U' * [1; zeros(n-1)]) ≈ A[:,1]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[:,1]

        A = Bidiagonal(fill(4,n), fill(1,n-1), :L)
        R = reversecholesky(Symmetric(A,:L))
        @test R.U * (R.U' * [1; zeros(n-1)]) ≈ A[:,1]
        @test R.L'*(R.L * [1; zeros(n-1)]) ≈ A[:,1]
    end

    @testset "coverage" begin
        A = [4 2; 2 4]
        R = reversecholesky(A)
        @test ReverseCholesky(R.factors, R.uplo, R.info) == R
        U,L = R
        @test U*U' ≈ A
        @test reversecholesky(5).U[1,1] ≈ sqrt(5)
        @test propertynames(R) == (:U, :L, :UL)
    end

    @testset "Lazy reversecholesky" begin
        A = SymTridiagonal(Fill(2,10), Fill(1,9))
        @test reversecholesky(A) == reversecholesky(SymTridiagonal(fill(2.0,10), fill(1.0,9))) == 
                reversecholesky(Symmetric(Bidiagonal(Fill(2,10), Fill(1,9), :U))) ==
                reversecholesky(Symmetric(Tridiagonal(Fill(3,9), Fill(2,10), Fill(1,9))))
    end
end

using MatrixFactorizations, LinearAlgebra, Random, ArrayLayouts, Test
using LinearAlgebra: BlasComplex, BlasFloat, BlasReal, rmul!, lmul!, require_one_based_indexing, checksquare
using MatrixFactorizations: QRCompactWYQLayout, AbstractQtype

if VERSION < v"1.12-"
    const FieldError = ErrorException
end

struct MyMatrix <: LayoutMatrix{Float64}
    A::Matrix{Float64}
end

Base.elsize(::Type{MyMatrix}) = sizeof(Float64)
Base.getindex(A::MyMatrix, k::Int, j::Int) = A.A[k,j]
Base.setindex!(A::MyMatrix, v, k::Int, j::Int) = setindex!(A.A, v, k, j)
Base.size(A::MyMatrix) = size(A.A)
Base.strides(A::MyMatrix) = strides(A.A)
Base.unsafe_convert(::Type{Ptr{T}}, A::MyMatrix) where T = Base.unsafe_convert(Ptr{T}, A.A)
ArrayLayouts.MemoryLayout(::Type{MyMatrix}) = DenseColumnMajor()

struct MyVector <: LayoutVector{Float64}
    A::Vector{Float64}
end

Base.elsize(::Type{MyVector}) = sizeof(Float64)
Base.getindex(A::MyVector, k::Int) = A.A[k]
Base.setindex!(A::MyVector, v, k::Int) = setindex!(A.A, v, k)
Base.size(A::MyVector) = size(A.A)
Base.strides(A::MyVector) = strides(A.A)
Base.unsafe_convert(::Type{Ptr{T}}, A::MyVector) where T = Base.unsafe_convert(Ptr{T}, A.A)
ArrayLayouts.MemoryLayout(::Type{MyVector}) = DenseColumnMajor()

include("test_ul.jl")
include("test_qr.jl")
include("test_ql.jl")
include("test_rq.jl")
include("test_polar.jl")
include("test_reversecholesky.jl")
include("test_lulinv.jl")
include("test_jordan.jl")

include("test_banded.jl")

using LinearAlgebra, MatrixFactorizations, Random, Test

@testset "Jordan Canonical Form" begin
    Random.seed!(0)
    V = rand(-3:3//1, 5, 5)
    λ = [1; 1; 1; -2; -2//1]
    J = diagm(0 => λ)
    J[1, 2] = 1
    #J[3, 4] = 1
    J[4, 5] = 1
    A = V*J/V
    F = lulinv(A, λ)
    L, U, p = F.L, F.U, F.p
    @test A[p, p] ≈ L*U/L
    E, R = MatrixFactorizations.triangular_to_psychologically_block_diagonal(UpperTriangular(U))
    @test U ≈ E*R/E
    P, B = MatrixFactorizations.psychologically_block_diagonal_to_block_diagonal(R)
    @test R ≈ P*B*P'
    EP, B = MatrixFactorizations.triangular_to_block_diagonal(UpperTriangular(U))
    @test U ≈ EP*B/EP
    PLEP, B = MatrixFactorizations.block_diagonalize(A, λ)
    @test A ≈ PLEP*B/PLEP

    @testset "Block sizes" begin
        import MatrixFactorizations: determine_block_sizes
        m = determine_block_sizes([1;;])
        @test m == [1]
        m = determine_block_sizes([1 2; 3 4])
        @test m == [1, 1]
        m = determine_block_sizes([1 2; 3 1])
        @test m == [2]
        m = determine_block_sizes([1 2 3;0 1 4; 0 0 1])
        @test m == [3]
        m = determine_block_sizes([1 2 3;0 2 4; 0 0 2])
        @test m == [1, 2]
        m = determine_block_sizes([2 2 3;0 2 4; 0 0 1])
        @test m == [2, 1]
        m = determine_block_sizes([1 2 3;0 2 4; 0 0 3])
        @test m == [1, 1, 1]
        m = determine_block_sizes([1 2 3 4;0 2 5 6; 0 0 3 7; 0 0 0 4])
        @test m == [1, 1, 1, 1]
        m = determine_block_sizes([1 2 3 4;0 2 5 6; 0 0 3 7; 0 0 0 3])
        @test m == [1, 1, 2]
        m = determine_block_sizes([1 2 3 4;0 2 5 6; 0 0 2 7; 0 0 0 3])
        @test m == [1, 2, 1]
        m = determine_block_sizes([1 2 3 4;0 3 5 6; 0 0 3 7; 0 0 0 3])
        @test m == [1, 3]
        m = determine_block_sizes([3 2 3 4;0 3 5 6; 0 0 3 7; 0 0 0 3])
        @test m == [4]
        m = determine_block_sizes([1 2 3 4;0 1 5 6; 0 0 3 7; 0 0 0 4])
        @test m == [2, 1, 1]
        m = determine_block_sizes([1 2 3 4;0 1 5 6; 0 0 3 7; 0 0 0 3])
        @test m == [2, 2]
        m = determine_block_sizes([1 2 3 4;0 1 5 6; 0 0 1 7; 0 0 0 3])
        @test m == [3, 1]
        m = determine_block_sizes(UpperTriangular([1 2 3 4;0 1 5 6; 0 0 1 7; 0 0 0 3]))
        @test m == [3, 1]
        Random.seed!(0)
        m = determine_block_sizes(rand(0:1, 10, 10))
        @test m == [1, 2, 2, 2, 1, 1, 1]
        m = determine_block_sizes(rand(0:1, 20, 20))
        @test m == [1, 3, 4, 6, 2, 2, 1, 1]
    end

    @testset "Upper triangular block to Jordan blocks" begin
        import MatrixFactorizations: upper_triangular_block_to_jordan_blocks
        Random.seed!(0)
        B = diagm(0 => 3//1*ones(Int, 12), 1 => [1,1,0,1,1,0,1,0,1,1,0]) + rand(-3:3, 12)*[zeros(Int,11); 1]'; B[end] = 3; B
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = diagm(0 => 4//1*ones(Int, 12)) + triu!(rand(-4:4, 12, 12), 1)
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = diagm(0 => 4//1*ones(Int, 12)) + triu!(rand(-4:4, 12, 12), 1)
        B = Rational{BigInt}.(B)
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = diagm(0 => 4//1*ones(Int, 12)) + triu!(rand(-4:4, 12, 12), 1)
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = [2 1 2; 0 2 1; 0 0 2//1]
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = [2 1 4 0; 0 2 1 0; 0 0 2 0; 0 0 0 2//1]
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        B = [2 1 4 0; 0 2 1 -1; 0 0 2 1; 0 0 0 2//1]
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F

        F = Matrix{Rational{Int}}(triu!(rand(1:4, 12, 12)))
        J = diagm(0 => 4//1*ones(Int, 12), 1 => rand(0:1, 11))
        B = Matrix{Rational{BigInt}}(F*J/F)
        F, J = upper_triangular_block_to_jordan_blocks(B)
        @test B ≈ F*J/F
    end

    @testset "JCF" begin
        Random.seed!(0)
        for _ in 1:10
            V = rand(-3:3//1, 8, 8)
            J1 = diagm(0 => 1//1*ones(Int, 4), 1 => rand(0:1, 3))
            J2 = diagm(0 => -1//1*ones(Int, 4), 1 => rand(0:1, 3))
            J = [J1 zeros(Rational{Int}, size(J1)); zeros(Rational{Int}, size(J2)) J2]
            λ = diag(J)
            A = V*J/V
            V, J = jordan(A, λ)
            @test A*V ≈ V*J
        end
    end

    @testset "Jordan canonical forms in the wild" begin
        @testset "https://en.wikipedia.org/wiki/Jordan_normal_form" begin
            A = [5 4 2 1; 0 1 -1 -1; -1 -1 3 0; 1 1 -1 2//1]
            λ = [1, 2, 4, 4//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
            # Next step in this code would be to completely elucidate the block structure in J:
            #JCF = BlockArrays.BlockDiagonal([JordanBlock(1//1, 1), JordanBlock(2//1, 1), JordanBlock(4//1, 2)])
            #@test J == JCF
        end
        @testset "https://math.stackexchange.com/questions/1221465/jordan-canonical-form-deployment" begin
            A = [-3 1 0 1 1; -3 1 0 1 1; -4 1 0 2 1; -3 1 0 1 1; -4 1 0 1 2//1]
            λ = [0, 0, 0, 0, 1//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://math.stackexchange.com/questions/3627150/find-the-jordan-form" begin
            A = [-83 -15 -68 -2 -100 216; -3 1 -2 0 -4 9; 42 7 35 1 50 -108; 43 8 35 3 50 -108; 22 4 18 1 27 -54; -10 -2 -8 0 -12 28//1]
            λ = [1, 2, 2, 2, 2, 2//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.maplesoft.com/applications/preview.aspx?id=33195" begin
            A = [-10 -13 15 -16 6 9 -3; 4 5 -6 7 -2 -4 1; -50 -60 72 -77 29 43 -13; -82 -98 118 -127 47 71 -21; 2 1 -2 2 -1 -1 0; -56 -66 80 -86 32 48 -14; 48 59 -70 75 -28 -42 13//1]
            λ = zeros(Rational{Int}, 7)
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://askfilo.com/user-question-answers-smart-solutions/find-the-jordan-canonical-form-j-for-the-matrix-also-find-a-3337353836383137" begin
            A = [-1 0 -2 -4; 2 1 2 4; -4 2 -1 -4; 2 -1 1 3//1]
            λ = [-1, 1, 1, 1//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.bartleby.com/questions-and-answers/1.-find-the-jordan-canonical-form-for-the-following-matrices.-0-0-0-0-1-2-0-4-a.-v-2.-1.-1-2-0.-0-0-/2193cc71-c370-45ea-bfed-d5cfe17c8946" begin
            B = [0 1 0 0; -3 4 0 0; 2 -1 2 0; -1 1 1 2//1]
            λ = [1, 2, 2, 3//1]
            V, J = jordan(B, λ)
            @test B*V == V*J
            A = [1 0 0 0 0; 1 -1 0 0 -1; 1 -1 0 0 -1; 0 0 0 0 -1; -1 1 0 0 1//1]
            λ = [0, 0, 0, 0, 1//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "http://buzzard.ups.edu/courses/2014spring/420demos/JCF-demo.pdf" begin
            A = Rational{BigInt}[50 -10 17 -21 7 6 1 -37 -8 -10 10 -14 27 39 8;
                 186 -207 -36 -184 -74 -71 -54 -22 -1 -93 38 -11 56 187 14;
                 3 16 9 -10 -11 8 -4 -24 4 -6 2 -14 13 6 -2;
                 -132 202 62 162 83 77 58 -23 -14 86 -28 -4 -22 -149 -3;
                 213 -237 -41 -218 -94 -82 -65 -30 2 -111 45 -16 69 216 13;
                 -608 549 27 552 195 173 139 178 34 266 -124 72 -239 -574 -57;
                 253 -299 -57 -274 -125 -108 -83 -26 3 -137 52 -15 79 258 15;
                 -196 175 0 170 50 56 38 58 21 76 -38 18 -76 -176 -23;
                 704 -651 -40 -649 -233 -206 -167 -197 -35 -313 143 -80 272 668 64;
                 322 -238 25 -251 -53 -62 -51 -126 -39 -112 62 -43 139 283 42;
                 -536 411 -28 449 129 115 98 211 52 207 -105 79 -236 -482 -61;
                 170 -190 -25 -165 -58 -67 -45 -20 -11 -77 32 -4 51 163 17;
                 1 14 9 10 9 7 6 -7 -4 5 0 -1 7 -4 1;
                 223 -195 -1 -201 -64 -61 -49 -71 -20 -92 43 -26 91 206 25;
                 -58 4 -27 29 -7 -10 1 53 12 12 -11 20 -39 -45 -10]
            λ = Rational{BigInt}[-ones(5); 2*ones(10)]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "http://matrix.skku.ac.kr/2014-Album/JCF/2GEV_JCF_u_GEV.htm" begin
            A = [0 0 1 7 -1; -5 -6 -6 -35 5; 1 1 -7 7 -1; 0 0 0 -9 0; 2 1 -5 -42 -3//1]
            λ = [-9, -7, -7, -1, -1//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.numerade.com/ask/question/1-find-a-jordan-canonical-form-of-the-following-matrix-4-1-0-0-a-h4ih-1-28093/" begin
            A = [4 1 0 0 0; -1 3 1 0 0; 1 0 2 0 0; -2 -1 -1 2 1; 1 0 0 0 2//1]
            λ = [2, 2, 3, 3, 3//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.chegg.com/homework-help/questions-and-answers/3-find-jordan-canonical-form-j-following-matrices-determine-matrix-x-xax-j-11-0-1-1-2-0-0--q25805340" begin
            A = [1 0 1; 1 0 2; 1 -1 2]
            λ = [1, 1, 1]
            V, J = jordan(A, λ)
            @test A*V == V*J
            A = [0 0 0 1; 0 0 0 1; 1 2 0 0; 0 0 0 -1.0]
            V, J = jordan(A)
            @test A*V ≈ V*J
            A = [1 2 0 0; 0 1 2 0; 0 0 1 2; 0 0 0 1//1]
            λ = diag(A) # because A is upper triangular
            V, J = jordan(A, λ)
            @test A*V == V*J
            A = [1 1 1 1 1; 0 1 1 1 1; 0 0 1 1 1; 0 0 0 0 1; 0 0 0 0 0//1]
            λ = diag(A) # because A is upper triangular
            V, J = jordan(A, λ)
            @test A*V == V*J
            A = [2 1 1 1 1 1; 0 2 1 1 1 1; 0 0 0 1 1 1; 0 0 0 0 1 1; 0 0 0 0 1 1; 0 0 0 0 1 1//1]
            λ = Rational{Int}.(eigvals(A))
            @test λ ≈ eigvals(A)
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.chegg.com/homework-help/questions-and-answers/solve-using-matlab-find-jordan-canonical-form-b-determine-matrix-diagonalizable-find-simil-q46775702" begin
            A = [0 1 -1 2 1 -1; -4 3 -1 3 1 0; 0 1 1 3 -1 -2; 0 1 -1 4 0 -2; 0 1 -1 2 2 -2; -1 1 -1 2 1 0//1]
            λ = [1, 1, 2, 2, 2, 2//1]
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
        @testset "https://www.chegg.com/homework-help/questions-and-answers/question-2-calculate-jordan-canonical-form-matrix-0-0-0-2-0-0-0-2-0-0-2-1-0-0-1-0-1-1-1-1--q58058571" begin
            A = [2 0 0 0 0 0; 0 2 0 0 0 0; 1 0 2 0 0 0; -1 0 0 -3 0 0; -1 0 1 1 -3 0; -1 1 -1 1 -1 -3//1]
            λ = diag(A) # because A is lower triangular
            V, J = jordan(A, λ)
            @test A*V == V*J
        end
    end

    @testset "REPL printing" begin
            bf = IOBuffer()
            show(bf, "text/plain", jordan([1 0; 0 1]))
            seekstart(bf)
            @test String(take!(bf)) ==
"""
Jordan{Float64, Matrix{Float64}, Matrix{Float64}}
Generalized eigenvectors:
2×2 Matrix{Float64}:
 0.0  1.0
 1.0  0.0
Jordan normal form:
2×2 Matrix{Float64}:
 1.0  0.0
 0.0  1.0"""
    end

    @testset "propertynames" begin
        names = sort!(collect(string.(Base.propertynames(jordan([2 1; 1 2])))))
        @test names == ["J", "V"]
        allnames = sort!(collect(string.(Base.propertynames(jordan([2 1; 1 2]), true))))
        @test allnames == ["J", "V"]
    end

    @testset "Mixed input types, conversion" begin
        A = [0 0 1 7 -1; -5 -6 -6 -35 5; 1 1 -7 7 -1; 0 0 0 -9 0; 2 1 -5 -42 -3//1]
        λ = [-9, -7, -7, -1, -1]
        V, J = jordan(A, λ)
        @test A*V == V*J
        A = [0 0 1 7 -1; -5 -6 -6 -35 5; 1 1 -7 7 -1; 0 0 0 -9 0; 2 1 -5 -42 -3]
        λ = [-9, -7, -7, -1, -1//1]
        V, J = jordan(A, λ)
        @test A*V == V*J
        F = jordan(A, λ)
        G = Jordan{Float64}(F)
        @test A*G.V ≈ G.V*G.J
    end
end

@testset "Polar Decomposition" begin

Random.seed!(1103)

# For each variant, decomposing A to U, H, verify:
# U is unitary
# H is hermitian and positive semi-definite
# backward error is small

for T in [Float64, Complex{Float64}]
    @testset "Newton $T" begin
        for n in [1,3,10]
            A = rand(T,n,n)
            U,H = polar(A, alg = :newton)
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H

            # also check the properties here (once should suffice)
            r = polar(A, alg = :newton)
            @test U == r.U
            @test H == r.H

            r = polar(A, alg = :newton, verbose = true)
            @test U == r.U
            @test H == r.H

            m = n + 2
            A = rand(T,m,n)
            U,H = polar(A, alg = :newton)
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H
        end
        A = rand(T,5,7)
        @test_throws ArgumentError U,H = polar(A, alg = :newton)
    end
end

for T in [Float64, Complex{Float64}]
    @testset "Halley $T" begin
        for n in [1,3,10]
            A = rand(T, n, n)
            r = polar(A, alg = :halley)
            U = r.U
            H = r.H
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H
        end
    end

    @testset "QDWH $T" begin
      for m in [1,3,10]
        B = rand(T, m, m)
        U2,H2 = polar(B, alg = :qdwh)
        @test U2'*U2 ≈ Matrix(I,m,m) atol=1e-7
        @test ishermitian(H2)
        for i in eigvals(H2)
            @test i >= 0.
        end
        @test B ≈ U2*H2
      end
    end
end

for T in [Float64, Complex{Float64}]
    @testset "SVD $T" begin
        for n in [1,3,10]
            m = n + rand(0:5)
            A = rand(T, m, n)
            U,H = polar(A, alg = :svd)
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H
        end
    end
end

for T in [Float64, Complex{Float64}]
    @testset "Newton-Schulz $T" begin
        for n in [1,3,10]
            m = n
            A = rand(T, m, n)
            nA = opnorm(A)
            A = (1.5 / nA) * A
            U,H = polar(A, alg = :schulz)
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H
        end
    end
end

for T in [Float64, Complex{Float64}]
    @testset "Hybrid $T" begin
        for n in [1,3,10]
            A = rand(T,n,n)
            U,H = polar(A, alg =:hybrid)
            @test U'*U ≈ Matrix(I,n,n) atol=1e-7
            @test ishermitian(H)
            for i in eigvals(H)
                @test i >= 0.
            end
            @test A ≈ U*H atol=1e-7
        end
    end
end

@testset "Float32" begin
    for n in [1,3,10]
        A = Array{Float32}(undef, n, n)
        copyto!(A, rand(n,n))

        r1 = polar(A, alg =:newton)
        r2 = polar(A, alg =:qdwh)
        r3 = polar(A, alg =:halley)
        r4 = polar(A, alg =:svd)
        r5 = polar(A, alg =:hybrid)

        @test r1.U ≈ r2.U
        @test r2.U ≈ r3.U
        @test r3.U ≈ r4.U
        @test r4.U ≈ r5.U
    end
end


end
